/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Specifies the group of the axis, i.e., whether it is a primary
 * or secondary axis.
 */
export var AxisGroup = /*@__PURE__*/ (function (AxisGroup) {
    /**
     * Primary axis group.
     */
    AxisGroup[AxisGroup["Primary"] = 1] = "Primary";
    /**
     * Secondary axis group. Invalid for [[AxisType.seriesAxis]] in 3D charts
     */
    AxisGroup[AxisGroup["Secondary"] = 2] = "Secondary";
    return AxisGroup;
})({});
/**
 * @hidden
 */
export let AxisGroup_$type = markEnum('AxisGroup', 'Primary,1|Secondary,2');
