/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, markType, getInstanceType } from "igniteui-angular-core";
import { ISupportSetProperty_$type } from "./ISupportSetProperty";
import { CT_BaseStyles } from "./CT_BaseStyles";
import { CT_ColorMapping } from "./CT_ColorMapping";
/**
 * @hidden
 */
export let CT_ClipboardStyleSheet = /*@__PURE__*/ (() => {
    class CT_ClipboardStyleSheet extends Base {
        constructor() {
            super();
            this.b = null;
            this.d = null;
        }
        get a() {
            return this.b;
        }
        set a(a) {
            this.b = a;
        }
        get c() {
            return this.d;
        }
        set c(a) {
            this.d = a;
        }
        setProperty(a, b) {
            switch (a) {
                case 1717:
                    this.a = typeCast(CT_BaseStyles.$, b);
                    break;
                case 282:
                    this.c = typeCast(CT_ColorMapping.$, b);
                    break;
                default: break;
            }
        }
        toString() {
            let a = getInstanceType(this);
            return a != null ? a.typeName : super.toString();
        }
    }
    CT_ClipboardStyleSheet.$t = markType(CT_ClipboardStyleSheet, 'CT_ClipboardStyleSheet', Base.$, [ISupportSetProperty_$type]);
    return CT_ClipboardStyleSheet;
})();
