/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, toNullable, Boolean_$type, fromEnum, markType } from "igniteui-angular-core";
import { ST_IconSetType_$type } from "./ST_IconSetType";
import { XmlNamespaceDefinitionBase } from "./XmlNamespaceDefinitionBase";
import { ST_OnOff } from "./ST_OnOff";
/**
 * @hidden
 */
export let CT_IconSet_SML2009 = /*@__PURE__*/ (() => {
    class CT_IconSet_SML2009 extends Base {
        constructor() {
            super();
            this.h = null;
            this.f = null;
            this.l = toNullable(ST_IconSetType_$type, null);
            this.r = toNullable(Boolean_$type, null);
            this.n = toNullable(Boolean_$type, null);
            this.p = toNullable(Boolean_$type, null);
            this.j = toNullable(Boolean_$type, null);
        }
        get g() {
            return this.h;
        }
        set g(a) {
            this.h = a;
        }
        get e() {
            return this.f;
        }
        set e(a) {
            this.f = a;
        }
        get k() {
            return this.l;
        }
        set k(a) {
            this.l = a;
        }
        get q() {
            return this.r;
        }
        set q(a) {
            this.r = a;
        }
        get m() {
            return this.n;
        }
        set m(a) {
            this.n = a;
        }
        get o() {
            return this.p;
        }
        set o(a) {
            this.p = a;
        }
        get i() {
            return this.j;
        }
        set i(a) {
            this.j = a;
        }
        static s(a, b, c, d, e, f) {
            b = toNullable(ST_IconSetType_$type, null);
            c = toNullable(Boolean_$type, null);
            d = toNullable(Boolean_$type, null);
            e = toNullable(Boolean_$type, null);
            f = toNullable(Boolean_$type, null);
            for (let g of fromEnum(a.ab.u)) {
                switch (g.a.e(a.d)) {
                    case "iconSet":
                        b = toNullable(ST_IconSetType_$type, XmlNamespaceDefinitionBase.b(ST_IconSetType_$type, g.d));
                        break;
                    case "showValue":
                        c = toNullable(Boolean_$type, ST_OnOff.e(g.d));
                        break;
                    case "percent":
                        d = toNullable(Boolean_$type, ST_OnOff.e(g.d));
                        break;
                    case "reverse":
                        e = toNullable(Boolean_$type, ST_OnOff.e(g.d));
                        break;
                    case "custom":
                        f = toNullable(Boolean_$type, ST_OnOff.e(g.d));
                        break;
                    default: break;
                }
            }
            ;
            return {
                p1: b,
                p2: c,
                p3: d,
                p4: e,
                p5: f
            };
        }
        static t(a, b, c = toNullable(Boolean_$type, null), d = toNullable(ST_IconSetType_$type, null), e = toNullable(Boolean_$type, null), f = toNullable(Boolean_$type, null), g = toNullable(Boolean_$type, null)) {
            a.ad.p(b, null);
            let h = null;
            let i = null;
            if (c.hasValue) {
                i = "custom";
                h = ST_OnOff.g(c.value);
                a.ad.h(i, h);
            }
            if (d.hasValue) {
                i = "iconSet";
                h = XmlNamespaceDefinitionBase.f(ST_IconSetType_$type, d.value);
                a.ad.h(i, h);
            }
            if (e.hasValue) {
                i = "percent";
                h = ST_OnOff.g(e.value);
                a.ad.h(i, h);
            }
            if (f.hasValue) {
                i = "reverse";
                h = ST_OnOff.g(f.value);
                a.ad.h(i, h);
            }
            if (g.hasValue) {
                i = "showValue";
                h = ST_OnOff.g(g.value);
                a.ad.h(i, h);
            }
            ;
        }
    }
    CT_IconSet_SML2009.$t = markType(CT_IconSet_SML2009, 'CT_IconSet_SML2009');
    return CT_IconSet_SML2009;
})();
