/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, toNullable, Number_$type, fromEnum, markType, getInstanceType } from "igniteui-angular-core";
import { ST_MarkerStyle_$type } from "./ST_MarkerStyle";
import { XmlNamespaceDefinitionBase } from "./XmlNamespaceDefinitionBase";
import { CultureInfo } from "igniteui-angular-core";
import { parseUInt8_1 } from "igniteui-angular-core";
/**
 * @hidden
 */
export let CT_MarkerLayout = /*@__PURE__*/ (() => {
    class CT_MarkerLayout extends Base {
        constructor() {
            super(...arguments);
            this.d = toNullable(ST_MarkerStyle_$type, null);
            this.b = toNullable(Number_$type, null);
        }
        get c() {
            return this.d;
        }
        set c(a) {
            this.d = a;
        }
        get a() {
            return this.b;
        }
        set a(a) {
            this.b = a;
        }
        static f(a, b, c) {
            b = toNullable(ST_MarkerStyle_$type, null);
            c = toNullable(Number_$type, null);
            for (let d of fromEnum(a.ab.u)) {
                switch (d.a.e(a.d)) {
                    case "symbol":
                        b = toNullable(ST_MarkerStyle_$type, XmlNamespaceDefinitionBase.b(ST_MarkerStyle_$type, d.d));
                        break;
                    case "size":
                        c = toNullable(Number_$type, parseUInt8_1(d.d, CultureInfo.invariantCulture));
                        break;
                    default: break;
                }
            }
            ;
            return {
                p1: b,
                p2: c
            };
        }
        static g(a, b, c = toNullable(Number_$type, null), d = toNullable(ST_MarkerStyle_$type, null)) {
            a.ad.p(b, "cs");
            let e = null;
            let f = null;
            if (c.hasValue) {
                f = "size";
                e = c.value.toString();
                a.ad.h(f, e);
            }
            if (d.hasValue) {
                f = "symbol";
                e = XmlNamespaceDefinitionBase.f(ST_MarkerStyle_$type, d.value);
                a.ad.h(f, e);
            }
            ;
        }
        toString() {
            let a = getInstanceType(this);
            return a != null ? a.typeName : super.toString();
        }
    }
    CT_MarkerLayout.$t = markType(CT_MarkerLayout, 'CT_MarkerLayout');
    return CT_MarkerLayout;
})();
