/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, toNullable, fromEnum, typeCast, markType, getInstanceType } from "igniteui-angular-core";
import { ISupportSetProperty_$type } from "./ISupportSetProperty";
import { ColorInfo } from "./ColorInfo";
import { ST_PatternType_$type } from "./ST_PatternType";
import { XmlNamespaceDefinitionBase } from "./XmlNamespaceDefinitionBase";
/**
 * @hidden
 */
export let CT_PatternFill = /*@__PURE__*/ (() => {
    class CT_PatternFill extends Base {
        constructor() {
            super();
            this.b = null;
            this.a = null;
            this.c = toNullable(ST_PatternType_$type, null);
        }
        static e(a, b) {
            b = toNullable(ST_PatternType_$type, null);
            for (let c of fromEnum(a.ab.u)) {
                switch (c.a.e(a.d)) {
                    case "patternType":
                        b = toNullable(ST_PatternType_$type, XmlNamespaceDefinitionBase.b(ST_PatternType_$type, c.d));
                        break;
                    default: break;
                }
            }
            return {
                p1: b
            };
        }
        static f(a, b, c = toNullable(ST_PatternType_$type, null)) {
            a.ad.p(b, null);
            let d = null;
            let e = null;
            if (c.hasValue) {
                e = "patternType";
                d = XmlNamespaceDefinitionBase.f(ST_PatternType_$type, c.value);
                a.ad.h(e, d);
            }
        }
        setProperty(a, b) {
            switch (a) {
                case 619:
                    this.b = typeCast(ColorInfo.$, b);
                    break;
                case 113:
                    this.a = typeCast(ColorInfo.$, b);
                    break;
                default: break;
            }
        }
        toString() {
            let a = getInstanceType(this);
            return a != null ? a.typeName : super.toString();
        }
    }
    CT_PatternFill.$t = markType(CT_PatternFill, 'CT_PatternFill', Base.$, [ISupportSetProperty_$type]);
    return CT_PatternFill;
})();
