/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { XmlNamespaceDefinitionBase } from "./XmlNamespaceDefinitionBase";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let DrawingMLChart2012 = /*@__PURE__*/ (() => {
    class DrawingMLChart2012 extends XmlNamespaceDefinitionBase {
        constructor() {
            super();
        }
        i(a) {
            switch (a) {
                case 0: return DrawingMLChart2012.bl;
                case 1: return DrawingMLChart2012.bk;
                default: return DrawingMLChart2012.bl;
            }
        }
        get_j() {
            return "c15";
        }
        get j() {
            return this.get_j();
        }
    }
    DrawingMLChart2012.$t = markType(DrawingMLChart2012, 'DrawingMLChart2012', XmlNamespaceDefinitionBase.$);
    DrawingMLChart2012.bl = "http://schemas.microsoft.com/office/drawing/2012/chart";
    DrawingMLChart2012.bk = "http://purl.oclc.org/ooxml/drawing/2012/chart";
    DrawingMLChart2012.bj = DrawingMLChart2012.bl;
    DrawingMLChart2012.ap = DrawingMLChart2012.bj + "/autoCat";
    DrawingMLChart2012.aq = DrawingMLChart2012.bj + "/bubble3D";
    DrawingMLChart2012.ar = DrawingMLChart2012.bj + "/cat";
    DrawingMLChart2012.as = DrawingMLChart2012.bj + "/categoryFilterException";
    DrawingMLChart2012.at = DrawingMLChart2012.bj + "/categoryFilterExceptions";
    DrawingMLChart2012.au = DrawingMLChart2012.bj + "/datalabelsRange";
    DrawingMLChart2012.av = DrawingMLChart2012.bj + "/dLbl";
    DrawingMLChart2012.aw = DrawingMLChart2012.bj + "/dlblFieldTable";
    DrawingMLChart2012.ax = DrawingMLChart2012.bj + "/dlblFieldTableCache";
    DrawingMLChart2012.ay = DrawingMLChart2012.bj + "/dlblFTEntry";
    DrawingMLChart2012.az = DrawingMLChart2012.bj + "/dlblRangeCache";
    DrawingMLChart2012.a0 = DrawingMLChart2012.bj + "/explosion";
    DrawingMLChart2012.a1 = DrawingMLChart2012.bj + "/f";
    DrawingMLChart2012.a2 = DrawingMLChart2012.bj + "/filteredAreaSeries";
    DrawingMLChart2012.a3 = DrawingMLChart2012.bj + "/filteredBarSeries";
    DrawingMLChart2012.a4 = DrawingMLChart2012.bj + "/filteredBubbleSeries";
    DrawingMLChart2012.a5 = DrawingMLChart2012.bj + "/filteredCategoryTitle";
    DrawingMLChart2012.a6 = DrawingMLChart2012.bj + "/filteredLineSeries";
    DrawingMLChart2012.a7 = DrawingMLChart2012.bj + "/filteredPieSeries";
    DrawingMLChart2012.a8 = DrawingMLChart2012.bj + "/filteredRadarSeries";
    DrawingMLChart2012.a9 = DrawingMLChart2012.bj + "/filteredScatterSeries";
    DrawingMLChart2012.ba = DrawingMLChart2012.bj + "/filteredSeriesTitle";
    DrawingMLChart2012.bb = DrawingMLChart2012.bj + "/filteredSurfaceSeries";
    DrawingMLChart2012.bc = DrawingMLChart2012.bj + "/formulaRef";
    DrawingMLChart2012.bd = DrawingMLChart2012.bj + "/fullRef";
    DrawingMLChart2012.be = DrawingMLChart2012.bj + "/invertIfNegative";
    DrawingMLChart2012.bf = DrawingMLChart2012.bj + "/layout";
    DrawingMLChart2012.bg = DrawingMLChart2012.bj + "/leaderLines";
    DrawingMLChart2012.bh = DrawingMLChart2012.bj + "/levelRef";
    DrawingMLChart2012.bi = DrawingMLChart2012.bj + "/marker";
    DrawingMLChart2012.bm = DrawingMLChart2012.bj + "/numFmt";
    DrawingMLChart2012.bn = DrawingMLChart2012.bj + "/pivotSource";
    DrawingMLChart2012.bo = DrawingMLChart2012.bj + "/ser";
    DrawingMLChart2012.bp = DrawingMLChart2012.bj + "/showDataLabelsRange";
    DrawingMLChart2012.bq = DrawingMLChart2012.bj + "/showLeaderLines";
    DrawingMLChart2012.br = DrawingMLChart2012.bj + "/spPr";
    DrawingMLChart2012.bs = DrawingMLChart2012.bj + "/sqref";
    DrawingMLChart2012.bt = DrawingMLChart2012.bj + "/tx";
    DrawingMLChart2012.bu = DrawingMLChart2012.bj + "/txfldGUID";
    DrawingMLChart2012.bv = DrawingMLChart2012.bj + "/xForSave";
    DrawingMLChart2012.an = new DrawingMLChart2012();
    return DrawingMLChart2012;
})();
