/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DrawingNamespaceDefinitionBase } from "./DrawingNamespaceDefinitionBase";
import { fromEnum, markType } from "igniteui-angular-core";
import { ST_Coordinate } from "./ST_Coordinate";
import { ST_OnOff } from "./ST_OnOff";
import { XmlNamespaceDefinitionBase } from "./XmlNamespaceDefinitionBase";
import { DrawingMLMain } from "./DrawingMLMain";
import { ST_EditAs_$type } from "./ST_EditAs";
/**
 * @hidden
 */
export let DrawingMLSpreadsheetDrawing = /*@__PURE__*/ (() => {
    class DrawingMLSpreadsheetDrawing extends DrawingNamespaceDefinitionBase {
        constructor() {
            super(DrawingMLSpreadsheetDrawing.dq, DrawingMLSpreadsheetDrawing.dr);
        }
        get_j() {
            return "xdr";
        }
        get j() {
            return this.get_j();
        }
        static eq(a, b) {
            for (let c of fromEnum(a.ab.u)) {
                switch (c.a.e(a.d)) {
                    default: break;
                }
            }
        }
        static e5(a, b) {
            a.ad.p(b, "xdr");
        }
        static ex(a, b, c) {
            for (let d of fromEnum(a.ab.u)) {
                switch (d.a.e(a.d)) {
                    default: break;
                }
            }
            c = ST_Coordinate.h(a.ab.ad);
            return {
                p2: c
            };
        }
        static fc(a, b, c) {
            a.ad.p(b, "xdr");
            a.ad.u(c.toString());
        }
        static em(a) {
            for (let b of fromEnum(a.ab.u)) {
                switch (b.a.e(a.d)) {
                    default: break;
                }
            }
        }
        static e1(a) {
            a.ad.p(DrawingMLSpreadsheetDrawing.ds, "xdr");
        }
        static en(a, b, c) {
            b = true;
            c = true;
            for (let d of fromEnum(a.ab.u)) {
                switch (d.a.e(a.d)) {
                    case "fLocksWithSheet":
                        b = ST_OnOff.e(d.d);
                        break;
                    case "fPrintsWithSheet":
                        c = ST_OnOff.e(d.d);
                        break;
                    default: break;
                }
            }
            return {
                p1: b,
                p2: c
            };
        }
        static e2(a, b = true, c = true) {
            a.ad.p(DrawingMLSpreadsheetDrawing.dt, "xdr");
            let d;
            if (b != true) {
                d = ST_OnOff.g(b);
                a.ad.h("fLocksWithSheet", d);
            }
            if (c != true) {
                d = ST_OnOff.g(c);
                a.ad.h("fPrintsWithSheet", d);
            }
        }
        static eo(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, DrawingMLSpreadsheetDrawing.dw, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static e3(a, b) {
            XmlNamespaceDefinitionBase.af(a, DrawingMLSpreadsheetDrawing.dw, "xdr", b);
        }
        static ep(a, b) {
            let c = DrawingMLSpreadsheetDrawing.ex(a, DrawingMLSpreadsheetDrawing.dx, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static e4(a, b) {
            DrawingMLSpreadsheetDrawing.fc(a, DrawingMLSpreadsheetDrawing.dx, b);
        }
        static er(a, b, c) {
            let d = DrawingMLMain.k5(a, DrawingMLSpreadsheetDrawing.d0, b, c);
            b = d.p2;
            c = d.p3;
            return {
                p1: b,
                p2: c
            };
        }
        static e6(a, b, c) {
            DrawingMLMain.n6(a, DrawingMLSpreadsheetDrawing.d0, b, c);
        }
        static es(a) {
        }
        static e7(a) {
            DrawingMLSpreadsheetDrawing.e5(a, DrawingMLSpreadsheetDrawing.d3);
        }
        static et(a) {
            for (let b of fromEnum(a.ab.u)) {
                switch (b.a.e(a.d)) {
                    default: break;
                }
            }
        }
        static e8(a) {
            a.ad.p(DrawingMLSpreadsheetDrawing.ea, "xdr");
        }
        static eu(a, b, c) {
            let d = DrawingMLMain.k1(a, DrawingMLSpreadsheetDrawing.ec, b, c);
            b = d.p2;
            c = d.p3;
            return {
                p1: b,
                p2: c
            };
        }
        static e9(a, b, c) {
            DrawingMLMain.n2(a, DrawingMLSpreadsheetDrawing.ec, b, c);
        }
        static ev(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, DrawingMLSpreadsheetDrawing.ed, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static fa(a, b) {
            XmlNamespaceDefinitionBase.af(a, DrawingMLSpreadsheetDrawing.ed, "xdr", b);
        }
        static ew(a, b) {
            let c = DrawingMLSpreadsheetDrawing.ex(a, DrawingMLSpreadsheetDrawing.ee, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static fb(a, b) {
            DrawingMLSpreadsheetDrawing.fc(a, DrawingMLSpreadsheetDrawing.ee, b);
        }
        static ey(a) {
        }
        static fd(a) {
            DrawingMLSpreadsheetDrawing.e5(a, DrawingMLSpreadsheetDrawing.ei);
        }
        static ez(a, b) {
            b = 0;
            for (let c of fromEnum(a.ab.u)) {
                switch (c.a.e(a.d)) {
                    case "editAs":
                        b = XmlNamespaceDefinitionBase.b(ST_EditAs_$type, c.d, b);
                        break;
                    default: break;
                }
            }
            return {
                p1: b
            };
        }
        static fe(a, b = 0) {
            a.ad.p(DrawingMLSpreadsheetDrawing.ej, "xdr");
            let c;
            if (b != 0) {
                c = XmlNamespaceDefinitionBase.f(ST_EditAs_$type, b);
                a.ad.h("editAs", c);
            }
        }
        static e0(a) {
            for (let b of fromEnum(a.ab.u)) {
                switch (b.a.e(a.d)) {
                    default: break;
                }
            }
        }
        static ff(a) {
            a.ad.p(DrawingMLSpreadsheetDrawing.el, "xdr");
            let b = a.d._z;
            a.ad.l(DrawingMLMain.an);
            a.ad.l(DrawingMLSpreadsheetDrawing.dn);
        }
    }
    DrawingMLSpreadsheetDrawing.$t = markType(DrawingMLSpreadsheetDrawing, 'DrawingMLSpreadsheetDrawing', DrawingNamespaceDefinitionBase.$);
    DrawingMLSpreadsheetDrawing.dr = "http://schemas.openxmlformats.org/drawingml/2006/spreadsheetDrawing";
    DrawingMLSpreadsheetDrawing.dq = "http://purl.oclc.org/ooxml/drawingml/spreadsheetDrawing";
    DrawingMLSpreadsheetDrawing.ds = DrawingMLSpreadsheetDrawing.dq + "/absoluteAnchor";
    DrawingMLSpreadsheetDrawing.dt = DrawingMLSpreadsheetDrawing.dq + "/clientData";
    DrawingMLSpreadsheetDrawing.dw = DrawingMLSpreadsheetDrawing.dq + "/col";
    DrawingMLSpreadsheetDrawing.dx = DrawingMLSpreadsheetDrawing.dq + "/colOff";
    DrawingMLSpreadsheetDrawing.d0 = DrawingMLSpreadsheetDrawing.dq + "/ext";
    DrawingMLSpreadsheetDrawing.d3 = DrawingMLSpreadsheetDrawing.dq + "/from";
    DrawingMLSpreadsheetDrawing.ea = DrawingMLSpreadsheetDrawing.dq + "/oneCellAnchor";
    DrawingMLSpreadsheetDrawing.ec = DrawingMLSpreadsheetDrawing.dq + "/pos";
    DrawingMLSpreadsheetDrawing.ed = DrawingMLSpreadsheetDrawing.dq + "/row";
    DrawingMLSpreadsheetDrawing.ee = DrawingMLSpreadsheetDrawing.dq + "/rowOff";
    DrawingMLSpreadsheetDrawing.ei = DrawingMLSpreadsheetDrawing.dq + "/to";
    DrawingMLSpreadsheetDrawing.ej = DrawingMLSpreadsheetDrawing.dq + "/twoCellAnchor";
    DrawingMLSpreadsheetDrawing.el = DrawingMLSpreadsheetDrawing.dq + "/wsDr";
    DrawingMLSpreadsheetDrawing.dy = DrawingMLSpreadsheetDrawing.dq + "/cxnSp";
    DrawingMLSpreadsheetDrawing.d4 = DrawingMLSpreadsheetDrawing.dq + "/graphicFrame";
    DrawingMLSpreadsheetDrawing.d5 = DrawingMLSpreadsheetDrawing.dq + "/grpSp";
    DrawingMLSpreadsheetDrawing.eb = DrawingMLSpreadsheetDrawing.dq + "/pic";
    DrawingMLSpreadsheetDrawing.ef = DrawingMLSpreadsheetDrawing.dq + "/sp";
    DrawingMLSpreadsheetDrawing.d9 = DrawingMLSpreadsheetDrawing.dq + "/nvSpPr";
    DrawingMLSpreadsheetDrawing.du = DrawingMLSpreadsheetDrawing.dq + "/cNvPr";
    DrawingMLSpreadsheetDrawing.dv = DrawingMLSpreadsheetDrawing.dq + "/cNvSpPr";
    DrawingMLSpreadsheetDrawing.eg = DrawingMLSpreadsheetDrawing.dq + "/spPr";
    DrawingMLSpreadsheetDrawing.ek = DrawingMLSpreadsheetDrawing.dq + "/txBody";
    DrawingMLSpreadsheetDrawing.dn = new DrawingMLSpreadsheetDrawing();
    return DrawingMLSpreadsheetDrawing;
})();
