/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which specify the direction in which an
 * <see cref="ErrorBars">error bar</see> extends.
 */
export var ErrorBarDirection = /*@__PURE__*/ (function (ErrorBarDirection) {
    /**
     * The error bar extends in both directions.
     */
    ErrorBarDirection[ErrorBarDirection["Both"] = 0] = "Both";
    /**
     * The error bar extends only in the positive direction.
     */
    ErrorBarDirection[ErrorBarDirection["Plus"] = 1] = "Plus";
    /**
     * The error bar extends only in the negative direction.
     */
    ErrorBarDirection[ErrorBarDirection["Minus"] = 2] = "Minus";
    return ErrorBarDirection;
})({});
/**
 * @hidden
 */
export let ErrorBarDirection_$type = markEnum('ErrorBarDirection', 'Both,0|Plus,1|Minus,2');
