/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { OfficeDocumentManager } from "./OfficeDocumentManager";
import { DrawingMLSpreadsheetDrawing } from "./DrawingMLSpreadsheetDrawing";
import { fromEnum, markType } from "igniteui-angular-core";
import { ExcelNamespace } from "./ExcelNamespace";
import { Excel2006Main } from "./Excel2006Main";
import { SpreadsheetMLMain } from "./SpreadsheetMLMain";
import { SpreadsheetML2009Main } from "./SpreadsheetML2009Main";
import { BmpPartManager } from "./BmpPartManager";
import { EmfPartManager } from "./EmfPartManager";
import { GifPartManager } from "./GifPartManager";
import { JpegPartManager } from "./JpegPartManager";
import { PngPartManager } from "./PngPartManager";
import { TiffPartManager } from "./TiffPartManager";
import { WmfPartManager } from "./WmfPartManager";
import { WorkbookPartManagerBase } from "./WorkbookPartManagerBase";
/**
 * @hidden
 */
export let ExcelDocumentManager = /*@__PURE__*/ (() => {
    class ExcelDocumentManager extends OfficeDocumentManager {
        constructor(a, b, c, d) {
            super(a, b, c, d);
        }
        get__v() {
            return 0;
        }
        get _v() {
            return this.get__v();
        }
        _aa() {
            if (this._ac == false) {
                return 0;
            }
            for (let a of fromEnum(this._b.getRelationships())) {
                switch (a.relationshipType) {
                    case WorkbookPartManagerBase.a6: return 0;
                    case WorkbookPartManagerBase.a5: return 1;
                }
            }
            return 0;
        }
        _bh() {
            super._bh();
            this._bk(DrawingMLSpreadsheetDrawing.dn);
            this._bk(ExcelNamespace.an);
            this._bk(Excel2006Main.an);
            this._bk(SpreadsheetMLMain.ao);
            this._bk(SpreadsheetML2009Main.an);
            this._bl(BmpPartManager.y);
            this._bl(EmfPartManager.y);
            this._bl(GifPartManager.y);
            this._bl(JpegPartManager.y);
            this._bl(PngPartManager.y);
            this._bl(TiffPartManager.y);
            this._bl(WmfPartManager.y);
        }
        get__t() {
            return DrawingMLSpreadsheetDrawing.dn;
        }
        get _t() {
            return this.get__t();
        }
        _bq() {
            switch (this._z) {
                case 0: return ExcelDocumentManager._bp;
                case 1: return ExcelDocumentManager._bo;
                default: return ExcelDocumentManager._bp;
            }
        }
        _br() {
            switch (this._z) {
                case 0: return ExcelDocumentManager._bt;
                case 1: return ExcelDocumentManager._bs;
                default: return ExcelDocumentManager._bt;
            }
        }
    }
    ExcelDocumentManager.$t = markType(ExcelDocumentManager, 'ExcelDocumentManager', OfficeDocumentManager.$);
    ExcelDocumentManager._bp = "http://schemas.openxmlformats.org/officeDocument/2006/relationships/externalLinkPath";
    ExcelDocumentManager._bo = "http://purl.oclc.org/ooxml/officeDocument/relationships/externalLinkPath";
    ExcelDocumentManager._bt = "http://schemas.openxmlformats.org/officeDocument/2006/relationships/oleObject";
    ExcelDocumentManager._bs = "http://purl.oclc.org/ooxml/officeDocument/relationships/oleObject";
    return ExcelDocumentManager;
})();
