/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { XmlNamespaceDefinitionBase } from "./XmlNamespaceDefinitionBase";
import { fromEnum, markType } from "igniteui-angular-core";
import { ST_TrueFalseBlank } from "./ST_TrueFalseBlank";
import { ST_CF_$type } from "./ST_CF";
import { ST_ObjectType_$type } from "./ST_ObjectType";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ExcelNamespace = /*@__PURE__*/ (() => {
    class ExcelNamespace extends XmlNamespaceDefinitionBase {
        constructor() {
            super();
        }
        i(a) {
            switch (a) {
                case 0:
                case 1: return "urn:schemas-microsoft-com:office:excel";
                default: return "urn:schemas-microsoft-com:office:excel";
            }
        }
        get_j() {
            return "x";
        }
        get j() {
            return this.get_j();
        }
        static dm(a, b, c) {
            for (let d of fromEnum(a.ab.u)) {
                switch (d.a.e(a.d)) {
                    default: break;
                }
            }
            c = ST_TrueFalseBlank.d(a.ab.ad);
            return {
                p2: c
            };
        }
        static e7(a, b, c, d) {
            a.ad.p(b, c);
            let e = ST_TrueFalseBlank.f(d);
            if (stringIsNullOrEmpty(e) == false) {
                a.ad.u(e);
            }
        }
        static ca(a, b) {
            let c = XmlNamespaceDefinitionBase.u(a, ExcelNamespace.ap, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static dv(a, b) {
            XmlNamespaceDefinitionBase.ai(a, ExcelNamespace.ap, "x", b);
        }
        static cb(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.aq, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static dw(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.aq, "x", b);
        }
        static cc(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.ar, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static dx(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.ar, "x", b);
        }
        static cd(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.as, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static dy(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.as, "x", b);
        }
        static ce(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.at, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static dz(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.at, "x", b);
        }
        static cf(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.au, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static d0(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.au, "x", b);
        }
        static cg(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.av, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static d1(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.av, "x", b);
        }
        static ch(a, b) {
            for (let c of fromEnum(a.ab.u)) {
                switch (c.a.e(a.d)) {
                    default: break;
                }
            }
            b = XmlNamespaceDefinitionBase.b(ST_CF_$type, a.ab.ad);
            return {
                p1: b
            };
        }
        static d2(a, b) {
            a.ad.p(ExcelNamespace.aw, "x");
            a.ad.u(XmlNamespaceDefinitionBase.f(ST_CF_$type, b));
        }
        static ci(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, ExcelNamespace.ax, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static d3(a, b) {
            XmlNamespaceDefinitionBase.af(a, ExcelNamespace.ax, "x", b);
        }
        static cj(a, b) {
            b = 0;
            for (let c of fromEnum(a.ab.u)) {
                switch (c.a.e(a.d)) {
                    case "ObjectType":
                        b = XmlNamespaceDefinitionBase.b(ST_ObjectType_$type, c.d, b);
                        break;
                    default: break;
                }
            }
            return {
                p1: b
            };
        }
        static d4(a, b) {
            a.ad.p(ExcelNamespace.ay, "x");
            let c;
            c = XmlNamespaceDefinitionBase.f(ST_ObjectType_$type, b);
            a.ad.h("ObjectType", c);
        }
        static ck(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.az, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static d5(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.az, "x", b);
        }
        static cl(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.a0, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static d6(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.a0, "x", b);
        }
        static cm(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, ExcelNamespace.a1, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static d7(a, b) {
            XmlNamespaceDefinitionBase.af(a, ExcelNamespace.a1, "x", b);
        }
        static cn(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.a2, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static d8(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.a2, "x", b);
        }
        static co(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.a3, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static d9(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.a3, "x", b);
        }
        static cp(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.a4, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ea(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.a4, "x", b);
        }
        static cq(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.a5, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static eb(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.a5, "x", b);
        }
        static cr(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.a6, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ec(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.a6, "x", b);
        }
        static cs(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, ExcelNamespace.a7, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ed(a, b) {
            XmlNamespaceDefinitionBase.af(a, ExcelNamespace.a7, "x", b);
        }
        static ct(a, b) {
            let c = XmlNamespaceDefinitionBase.u(a, ExcelNamespace.a8, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ee(a, b) {
            XmlNamespaceDefinitionBase.ai(a, ExcelNamespace.a8, "x", b);
        }
        static cu(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, ExcelNamespace.a9, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ef(a, b) {
            XmlNamespaceDefinitionBase.af(a, ExcelNamespace.a9, "x", b);
        }
        static cv(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.ba, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static eg(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.ba, "x", b);
        }
        static cw(a, b) {
            let c = XmlNamespaceDefinitionBase.u(a, ExcelNamespace.bb, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static eh(a, b) {
            XmlNamespaceDefinitionBase.ai(a, ExcelNamespace.bb, "x", b);
        }
        static cx(a, b) {
            let c = XmlNamespaceDefinitionBase.u(a, ExcelNamespace.bc, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ei(a, b) {
            XmlNamespaceDefinitionBase.ai(a, ExcelNamespace.bc, "x", b);
        }
        static cy(a, b) {
            let c = XmlNamespaceDefinitionBase.u(a, ExcelNamespace.bd, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ej(a, b) {
            XmlNamespaceDefinitionBase.ai(a, ExcelNamespace.bd, "x", b);
        }
        static cz(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.be, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ek(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.be, "x", b);
        }
        static c0(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.bf, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static el(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.bf, "x", b);
        }
        static c1(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, ExcelNamespace.bg, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static em(a, b) {
            XmlNamespaceDefinitionBase.af(a, ExcelNamespace.bg, "x", b);
        }
        static c2(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.bh, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static en(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.bh, "x", b);
        }
        static c3(a, b) {
            let c = XmlNamespaceDefinitionBase.u(a, ExcelNamespace.bi, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static eo(a, b) {
            XmlNamespaceDefinitionBase.ai(a, ExcelNamespace.bi, "x", b);
        }
        static c5(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.bk, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static eq(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.bk, "x", b);
        }
        static c4(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.bj, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ep(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.bj, "x", b);
        }
        static c6(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.bl, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static er(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.bl, "x", b);
        }
        static c7(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, ExcelNamespace.bm, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static es(a, b) {
            XmlNamespaceDefinitionBase.af(a, ExcelNamespace.bm, "x", b);
        }
        static c8(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, ExcelNamespace.bn, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static et(a, b) {
            XmlNamespaceDefinitionBase.af(a, ExcelNamespace.bn, "x", b);
        }
        static c9(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.bo, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static eu(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.bo, "x", b);
        }
        static da(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.bp, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ev(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.bp, "x", b);
        }
        static dc(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.br, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ex(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.br, "x", b);
        }
        static db(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.bs, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ew(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.bs, "x", b);
        }
        static dd(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, ExcelNamespace.bu, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ey(a, b) {
            XmlNamespaceDefinitionBase.af(a, ExcelNamespace.bu, "x", b);
        }
        static de(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.bv, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static ez(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.bv, "x", b);
        }
        static df(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.bw, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static e0(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.bw, "x", b);
        }
        static dg(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, ExcelNamespace.bx, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static e1(a, b) {
            XmlNamespaceDefinitionBase.af(a, ExcelNamespace.bx, "x", b);
        }
        static dh(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.by, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static e2(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.by, "x", b);
        }
        static di(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.bz, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static e3(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.bz, "x", b);
        }
        static dj(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, ExcelNamespace.b0, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static e4(a, b) {
            XmlNamespaceDefinitionBase.af(a, ExcelNamespace.b0, "x", b);
        }
        static dk(a, b) {
            let c = XmlNamespaceDefinitionBase.u(a, ExcelNamespace.b1, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static e5(a, b) {
            XmlNamespaceDefinitionBase.ai(a, ExcelNamespace.b1, "x", b);
        }
        static dl(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.b2, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static e6(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.b2, "x", b);
        }
        static dn(a, b) {
            let c = XmlNamespaceDefinitionBase.u(a, ExcelNamespace.b3, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static e8(a, b) {
            XmlNamespaceDefinitionBase.ai(a, ExcelNamespace.b3, "x", b);
        }
        static dp(a, b) {
            let c = XmlNamespaceDefinitionBase.u(a, ExcelNamespace.b4, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static e9(a, b) {
            XmlNamespaceDefinitionBase.ai(a, ExcelNamespace.b4, "x", b);
        }
        static dq(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.b5, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static fa(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.b5, "x", b);
        }
        static du(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.b9, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static fe(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.b9, "x", b);
        }
        static ds(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.b7, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static fc(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.b7, "x", b);
        }
        static dr(a, b) {
            let c = XmlNamespaceDefinitionBase.r(a, ExcelNamespace.b6, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static fb(a, b) {
            XmlNamespaceDefinitionBase.af(a, ExcelNamespace.b6, "x", b);
        }
        static dt(a, b) {
            let c = ExcelNamespace.dm(a, ExcelNamespace.b8, b);
            b = c.p2;
            return {
                p1: b
            };
        }
        static fd(a, b) {
            ExcelNamespace.e7(a, ExcelNamespace.b8, "x", b);
        }
    }
    ExcelNamespace.$t = markType(ExcelNamespace, 'ExcelNamespace', XmlNamespaceDefinitionBase.$);
    ExcelNamespace.ap = "urn:schemas-microsoft-com:office:excel" + "/Anchor";
    ExcelNamespace.aq = "urn:schemas-microsoft-com:office:excel" + "/AutoFill";
    ExcelNamespace.ar = "urn:schemas-microsoft-com:office:excel" + "/AutoLine";
    ExcelNamespace.as = "urn:schemas-microsoft-com:office:excel" + "/AutoPict";
    ExcelNamespace.at = "urn:schemas-microsoft-com:office:excel" + "/AutoScale";
    ExcelNamespace.au = "urn:schemas-microsoft-com:office:excel" + "/Camera";
    ExcelNamespace.av = "urn:schemas-microsoft-com:office:excel" + "/Cancel";
    ExcelNamespace.aw = "urn:schemas-microsoft-com:office:excel" + "/CF";
    ExcelNamespace.ax = "urn:schemas-microsoft-com:office:excel" + "/Checked";
    ExcelNamespace.ay = "urn:schemas-microsoft-com:office:excel" + "/ClientData";
    ExcelNamespace.az = "urn:schemas-microsoft-com:office:excel" + "/ColHidden";
    ExcelNamespace.a0 = "urn:schemas-microsoft-com:office:excel" + "/Colored";
    ExcelNamespace.a1 = "urn:schemas-microsoft-com:office:excel" + "/Column";
    ExcelNamespace.a2 = "urn:schemas-microsoft-com:office:excel" + "/DDE";
    ExcelNamespace.a3 = "urn:schemas-microsoft-com:office:excel" + "/Default";
    ExcelNamespace.a4 = "urn:schemas-microsoft-com:office:excel" + "/DefaultSize";
    ExcelNamespace.a5 = "urn:schemas-microsoft-com:office:excel" + "/Disabled";
    ExcelNamespace.a6 = "urn:schemas-microsoft-com:office:excel" + "/Dismiss";
    ExcelNamespace.a7 = "urn:schemas-microsoft-com:office:excel" + "/DropLines";
    ExcelNamespace.a8 = "urn:schemas-microsoft-com:office:excel" + "/DropStyle";
    ExcelNamespace.a9 = "urn:schemas-microsoft-com:office:excel" + "/Dx";
    ExcelNamespace.ba = "urn:schemas-microsoft-com:office:excel" + "/FirstButton";
    ExcelNamespace.bb = "urn:schemas-microsoft-com:office:excel" + "/FmlaLink";
    ExcelNamespace.bc = "urn:schemas-microsoft-com:office:excel" + "/FmlaMacro";
    ExcelNamespace.bd = "urn:schemas-microsoft-com:office:excel" + "/FmlaRange";
    ExcelNamespace.be = "urn:schemas-microsoft-com:office:excel" + "/Help";
    ExcelNamespace.bf = "urn:schemas-microsoft-com:office:excel" + "/Horiz";
    ExcelNamespace.bg = "urn:schemas-microsoft-com:office:excel" + "/Inc";
    ExcelNamespace.bh = "urn:schemas-microsoft-com:office:excel" + "/JustLastX";
    ExcelNamespace.bi = "urn:schemas-microsoft-com:office:excel" + "/LCT";
    ExcelNamespace.bk = "urn:schemas-microsoft-com:office:excel" + "/LockText";
    ExcelNamespace.bj = "urn:schemas-microsoft-com:office:excel" + "/Locked";
    ExcelNamespace.bn = "urn:schemas-microsoft-com:office:excel" + "/Min";
    ExcelNamespace.bl = "urn:schemas-microsoft-com:office:excel" + "/MapOCX";
    ExcelNamespace.bm = "urn:schemas-microsoft-com:office:excel" + "/Max";
    ExcelNamespace.bo = "urn:schemas-microsoft-com:office:excel" + "/MoveWithCells";
    ExcelNamespace.bp = "urn:schemas-microsoft-com:office:excel" + "/MultiLine";
    ExcelNamespace.br = "urn:schemas-microsoft-com:office:excel" + "/NoThreeD";
    ExcelNamespace.bs = "urn:schemas-microsoft-com:office:excel" + "/NoThreeD2";
    ExcelNamespace.bu = "urn:schemas-microsoft-com:office:excel" + "/Page";
    ExcelNamespace.bv = "urn:schemas-microsoft-com:office:excel" + "/PrintObject";
    ExcelNamespace.bw = "urn:schemas-microsoft-com:office:excel" + "/RecalcAlways";
    ExcelNamespace.bx = "urn:schemas-microsoft-com:office:excel" + "/Row";
    ExcelNamespace.by = "urn:schemas-microsoft-com:office:excel" + "/RowHidden";
    ExcelNamespace.bz = "urn:schemas-microsoft-com:office:excel" + "/SecretEdit";
    ExcelNamespace.b0 = "urn:schemas-microsoft-com:office:excel" + "/Sel";
    ExcelNamespace.b1 = "urn:schemas-microsoft-com:office:excel" + "/SelType";
    ExcelNamespace.b2 = "urn:schemas-microsoft-com:office:excel" + "/SizeWithCells";
    ExcelNamespace.b3 = "urn:schemas-microsoft-com:office:excel" + "/TextHAlign";
    ExcelNamespace.b4 = "urn:schemas-microsoft-com:office:excel" + "/TextVAlign";
    ExcelNamespace.b5 = "urn:schemas-microsoft-com:office:excel" + "/UIObj";
    ExcelNamespace.b9 = "urn:schemas-microsoft-com:office:excel" + "/VScroll";
    ExcelNamespace.b6 = "urn:schemas-microsoft-com:office:excel" + "/Val";
    ExcelNamespace.b7 = "urn:schemas-microsoft-com:office:excel" + "/ValidIds";
    ExcelNamespace.b8 = "urn:schemas-microsoft-com:office:excel" + "/Visible";
    ExcelNamespace.an = new ExcelNamespace();
    return ExcelNamespace;
})();
