/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which determine  the manner in which cell values
 * are compared to the [[ConditionValue.value]]
 * property when conditional criteria is evaluated by an
 * [[IconSetConditionalFormat]].
 */
export var ThresholdComparison = /*@__PURE__*/ (function (ThresholdComparison) {
    /**
     * The cell value can be greater than <b>or equal to</b> the threshold <see cref="ConditionValue.Value">value</see>.
     */
    ThresholdComparison[ThresholdComparison["GreaterEqual"] = 0] = "GreaterEqual";
    /**
     * The cell value must be greater than <b>but not equal to</b> the threshold <see cref="ConditionValue.Value">value</see>.
     */
    ThresholdComparison[ThresholdComparison["Greater"] = 1] = "Greater";
    return ThresholdComparison;
})({});
/**
 * @hidden
 */
export let ThresholdComparison_$type = markEnum('ThresholdComparison', 'GreaterEqual,0|Greater,1');
