/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { stringToLocaleUpper } from "igniteui-angular-core";
/**
 * @hidden
 */
export let UltraCalcFunctionUpper = /*@__PURE__*/ (() => {
    class UltraCalcFunctionUpper extends BuiltInFunctionBase {
        evaluate(a, b) {
            if (true) {
                let c = a.pop();
                if (c.isError) {
                    return c;
                }
                return new ExcelCalcValue(c.toString().toUpperCase());
            }
            if (a.peek().isString) {
                return new ExcelCalcValue(stringToLocaleUpper(a.pop().toString(), a._w));
            }
            else {
                return a.pop();
            }
        }
        get_name() {
            return "upper";
        }
        get name() {
            return this.get_name();
        }
        get_minArgs() {
            return 1;
        }
        get minArgs() {
            return this.get_minArgs();
        }
        get_maxArgs() {
            return 1;
        }
        get maxArgs() {
            return this.get_maxArgs();
        }
        doesParameterAllowIntermediateResultArray(a, b) {
            return true;
        }
    }
    UltraCalcFunctionUpper.$t = markType(UltraCalcFunctionUpper, 'UltraCalcFunctionUpper', BuiltInFunctionBase.$);
    return UltraCalcFunctionUpper;
})();
