/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, toNullable, Boolean_$type, fromEnum, markType, getInstanceType } from "igniteui-angular-core";
import { ST_OnOff } from "./ST_OnOff";
/**
 * @hidden
 */
var CT_CellProtection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CT_CellProtection, _super);
    function CT_CellProtection() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = toNullable(Boolean_$type, null);
        _this.a = toNullable(Boolean_$type, null);
        return _this;
    }
    CT_CellProtection.d = function (a, b, c) {
        var e_1, _a;
        b = toNullable(Boolean_$type, null);
        c = toNullable(Boolean_$type, null);
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                switch (d.a.e(a.d)) {
                    case "locked":
                        b = toNullable(Boolean_$type, ST_OnOff.e(d.d));
                        break;
                    case "hidden":
                        c = toNullable(Boolean_$type, ST_OnOff.e(d.d));
                        break;
                    default: break;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return {
            p1: b,
            p2: c
        };
    };
    CT_CellProtection.e = function (a, b, c, d) {
        if (c === void 0) {
            c = toNullable(Boolean_$type, null);
        }
        if (d === void 0) {
            d = toNullable(Boolean_$type, null);
        }
        a.ad.p(b, null);
        var e = null;
        var f = null;
        if (c.hasValue) {
            f = "hidden";
            e = ST_OnOff.g(c.value);
            a.ad.h(f, e);
        }
        if (d.hasValue) {
            f = "locked";
            e = ST_OnOff.g(d.value);
            a.ad.h(f, e);
        }
    };
    CT_CellProtection.prototype.toString = function () {
        var a = getInstanceType(this);
        return a != null ? a.typeName : _super.prototype.toString.call(this);
    };
    CT_CellProtection.$t = markType(CT_CellProtection, 'CT_CellProtection');
    return CT_CellProtection;
}(Base));
export { CT_CellProtection };
