/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, toNullable, Boolean_$type, fromEnum, markType } from "igniteui-angular-core";
import { ST_IconSetType_$type } from "./ST_IconSetType";
import { XmlNamespaceDefinitionBase } from "./XmlNamespaceDefinitionBase";
import { ST_OnOff } from "./ST_OnOff";
/**
 * @hidden
 */
var CT_IconSet_SML2009 = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CT_IconSet_SML2009, _super);
    function CT_IconSet_SML2009() {
        var _this = _super.call(this) || this;
        _this.h = null;
        _this.f = null;
        _this.l = toNullable(ST_IconSetType_$type, null);
        _this.r = toNullable(Boolean_$type, null);
        _this.n = toNullable(Boolean_$type, null);
        _this.p = toNullable(Boolean_$type, null);
        _this.j = toNullable(Boolean_$type, null);
        return _this;
    }
    Object.defineProperty(CT_IconSet_SML2009.prototype, "g", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            this.h = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_IconSet_SML2009.prototype, "e", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            this.f = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_IconSet_SML2009.prototype, "k", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            this.l = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_IconSet_SML2009.prototype, "q", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            this.r = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_IconSet_SML2009.prototype, "m", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            this.n = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_IconSet_SML2009.prototype, "o", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            this.p = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_IconSet_SML2009.prototype, "i", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
        },
        enumerable: false,
        configurable: true
    });
    CT_IconSet_SML2009.s = function (a, b, c, d, e, f) {
        var e_1, _a;
        b = toNullable(ST_IconSetType_$type, null);
        c = toNullable(Boolean_$type, null);
        d = toNullable(Boolean_$type, null);
        e = toNullable(Boolean_$type, null);
        f = toNullable(Boolean_$type, null);
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var g = _c.value;
                switch (g.a.e(a.d)) {
                    case "iconSet":
                        b = toNullable(ST_IconSetType_$type, XmlNamespaceDefinitionBase.b(ST_IconSetType_$type, g.d));
                        break;
                    case "showValue":
                        c = toNullable(Boolean_$type, ST_OnOff.e(g.d));
                        break;
                    case "percent":
                        d = toNullable(Boolean_$type, ST_OnOff.e(g.d));
                        break;
                    case "reverse":
                        e = toNullable(Boolean_$type, ST_OnOff.e(g.d));
                        break;
                    case "custom":
                        f = toNullable(Boolean_$type, ST_OnOff.e(g.d));
                        break;
                    default: break;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        ;
        return {
            p1: b,
            p2: c,
            p3: d,
            p4: e,
            p5: f
        };
    };
    CT_IconSet_SML2009.t = function (a, b, c, d, e, f, g) {
        if (c === void 0) {
            c = toNullable(Boolean_$type, null);
        }
        if (d === void 0) {
            d = toNullable(ST_IconSetType_$type, null);
        }
        if (e === void 0) {
            e = toNullable(Boolean_$type, null);
        }
        if (f === void 0) {
            f = toNullable(Boolean_$type, null);
        }
        if (g === void 0) {
            g = toNullable(Boolean_$type, null);
        }
        a.ad.p(b, null);
        var h = null;
        var i = null;
        if (c.hasValue) {
            i = "custom";
            h = ST_OnOff.g(c.value);
            a.ad.h(i, h);
        }
        if (d.hasValue) {
            i = "iconSet";
            h = XmlNamespaceDefinitionBase.f(ST_IconSetType_$type, d.value);
            a.ad.h(i, h);
        }
        if (e.hasValue) {
            i = "percent";
            h = ST_OnOff.g(e.value);
            a.ad.h(i, h);
        }
        if (f.hasValue) {
            i = "reverse";
            h = ST_OnOff.g(f.value);
            a.ad.h(i, h);
        }
        if (g.hasValue) {
            i = "showValue";
            h = ST_OnOff.g(g.value);
            a.ad.h(i, h);
        }
        ;
    };
    CT_IconSet_SML2009.$t = markType(CT_IconSet_SML2009, 'CT_IconSet_SML2009');
    return CT_IconSet_SML2009;
}(Base));
export { CT_IconSet_SML2009 };
