/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { CT_TextBodyPropertiesBase } from "./CT_TextBodyPropertiesBase";
import { toNullable, Boolean_$type, Number_$type, typeCast, markType } from "igniteui-angular-core";
import { ST_TextAnchoringType_$type } from "./ST_TextAnchoringType";
import { ST_Coordinate32 } from "./ST_Coordinate32";
import { ST_TextHorzOverflowType_$type } from "./ST_TextHorzOverflowType";
import { ST_TextVertOverflowType_$type } from "./ST_TextVertOverflowType";
import { ST_TextWrappingType_$type } from "./ST_TextWrappingType";
import { ST_TextVerticalType_$type } from "./ST_TextVerticalType";
/**
 * @hidden
 */
var CT_TextBodyProperties = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CT_TextBodyProperties, _super);
    function CT_TextBodyProperties() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = toNullable(ST_TextAnchoringType_$type, null);
        _this.e = toNullable(Boolean_$type, null);
        _this.f = toNullable(ST_Coordinate32.$, null);
        _this.g = toNullable(Boolean_$type, null);
        _this.h = toNullable(Boolean_$type, null);
        _this.i = toNullable(Boolean_$type, null);
        _this.j = toNullable(ST_Coordinate32.$, null);
        _this.k = toNullable(Number_$type, null);
        _this.l = toNullable(Boolean_$type, null);
        _this.m = toNullable(ST_Coordinate32.$, null);
        _this.n = toNullable(Number_$type, null);
        _this.o = toNullable(Number_$type, null);
        _this.p = toNullable(ST_TextHorzOverflowType_$type, null);
        _this.c = false;
        _this.q = toNullable(ST_TextVertOverflowType_$type, null);
        _this.r = toNullable(ST_TextWrappingType_$type, null);
        _this.s = toNullable(ST_Coordinate32.$, null);
        _this.t = toNullable(ST_TextVerticalType_$type, null);
        return _this;
    }
    CT_TextBodyProperties.b = function (a) {
        var b = null;
        if (a != null) {
            b = typeCast(CT_TextBodyProperties.$, a);
            if (b == null) {
                b = new CT_TextBodyProperties();
                b.a = a.a;
            }
        }
        return b || new CT_TextBodyProperties();
    };
    CT_TextBodyProperties.$t = markType(CT_TextBodyProperties, 'CT_TextBodyProperties', CT_TextBodyPropertiesBase.$);
    return CT_TextBodyProperties;
}(CT_TextBodyPropertiesBase));
export { CT_TextBodyProperties };
