/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var ChartExElements = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChartExElements, _super);
    function ChartExElements() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ChartExElements.$t = markType(ChartExElements, 'ChartExElements');
    ChartExElements.bl = "http://schemas.microsoft.com/office/drawing/2014/chartex";
    ChartExElements.a = ChartExElements.bl + "/address";
    ChartExElements.b = ChartExElements.bl + "/aggregation";
    ChartExElements.c = ChartExElements.bl + "/autoUpdate";
    ChartExElements.d = ChartExElements.bl + "/axis";
    ChartExElements.e = ChartExElements.bl + "/axisId";
    ChartExElements.f = ChartExElements.bl + "/binary";
    ChartExElements.g = ChartExElements.bl + "/binCount";
    ChartExElements.h = ChartExElements.bl + "/binning";
    ChartExElements.i = ChartExElements.bl + "/binSize";
    ChartExElements.j = ChartExElements.bl + "/catScaling";
    ChartExElements.k = ChartExElements.bl + "/chart";
    ChartExElements.l = ChartExElements.bl + "/chartData";
    ChartExElements.m = ChartExElements.bl + "/chartSpace";
    ChartExElements.n = ChartExElements.bl + "/clear";
    ChartExElements.o = ChartExElements.bl + "/clrMapOvr";
    ChartExElements.p = ChartExElements.bl + "/copyright";
    ChartExElements.q = ChartExElements.bl + "/copyrights";
    ChartExElements.r = ChartExElements.bl + "/data";
    ChartExElements.s = ChartExElements.bl + "/dataId";
    ChartExElements.t = ChartExElements.bl + "/dataLabel";
    ChartExElements.u = ChartExElements.bl + "/dataLabelHidden";
    ChartExElements.v = ChartExElements.bl + "/dataLabels";
    ChartExElements.w = ChartExElements.bl + "/dataPt";
    ChartExElements.x = ChartExElements.bl + "/entityType";
    ChartExElements.y = ChartExElements.bl + "/evenFooter";
    ChartExElements.z = ChartExElements.bl + "/evenHeader";
    ChartExElements.aa = ChartExElements.bl + "/ext";
    ChartExElements.ab = ChartExElements.bl + "/externalData";
    ChartExElements.ac = ChartExElements.bl + "/extLst";
    ChartExElements.ad = ChartExElements.bl + "/extremeValue";
    ChartExElements.ae = ChartExElements.bl + "/f";
    ChartExElements.af = ChartExElements.bl + "/firstFooter";
    ChartExElements.ag = ChartExElements.bl + "/firstHeader";
    ChartExElements.ah = ChartExElements.bl + "/fmtOvr";
    ChartExElements.ai = ChartExElements.bl + "/fmtOvrs";
    ChartExElements.aj = ChartExElements.bl + "/geoCache";
    ChartExElements.ak = ChartExElements.bl + "/geoChildEntities";
    ChartExElements.al = ChartExElements.bl + "/geoChildEntitiesQuery";
    ChartExElements.am = ChartExElements.bl + "/geoChildEntitiesQueryResult";
    ChartExElements.an = ChartExElements.bl + "/geoChildEntitiesQueryResults";
    ChartExElements.ao = ChartExElements.bl + "/geoChildTypes";
    ChartExElements.ap = ChartExElements.bl + "/geoData";
    ChartExElements.aq = ChartExElements.bl + "/geoDataEntityQuery";
    ChartExElements.ar = ChartExElements.bl + "/geoDataEntityQueryResult";
    ChartExElements.as = ChartExElements.bl + "/geoDataEntityQueryResults";
    ChartExElements.at = ChartExElements.bl + "/geoDataPointQuery";
    ChartExElements.au = ChartExElements.bl + "/geoDataPointToEntityQuery";
    ChartExElements.av = ChartExElements.bl + "/geoDataPointToEntityQueryResult";
    ChartExElements.aw = ChartExElements.bl + "/geoDataPointToEntityQueryResults";
    ChartExElements.ax = ChartExElements.bl + "/geography";
    ChartExElements.ay = ChartExElements.bl + "/geoHierarchyEntity";
    ChartExElements.az = ChartExElements.bl + "/geoLocation";
    ChartExElements.a0 = ChartExElements.bl + "/geoLocationQuery";
    ChartExElements.a1 = ChartExElements.bl + "/geoLocationQueryResult";
    ChartExElements.a2 = ChartExElements.bl + "/geoLocationQueryResults";
    ChartExElements.a3 = ChartExElements.bl + "/geoLocations";
    ChartExElements.a4 = ChartExElements.bl + "/geoPolygon";
    ChartExElements.a5 = ChartExElements.bl + "/geoPolygons";
    ChartExElements.a6 = ChartExElements.bl + "/headerFooter";
    ChartExElements.a7 = ChartExElements.bl + "/idx";
    ChartExElements.a8 = ChartExElements.bl + "/layoutPr";
    ChartExElements.a9 = ChartExElements.bl + "/legend";
    ChartExElements.ba = ChartExElements.bl + "/lvl";
    ChartExElements.bb = ChartExElements.bl + "/majorGridlines";
    ChartExElements.bc = ChartExElements.bl + "/majorTickMarks";
    ChartExElements.bd = ChartExElements.bl + "/max";
    ChartExElements.be = ChartExElements.bl + "/maxColor";
    ChartExElements.bf = ChartExElements.bl + "/mid";
    ChartExElements.bg = ChartExElements.bl + "/midColor";
    ChartExElements.bh = ChartExElements.bl + "/min";
    ChartExElements.bi = ChartExElements.bl + "/minColor";
    ChartExElements.bj = ChartExElements.bl + "/minorGridlines";
    ChartExElements.bk = ChartExElements.bl + "/minorTickMarks";
    ChartExElements.bn = ChartExElements.bl + "/number";
    ChartExElements.bm = ChartExElements.bl + "/nf";
    ChartExElements.bo = ChartExElements.bl + "/numDim";
    ChartExElements.bp = ChartExElements.bl + "/numFmt";
    ChartExElements.bq = ChartExElements.bl + "/oddFooter";
    ChartExElements.br = ChartExElements.bl + "/oddHeader";
    ChartExElements.bs = ChartExElements.bl + "/pageMargins";
    ChartExElements.bt = ChartExElements.bl + "/pageSetup";
    ChartExElements.bu = ChartExElements.bl + "/parentLabelLayout";
    ChartExElements.bv = ChartExElements.bl + "/percent";
    ChartExElements.bw = ChartExElements.bl + "/plotArea";
    ChartExElements.bx = ChartExElements.bl + "/plotAreaRegion";
    ChartExElements.by = ChartExElements.bl + "/plotSurface";
    ChartExElements.bz = ChartExElements.bl + "/printSettings";
    ChartExElements.b0 = ChartExElements.bl + "/pt";
    ChartExElements.b1 = ChartExElements.bl + "/regionLabelLayout";
    ChartExElements.b2 = ChartExElements.bl + "/rich";
    ChartExElements.b3 = ChartExElements.bl + "/separator";
    ChartExElements.b4 = ChartExElements.bl + "/series";
    ChartExElements.b5 = ChartExElements.bl + "/spPr";
    ChartExElements.b6 = ChartExElements.bl + "/statistics";
    ChartExElements.b7 = ChartExElements.bl + "/strDim";
    ChartExElements.b8 = ChartExElements.bl + "/subtotals";
    ChartExElements.b9 = ChartExElements.bl + "/tickLabels";
    ChartExElements.ca = ChartExElements.bl + "/title";
    ChartExElements.cb = ChartExElements.bl + "/tx";
    ChartExElements.cc = ChartExElements.bl + "/txData";
    ChartExElements.cd = ChartExElements.bl + "/txPr";
    ChartExElements.ce = ChartExElements.bl + "/units";
    ChartExElements.cf = ChartExElements.bl + "/unitsLabel";
    ChartExElements.ch = ChartExElements.bl + "/valScaling";
    ChartExElements.cg = ChartExElements.bl + "/v";
    ChartExElements.ci = ChartExElements.bl + "/valueColorPositions";
    ChartExElements.cj = ChartExElements.bl + "/valueColors";
    ChartExElements.ck = ChartExElements.bl + "/visibility";
    return ChartExElements;
}(Base));
export { ChartExElements };
