/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { XmlPartManagerBase } from "./XmlPartManagerBase";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var ChartExPartManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChartExPartManager, _super);
    function ChartExPartManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ChartExPartManager.prototype.get_m = function () {
        return "application/vnd.ms-office.chartex+xml";
    };
    Object.defineProperty(ChartExPartManager.prototype, "m", {
        get: function () {
            return this.get_m();
        },
        enumerable: false,
        configurable: true
    });
    ChartExPartManager.prototype.n = function (a) {
        switch (a) {
            case 0: return "/xl/charts/chartEx.xml";
            default: return null;
        }
    };
    ChartExPartManager.prototype.o = function (a) {
        switch (a) {
            case 0: return ChartExPartManager.a6;
            case 1: return ChartExPartManager.a5;
            default: return ChartExPartManager.a6;
        }
    };
    ChartExPartManager.prototype.get_g = function () {
        return true;
    };
    Object.defineProperty(ChartExPartManager.prototype, "g", {
        get: function () {
            return this.get_g();
        },
        enumerable: false,
        configurable: true
    });
    ChartExPartManager.$t = markType(ChartExPartManager, 'ChartExPartManager', XmlPartManagerBase.$);
    ChartExPartManager.a6 = "http://schemas.microsoft.com/office/2014/relationships/chartEx";
    ChartExPartManager.a5 = "http://purl.oclc.org/ooxml/office/2014/relationships/chartEx";
    return ChartExPartManager;
}(XmlPartManagerBase));
export { ChartExPartManager };
