/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { InvalidOperationException } from "igniteui-angular-core";
import { DocCoreUtils } from "./DocCoreUtils";
import { markType } from "igniteui-angular-core";
/**
 * Represents an error that occurs when no password is used to open an encrypted document.
 */
var DocumentEncryptedException = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DocumentEncryptedException, _super);
    function DocumentEncryptedException() {
        var _rest = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            _rest[_i] = arguments[_i];
        }
        var _this = this;
        var a;
        if (arguments.length === 0) {
            a = 0;
        }
        else if (arguments.length === 1) {
            a = 1;
        }
        else if (arguments.length === 2) {
            a = 2;
        }
        switch (a) {
            case 0:
                {
                    _this = _super.call(this, 1, DocCoreUtils.aa("LE_DocumentEncryptedException_DefaultMessage")) || this;
                }
                break;
            case 1:
                {
                    var message = _rest[0];
                    _this = _super.call(this, 1, message) || this;
                }
                break;
            case 2:
                {
                    var message = _rest[0];
                    var innerException = _rest[1];
                    _this = _super.call(this, 2, message, innerException) || this;
                }
                break;
            default: throw new Error('Invalid arguments');
        }
        return _this;
    }
    DocumentEncryptedException.$t = markType(DocumentEncryptedException, 'DocumentEncryptedException', InvalidOperationException.$);
    return DocumentEncryptedException;
}(InvalidOperationException));
export { DocumentEncryptedException };
