/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, typeCast, markType } from "igniteui-angular-core";
import { WorksheetImage } from "./WorksheetImage";
import { WorksheetShapeGroup } from "./WorksheetShapeGroup";
import { ExcelUtils } from "./ExcelUtils";
import { stringFormat } from "igniteui-angular-core";
/**
 * @hidden
 */
var ObjectModelDrawingPartManager_ShapeIdentity = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ObjectModelDrawingPartManager_ShapeIdentity, _super);
    function ObjectModelDrawingPartManager_ShapeIdentity(a, b) {
        var _this = _super.call(this) || this;
        _this.c = 0;
        _this.a = null;
        _this.c = b;
        _this.a = a._b8 != null ? a._b8 : ObjectModelDrawingPartManager_ShapeIdentity.b(a, b);
        return _this;
    }
    ObjectModelDrawingPartManager_ShapeIdentity.b = function (a, b) {
        var c;
        if (typeCast(WorksheetImage.$, a) !== null) {
            c = "WorksheetShapeSerialization_ImageName";
        }
        else if (typeCast(WorksheetShapeGroup.$, a) !== null) {
            c = "WorksheetShapeSerialization_GroupName";
        }
        else {
            c = "WorksheetShapeSerialization_ShapeName";
        }
        return stringFormat("{0} {1}", ExcelUtils.ef(c), b);
    };
    ObjectModelDrawingPartManager_ShapeIdentity.$t = markType(ObjectModelDrawingPartManager_ShapeIdentity, 'ObjectModelDrawingPartManager_ShapeIdentity');
    return ObjectModelDrawingPartManager_ShapeIdentity;
}(Base));
export { ObjectModelDrawingPartManager_ShapeIdentity };
