/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { ArrayInteriorFormula } from "./ArrayInteriorFormula";
import { typeCast, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionFormulaText = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionFormulaText, _super);
    function UltraCalcFunctionFormulaText() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionFormulaText.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (!c.isReference) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(3));
        }
        var d = c.toReference();
        var e = d.value;
        var f = d.formula;
        if (f == null) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(3));
        }
        var g;
        if (typeCast(ArrayInteriorFormula.$, f) !== null) {
            g = "{" + f._cz._toString() + "}";
        }
        else {
            g = f.formulaString;
        }
        return new ExcelCalcValue(g);
    };
    UltraCalcFunctionFormulaText.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionFormulaText.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionFormulaText.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionFormulaText.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionFormulaText.prototype.get_name = function () {
        return "formulatext";
    };
    Object.defineProperty(UltraCalcFunctionFormulaText.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionFormulaText.$t = markType(UltraCalcFunctionFormulaText, 'UltraCalcFunctionFormulaText', BuiltInFunctionBase.$);
    return UltraCalcFunctionFormulaText;
}(BuiltInFunctionBase));
export { UltraCalcFunctionFormulaText };
