/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { typeCast, markType } from "igniteui-angular-core";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
/**
 * @hidden
 */
var UltraCalcFunctionIfNa = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionIfNa, _super);
    function UltraCalcFunctionIfNa() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionIfNa.prototype.evaluate = function (a, b) {
        var c = a.pop();
        var d = a.pop();
        var e = d._getResolvedValue();
        if (typeCast(ExcelCalcErrorValue.$, e) !== null && e.code == 3) {
            return c;
        }
        return new ExcelCalcValue(e);
    };
    UltraCalcFunctionIfNa.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionIfNa.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIfNa.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionIfNa.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIfNa.prototype.get_name = function () {
        return "ifna";
    };
    Object.defineProperty(UltraCalcFunctionIfNa.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIfNa.$t = markType(UltraCalcFunctionIfNa, 'UltraCalcFunctionIfNa', BuiltInFunctionBase.$);
    return UltraCalcFunctionIfNa;
}(BuiltInFunctionBase));
export { UltraCalcFunctionIfNa };
