/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { UltraCalcFunctionComplex_ComplexNumber } from "./UltraCalcFunctionComplex_ComplexNumber";
import { markType } from "igniteui-angular-core";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
/**
 * @hidden
 */
var UltraCalcFunctionImPower = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionImPower, _super);
    function UltraCalcFunctionImPower() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionImPower.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var d = c._toDouble3();
        var e = a.pop();
        if (e.isError) {
            return e;
        }
        var f = e.toString();
        var g = new UltraCalcFunctionComplex_ComplexNumber(1, a._w, f);
        if (g.y == false) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var h = g.u(d);
        if (h.y == false) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        return new ExcelCalcValue(h.toString());
    };
    UltraCalcFunctionImPower.prototype.get_name = function () {
        return "impower";
    };
    Object.defineProperty(UltraCalcFunctionImPower.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionImPower.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionImPower.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionImPower.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionImPower.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionImPower.prototype.doesParameterAllowIntermediateResultArray = function (a, b) {
        return (b == false);
    };
    UltraCalcFunctionImPower.$t = markType(UltraCalcFunctionImPower, 'UltraCalcFunctionImPower', BuiltInFunctionBase.$);
    return UltraCalcFunctionImPower;
}(BuiltInFunctionBase));
export { UltraCalcFunctionImPower };
