/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionIsNonText = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionIsNonText, _super);
    function UltraCalcFunctionIsNonText() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionIsNonText.prototype.evaluate = function (a, b) {
        var c = a.pop();
        return new ExcelCalcValue(!c.isString);
    };
    UltraCalcFunctionIsNonText.prototype.get_name = function () {
        return "isnontext";
    };
    Object.defineProperty(UltraCalcFunctionIsNonText.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsNonText.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionIsNonText.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsNonText.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionIsNonText.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsNonText.$t = markType(UltraCalcFunctionIsNonText, 'UltraCalcFunctionIsNonText', BuiltInFunctionBase.$);
    return UltraCalcFunctionIsNonText;
}(BuiltInFunctionBase));
export { UltraCalcFunctionIsNonText };
