/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { MatrixUtilities } from "./MatrixUtilities";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionMinverse = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionMinverse, _super);
    function UltraCalcFunctionMinverse() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionMinverse.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isError) {
            return c;
        }
        var d = c.toArrayProxy();
        var e = d.getLength(0);
        if (e != d.getLength(1)) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(1));
        }
        var f;
        var g = ((function () { var h = MatrixUtilities.b(d, 0, f); f = h.p2; return h.ret; })());
        if (f != null) {
            return new ExcelCalcValue(f);
        }
        var h = ((function () { var i = MatrixUtilities.a(g, e, f); f = i.p2; return i.ret; })());
        if (f != null) {
            return new ExcelCalcValue(f);
        }
        var i = ((function () {
            var $firstRank;
            var $ret = new Array($firstRank = e);
            var $currRet = $ret;
            for (var $rankInit = 0; $rankInit < $firstRank; $rankInit++) {
                $currRet[$rankInit] = new Array(e);
            }
            return $ret;
        })());
        for (var j = 0; j < e; j++) {
            for (var k = 0; k < e; k++) {
                i[j][k] = new ExcelCalcValue(h[j][k]);
            }
        }
        return new ExcelCalcValue(i);
    };
    UltraCalcFunctionMinverse.prototype.get_name = function () {
        return "minverse";
    };
    Object.defineProperty(UltraCalcFunctionMinverse.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionMinverse.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionMinverse.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionMinverse.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionMinverse.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionMinverse.$t = markType(UltraCalcFunctionMinverse, 'UltraCalcFunctionMinverse', BuiltInFunctionBase.$);
    return UltraCalcFunctionMinverse;
}(BuiltInFunctionBase));
export { UltraCalcFunctionMinverse };
