/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { CalcFunctionUtilities } from "./CalcFunctionUtilities";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
/**
 * @hidden
 */
var UltraCalcFunctionRRI = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionRRI, _super);
    function UltraCalcFunctionRRI() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionRRI.prototype.evaluate = function (a, b) {
        return CalcFunctionUtilities.i(a, true, function (c, d, e) {
            if (c <= 0) {
                return new ExcelCalcValue(new ExcelCalcErrorValue(4));
            }
            var f = Math.pow(e / d, 1 / c) - 1;
            return new ExcelCalcValue(f);
        });
    };
    UltraCalcFunctionRRI.prototype.get_maxArgs = function () {
        return 3;
    };
    Object.defineProperty(UltraCalcFunctionRRI.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRRI.prototype.get_minArgs = function () {
        return 3;
    };
    Object.defineProperty(UltraCalcFunctionRRI.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRRI.prototype.get_name = function () {
        return "rri";
    };
    Object.defineProperty(UltraCalcFunctionRRI.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRRI.$t = markType(UltraCalcFunctionRRI, 'UltraCalcFunctionRRI', BuiltInFunctionBase.$);
    return UltraCalcFunctionRRI;
}(BuiltInFunctionBase));
export { UltraCalcFunctionRRI };
