/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { CalcFunctionUtilities } from "./CalcFunctionUtilities";
/**
 * @hidden
 */
var UltraCalcFunctionSumSq = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionSumSq, _super);
    function UltraCalcFunctionSumSq() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionSumSq.prototype.evaluate = function (a, b) {
        return CalcFunctionUtilities.d(a, b, 1229, function (c) {
            if (c.count == 0) {
                return new ExcelCalcValue(0);
            }
            var d = 0;
            for (var e = 0; e < c.count; e++) {
                d += (c._inner[e] * c._inner[e]);
            }
            return new ExcelCalcValue(d);
        });
    };
    UltraCalcFunctionSumSq.prototype.get_name = function () {
        return "sumsq";
    };
    Object.defineProperty(UltraCalcFunctionSumSq.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionSumSq.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionSumSq.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionSumSq.prototype.get_maxArgs = function () {
        return 0x7FFFFFFF;
    };
    Object.defineProperty(UltraCalcFunctionSumSq.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionSumSq.$t = markType(UltraCalcFunctionSumSq, 'UltraCalcFunctionSumSq', BuiltInFunctionBase.$);
    return UltraCalcFunctionSumSq;
}(BuiltInFunctionBase));
export { UltraCalcFunctionSumSq };
