/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { MatrixUtilities } from "./MatrixUtilities";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionTranspose = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionTranspose, _super);
    function UltraCalcFunctionTranspose() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionTranspose.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isError) {
            return c;
        }
        return new ExcelCalcValue(MatrixUtilities.d(c.toArrayProxy()));
    };
    UltraCalcFunctionTranspose.prototype.get_name = function () {
        return "transpose";
    };
    Object.defineProperty(UltraCalcFunctionTranspose.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionTranspose.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionTranspose.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionTranspose.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionTranspose.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionTranspose.$t = markType(UltraCalcFunctionTranspose, 'UltraCalcFunctionTranspose', BuiltInFunctionBase.$);
    return UltraCalcFunctionTranspose;
}(BuiltInFunctionBase));
export { UltraCalcFunctionTranspose };
