/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various encryption modes that can be used to encrypt documents saved in the 2007 file formats and later.
 */
export var WorkbookEncryptionMode = /*@__PURE__*/ (function (WorkbookEncryptionMode) {
    /**
     * Standard encryption used in Excel 2007 and later
     */
    WorkbookEncryptionMode[WorkbookEncryptionMode["Standard"] = 0] = "Standard";
    /**
     * Agile encryption used in Excel 2010 and later
     */
    WorkbookEncryptionMode[WorkbookEncryptionMode["Agile"] = 1] = "Agile";
    return WorkbookEncryptionMode;
})({});
/**
 * @hidden
 */
export var WorkbookEncryptionMode_$type = markEnum('WorkbookEncryptionMode', 'Standard,0|Agile,1');
