import { Type } from "igniteui-angular-core";
/**
 * Represents the various types of the [[AverageFilter]].
 * @see [[AverageFilter.type]]
 */
export declare enum AverageFilterType {
    /**
     * Filter in values above the average of the entire range of data being filtered.
     */
    AboveAverage = 0,
    /**
     * Filter in values below the average of the entire range of data being filtered.
     */
    BelowAverage = 1
}
/**
 * @hidden
 */
export declare let AverageFilterType_$type: Type;
