import { Base, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { CT_ShapeProperties_DML } from "./CT_ShapeProperties_DML";
import { CT_TextBodyProperties_DML } from "./CT_TextBodyProperties_DML";
import { CT_TextListStyle_DML } from "./CT_TextListStyle_DML";
import { CT_ShapeStyle } from "./CT_ShapeStyle";
import { CT_OfficeArtExtensionList } from "./CT_OfficeArtExtensionList";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_DefaultShapeDefinition extends Base implements ISupportSetProperty {
    static $t: Type;
    private d;
    private f;
    private h;
    private j;
    private b;
    constructor();
    get c(): CT_ShapeProperties_DML;
    set c(a: CT_ShapeProperties_DML);
    get e(): CT_TextBodyProperties_DML;
    set e(a: CT_TextBodyProperties_DML);
    get g(): CT_TextListStyle_DML;
    set g(a: CT_TextListStyle_DML);
    get i(): CT_ShapeStyle;
    set i(a: CT_ShapeStyle);
    get a(): CT_OfficeArtExtensionList;
    set a(a: CT_OfficeArtExtensionList);
    setProperty(a: ElementPropertyIds, b: any): void;
    toString(): string;
}
