import { Base, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { CT_GvmlGraphicFrameNonVisual } from "./CT_GvmlGraphicFrameNonVisual";
import { CT_GraphicalObject } from "./CT_GraphicalObject";
import { CT_Transform2D } from "./CT_Transform2D";
import { CT_OfficeArtExtensionList } from "./CT_OfficeArtExtensionList";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_GvmlGraphicalObjectFrame extends Base implements ISupportSetProperty {
    static $t: Type;
    private b;
    private f;
    private h;
    private d;
    constructor();
    get a(): CT_GvmlGraphicFrameNonVisual;
    set a(a: CT_GvmlGraphicFrameNonVisual);
    get e(): CT_GraphicalObject;
    set e(a: CT_GraphicalObject);
    get g(): CT_Transform2D;
    set g(a: CT_Transform2D);
    get c(): CT_OfficeArtExtensionList;
    set c(a: CT_OfficeArtExtensionList);
    setProperty(a: ElementPropertyIds, b: any): void;
    toString(): string;
}
