import { Base, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { CT_GvmlShapeNonVisual } from "./CT_GvmlShapeNonVisual";
import { CT_ShapeProperties_DML } from "./CT_ShapeProperties_DML";
import { CT_GvmlTextShape } from "./CT_GvmlTextShape";
import { CT_ShapeStyle } from "./CT_ShapeStyle";
import { CT_OfficeArtExtensionList } from "./CT_OfficeArtExtensionList";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_GvmlShape extends Base implements ISupportSetProperty {
    static $t: Type;
    private b;
    private h;
    private d;
    private j;
    private f;
    constructor();
    get a(): CT_GvmlShapeNonVisual;
    set a(a: CT_GvmlShapeNonVisual);
    get g(): CT_ShapeProperties_DML;
    set g(a: CT_ShapeProperties_DML);
    get c(): CT_GvmlTextShape;
    set c(a: CT_GvmlTextShape);
    get i(): CT_ShapeStyle;
    set i(a: CT_ShapeStyle);
    get e(): CT_OfficeArtExtensionList;
    set e(a: CT_OfficeArtExtensionList);
    setProperty(a: ElementPropertyIds, b: any): void;
    toString(): string;
}
