import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum CellFormatValue {
    Alignment = 1,
    BottomBorderColorInfo = 2,
    BottomBorderStyle = 4,
    DiagonalBorderColorInfo = 8,
    DiagonalBorders = 16,
    DiagonalBorderStyle = 32,
    Fill = 64,
    FontBold = 128,
    FontColorInfo = 256,
    FontHeight = 512,
    FontItalic = 1024,
    FontName = 2048,
    FontStrikeout = 4096,
    FontSuperscriptSubscriptStyle = 8192,
    FontUnderlineStyle = 16384,
    FormatOptions = 32768,
    FormatString = 65536,
    Indent = 131072,
    LeftBorderColorInfo = 262144,
    LeftBorderStyle = 524288,
    Locked = 1048576,
    RightBorderColorInfo = 2097152,
    RightBorderStyle = 4194304,
    Rotation = 8388608,
    ShrinkToFit = 16777216,
    Style = 33554432,
    TopBorderColorInfo = 67108864,
    TopBorderStyle = 134217728,
    VerticalAlignment = 268435456,
    WrapText = 536870912,
    _EndValue = 1073741824,
    _OuterBorders = 208404486,
    _TopAndBottomBorders = 201326598,
    _UndoElementData = 33587200,
    ThemeProperties = 69470538,
    ThemeColorProperties = 69468490,
    AlignmentFormattingProperties = 830603265,
    BorderFormattingProperties = 208404542,
    FillFormattingProperties = 1073741888,
    FontFormattingProperties = 32640,
    NumberFormattingProperties = 1073807360,
    ProtectionFormattingProperties = 1074790400,
    AllFormattingProperties = 2147483647
}
/**
 * @hidden
 */
export declare let CellFormatValue_$type: Type;
