import { Type } from "igniteui-angular-core";
/**
 * Constants which determine whether <see cref="DataBarConditionalFormat">data bars</see> are filled with a solid color or
 * with a gradient.
 */
export declare enum DataBarFillType {
    /**
     * Data bars are filled with a solid color.
     */
    SolidColor = 0,
    /**
     * Data bars are filled with a linear gradient.
     */
    Gradient = 1
}
/**
 * @hidden
 */
export declare let DataBarFillType_$type: Type;
