import { Type } from "igniteui-angular-core";
/**
 * Represents the various date range types which can be filtered by the [[DatePeriodFilter]].
 * @see [[DatePeriodFilter.type]]
 */
export declare enum DatePeriodFilterType {
    /**
     * Filter in dates in a specific month of any year.
     */
    Month = 0,
    /**
     * Filter in dates in a specific quarter of any year.
     */
    Quarter = 1
}
/**
 * @hidden
 */
export declare let DatePeriodFilterType_$type: Type;
