import { Type } from "igniteui-angular-core";
/**
 * Represents the various ways a date can be stored internally.
 */
export declare enum DateSystem {
    /**
     * Dates are stored as time elapsed since 1900.
     */
    From1900 = 0,
    /**
     * Dates are stored as time elapsed since 1904 (used mainly on Apple computers).
     */
    From1904 = 1
}
/**
 * @hidden
 */
export declare let DateSystem_$type: Type;
