import { Type } from "igniteui-angular-core";
/**
 * Enumeration for font superscript or subscript style. Default value is used in property override situations.
 */
export declare enum FontSuperscriptSubscriptStyle {
    /**
     * Use the current default.
     */
    Default = -1,
    /**
     * No superscript or subscript style.
     */
    None = 0,
    /**
     * Superscript style.
     */
    Superscript = 1,
    /**
     * Subscript style.
     */
    Subscript = 2
}
/**
 * @hidden
 */
export declare let FontSuperscriptSubscriptStyle_$type: Type;
