import { List$1 } from "igniteui-angular-core";
import { IZipEntry } from "./IZipEntry";
import { WorkItem$1 } from "./WorkItem$1";
import { Stream, Type } from "igniteui-angular-core";
import { WorkItem } from "./WorkItem";
/**
 * @hidden
 */
export interface IZipFile {
    load(stream: string | Uint8Array): WorkItem$1<IZipFile>;
    _load$i(a: Stream): WorkItem$1<IZipFile>;
    save(stream: string | Uint8Array): WorkItem;
    _save$i(a: Stream): WorkItem;
    readonly entries: List$1<IZipEntry>;
    createFile(fileName: string, directoryName: string, stream: string | Uint8Array): IZipEntry;
    _createFile$i(a: string, b: string, c: Stream): IZipEntry;
}
/**
 * @hidden
 */
export declare let IZipFile_$type: Type;
