import { SystemException, BaseError, Type } from "igniteui-angular-core";
/**
 * Represents an error in which an attempt was made to treat a value as the wrong type.
 */
export declare class InvalidCastException extends SystemException {
    static $t: Type;
    constructor(message: string, innerException: BaseError);
}
