import { PackageRelationship } from "./PackageRelationship";
import { IInvalidPackageRelationshipTarget } from "./IInvalidPackageRelationshipTarget";
import { Uri } from "igniteui-angular-core";
import { RelationshipTargetMode } from "./RelationshipTargetMode";
import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class InvalidTargetPackageRelationship extends PackageRelationship implements IInvalidPackageRelationshipTarget {
    static $t: Type;
    constructor(a: Uri, b: string, c: RelationshipTargetMode, d: string, e: string);
    protected get_targetUri(): Uri;
    protected set_targetUri(a: Uri): void;
    private _targetString;
    get targetString(): string;
    set targetString(a: string);
}
