import { Base, Type } from "igniteui-angular-core";
import { IPackageRelationship } from "./IPackageRelationship";
import { Uri } from "igniteui-angular-core";
import { RelationshipTargetMode } from "./RelationshipTargetMode";
/**
 * @hidden
 */
export declare class PackageRelationship extends Base implements IPackageRelationship {
    static $t: Type;
    constructor(a: number, b: Uri, c: RelationshipTargetMode, d: string, e: string);
    constructor(a: number, b: Uri, c: Uri, d: RelationshipTargetMode, e: string, f: string);
    constructor(a: number, ..._rest: any[]);
    private _sourceUri;
    get sourceUri(): Uri;
    set sourceUri(a: Uri);
    private _targetUri;
    protected get_targetUri(): Uri;
    protected set_targetUri(a: Uri): void;
    get targetUri(): Uri;
    set targetUri(a: Uri);
    private _id;
    get id(): string;
    set id(a: string);
    private _relationshipType;
    get relationshipType(): string;
    set relationshipType(a: string);
    private _targetMode;
    get targetMode(): RelationshipTargetMode;
    set targetMode(a: RelationshipTargetMode);
}
