import { Type } from "igniteui-angular-core";
/**
 * Constants which define the label positioning for a <i>Treemap</i> chart.
 */
export declare enum ParentLabelLayout {
    /**
     * Labels are not displayed.
     */
    None = 0,
    /**
     * Labels are displayed as banners.
     */
    Banner = 1,
    /**
     * Labels are displayed with overlapping.
     */
    Overlapping = 2
}
/**
 * @hidden
 */
export declare let ParentLabelLayout_$type: Type;
