import { Type } from "igniteui-angular-core";
/**
 * Determines how blanks are displayed in a sparkline
 * @see [[SparklineGroup.displayBlanksAs]]
 */
export declare enum SparklineDisplayBlanksAs {
    /**
     * Empty cells are plotted as interpolated.
     */
    Span = 0,
    /**
     * Empty cells are not plotted.
     */
    Gap = 1,
    /**
     * Empty cells are plotted as zero.
     */
    Zero = 2
}
/**
 * @hidden
 */
export declare let SparklineDisplayBlanksAs_$type: Type;
