import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the unit of measure for [[Axis]] date/time values.
 */
export declare enum TimeUnit {
    /**
     * The Axis interval is expressed in days.
     */
    Days = 0,
    /**
     * The Axis interval is expressed in months.
     */
    Months = 1,
    /**
     * The Axis interval is expressed in years.
     */
    Years = 2
}
/**
 * @hidden
 */
export declare let TimeUnit_$type: Type;
