import { Type } from "igniteui-angular-core";
/**
 * Determines the horizontal alignment for a title
 */
export declare enum VerticalTitleAlignment {
    /**
     * The title will be aligned on the bottom
     */
    Bottom = -4107,
    /**
     * The title will be centered vertically
     */
    Center = -4108,
    /**
     * The title will be distributed
     */
    Distributed = -4117,
    /**
     * The title will be justified
     */
    Justify = -4130,
    /**
     * The title will be aligned on the top
     */
    Top = -4160
}
/**
 * @hidden
 */
export declare let VerticalTitleAlignment_$type: Type;
