import { FormulaTokenVisitor } from "./FormulaTokenVisitor";
import { FormulaToken } from "./FormulaToken";
import { BiffRecordStream } from "./BiffRecordStream";
import { Area3DToken } from "./Area3DToken";
import { AreaErrToken } from "./AreaErrToken";
import { AreaToken } from "./AreaToken";
import { ArrayToken } from "./ArrayToken";
import { AttrChooseToken } from "./AttrChooseToken";
import { AttrIfToken } from "./AttrIfToken";
import { AttrSkipToken } from "./AttrSkipToken";
import { AttrSpaceToken } from "./AttrSpaceToken";
import { AttrSumToken } from "./AttrSumToken";
import { AttrVolatileToken } from "./AttrVolatileToken";
import { BinaryOperatorToken } from "./BinaryOperatorToken";
import { BoolToken } from "./BoolToken";
import { ErrToken } from "./ErrToken";
import { ExpToken } from "./ExpToken";
import { FunctionOperator } from "./FunctionOperator";
import { FunctionVOperator } from "./FunctionVOperator";
import { IntToken } from "./IntToken";
import { MemAreaOperator } from "./MemAreaOperator";
import { MemErrOperator } from "./MemErrOperator";
import { MemFuncOperator } from "./MemFuncOperator";
import { MemNoMemOperator } from "./MemNoMemOperator";
import { MissArgToken } from "./MissArgToken";
import { NameToken } from "./NameToken";
import { NameXToken } from "./NameXToken";
import { NumberToken } from "./NumberToken";
import { ParenToken } from "./ParenToken";
import { Ref3DToken } from "./Ref3DToken";
import { RefErrToken } from "./RefErrToken";
import { RefToken } from "./RefToken";
import { StrToken } from "./StrToken";
import { StructuredTableReference } from "./StructuredTableReference";
import { TblToken } from "./TblToken";
import { UnaryOperatorToken } from "./UnaryOperatorToken";
import { FormulaContext } from "./FormulaContext";
import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class WorkbookSaveManagerExcel2003_SaveTokenVisitor extends FormulaTokenVisitor {
    static $t: Type;
    private static a4;
    private static readonly az;
    private static readonly a0;
    private a6;
    private a1;
    private a3;
    private a2;
    constructor();
    e(a: FormulaToken): void;
    g(): void;
    h(): void;
    j(a: Area3DToken): void;
    l(a: AreaErrToken): void;
    n(a: AreaToken): void;
    o(a: ArrayToken): void;
    p(a: AttrChooseToken): void;
    q(a: AttrIfToken): void;
    r(a: AttrSkipToken): void;
    s(a: AttrSpaceToken): void;
    t(a: AttrSumToken): void;
    u(a: AttrVolatileToken): void;
    v(a: BinaryOperatorToken): void;
    w(a: BoolToken): void;
    y(a: ErrToken): void;
    z(a: ExpToken): void;
    aa(a: FunctionOperator): void;
    ac(a: FunctionVOperator): void;
    ad(a: IntToken): void;
    ae(a: MemAreaOperator): void;
    af(a: MemErrOperator): void;
    ag(a: MemFuncOperator): void;
    ah(a: MemNoMemOperator): void;
    ai(a: MissArgToken): void;
    aj(a: NameToken): void;
    ak(a: NameXToken): void;
    al(a: NumberToken): void;
    an(a: ParenToken): void;
    ap(a: Ref3DToken): void;
    as(a: RefErrToken): void;
    au(a: RefToken): void;
    av(a: StrToken): void;
    aw(a: StructuredTableReference): void;
    ax(a: TblToken): void;
    ay(a: UnaryOperatorToken): void;
    static a5(a: FormulaContext, b: BiffRecordStream, c: boolean, d: FormulaToken[], e: number[]): WorkbookSaveManagerExcel2003_SaveTokenVisitor;
    private a7;
}
