import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum WorksheetProtectionType {
    Objects = 1,
    Scenarios = 2,
    FormatCells = 4,
    FormatColumns = 8,
    FormatRows = 16,
    InsertColumns = 32,
    InsertRows = 64,
    InsertHyperlinks = 128,
    DeleteColumns = 256,
    DeleteRows = 512,
    Sort = 1024,
    AutoFilter = 2048,
    PivotTables = 4096
}
/**
 * @hidden
 */
export declare let WorksheetProtectionType_$type: Type;
