import { Base, Type } from "igniteui-angular-core";
import { IEG_ColorTransformVisitor$2 } from "./IEG_ColorTransformVisitor$2";
import { Color } from "igniteui-angular-core";
import { ColorTransform_Alpha } from "./ColorTransform_Alpha";
import { ColorTransform_AlphaMod } from "./ColorTransform_AlphaMod";
import { ColorTransform_AlphaOff } from "./ColorTransform_AlphaOff";
import { ColorTransform_Blue } from "./ColorTransform_Blue";
import { ColorTransform_BlueMod } from "./ColorTransform_BlueMod";
import { ColorTransform_BlueOff } from "./ColorTransform_BlueOff";
import { ColorTransform_Comp } from "./ColorTransform_Comp";
import { ColorTransform_Gray } from "./ColorTransform_Gray";
import { ColorTransform_Green } from "./ColorTransform_Green";
import { ColorTransform_GreenMod } from "./ColorTransform_GreenMod";
import { ColorTransform_GreenOff } from "./ColorTransform_GreenOff";
import { ColorTransform_Hue } from "./ColorTransform_Hue";
import { ColorTransform_HueMod } from "./ColorTransform_HueMod";
import { ColorTransform_HueOff } from "./ColorTransform_HueOff";
import { ColorTransform_Inv } from "./ColorTransform_Inv";
import { ColorTransform_Lum } from "./ColorTransform_Lum";
import { ColorTransform_LumMod } from "./ColorTransform_LumMod";
import { ColorTransform_LumOff } from "./ColorTransform_LumOff";
import { ColorTransform_Red } from "./ColorTransform_Red";
import { ColorTransform_RedMod } from "./ColorTransform_RedMod";
import { ColorTransform_RedOff } from "./ColorTransform_RedOff";
import { ColorTransform_Sat } from "./ColorTransform_Sat";
import { ColorTransform_SatMod } from "./ColorTransform_SatMod";
import { ColorTransform_SatOff } from "./ColorTransform_SatOff";
import { ColorTransform_Shade } from "./ColorTransform_Shade";
import { ColorTransform_Tint } from "./ColorTransform_Tint";
/**
 * @hidden
 */
export declare class XlsxUtilities_ColorTransformsApplicator extends Base implements IEG_ColorTransformVisitor$2<Color, Color> {
    static $t: Type;
    static readonly a: XlsxUtilities_ColorTransformsApplicator;
    constructor();
    _visitColorTransform_Alpha$i(a: ColorTransform_Alpha, b: Color): Color;
    _visitColorTransform_AlphaMod$i(a: ColorTransform_AlphaMod, b: Color): Color;
    _visitColorTransform_AlphaOff$i(a: ColorTransform_AlphaOff, b: Color): Color;
    _visitColorTransform_Blue$i(a: ColorTransform_Blue, b: Color): Color;
    _visitColorTransform_BlueMod$i(a: ColorTransform_BlueMod, b: Color): Color;
    _visitColorTransform_BlueOff$i(a: ColorTransform_BlueOff, b: Color): Color;
    _visitColorTransform_Comp$i(a: ColorTransform_Comp, b: Color): Color;
    _visitColorTransform_Gray$i(a: ColorTransform_Gray, b: Color): Color;
    _visitColorTransform_Green$i(a: ColorTransform_Green, b: Color): Color;
    _visitColorTransform_GreenMod$i(a: ColorTransform_GreenMod, b: Color): Color;
    _visitColorTransform_GreenOff$i(a: ColorTransform_GreenOff, b: Color): Color;
    _visitColorTransform_Hue$i(a: ColorTransform_Hue, b: Color): Color;
    _visitColorTransform_HueMod$i(a: ColorTransform_HueMod, b: Color): Color;
    _visitColorTransform_HueOff$i(a: ColorTransform_HueOff, b: Color): Color;
    _visitColorTransform_Inv$i(a: ColorTransform_Inv, b: Color): Color;
    _visitColorTransform_Lum$i(a: ColorTransform_Lum, b: Color): Color;
    _visitColorTransform_LumMod$i(a: ColorTransform_LumMod, b: Color): Color;
    _visitColorTransform_LumOff$i(a: ColorTransform_LumOff, b: Color): Color;
    _visitColorTransform_Red$i(a: ColorTransform_Red, b: Color): Color;
    _visitColorTransform_RedMod$i(a: ColorTransform_RedMod, b: Color): Color;
    _visitColorTransform_RedOff$i(a: ColorTransform_RedOff, b: Color): Color;
    _visitColorTransform_Sat$i(a: ColorTransform_Sat, b: Color): Color;
    _visitColorTransform_SatMod$i(a: ColorTransform_SatMod, b: Color): Color;
    _visitColorTransform_SatOff$i(a: ColorTransform_SatOff, b: Color): Color;
    _visitColorTransform_Shade$i(a: ColorTransform_Shade, b: Color): Color;
    _visitColorTransform_Tint$i(a: ColorTransform_Tint, b: Color): Color;
    private static c;
    private static b;
}
