/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let CalendarUtilities = /*@__PURE__*/ (() => {
    class CalendarUtilities extends Base {
        static b(a) {
            return a.eras.length;
        }
        static a(a) {
            if (a == null) {
                return 0;
            }
            let b = a.name.toLowerCase();
            switch (b) {
                case "af": return 54;
                case "af-za": return 1078;
                case "am": return 94;
                case "am-et": return 1118;
                case "ar": return 1;
                case "ar-ae": return 14337;
                case "ar-bh": return 15361;
                case "ar-dz": return 5121;
                case "ar-eg": return 3073;
                case "ar-iq": return 2049;
                case "ar-jo": return 11265;
                case "ar-kw": return 13313;
                case "ar-lb": return 12289;
                case "ar-ly": return 4097;
                case "ar-ma": return 6145;
                case "ar-om": return 8193;
                case "ar-qa": return 16385;
                case "ar-sa": return 1025;
                case "ar-sy": return 10241;
                case "ar-tn": return 7169;
                case "ar-ye": return 9217;
                case "arn": return 122;
                case "arn-cl": return 1146;
                case "as": return 77;
                case "as-in": return 1101;
                case "az": return 44;
                case "az-cyrl": return 29740;
                case "az-cyrl-az": return 2092;
                case "az-latn": return 30764;
                case "az-latn-az": return 1068;
                case "ba": return 109;
                case "ba-ru": return 1133;
                case "be": return 35;
                case "be-by": return 1059;
                case "bg": return 2;
                case "bg-bg": return 1026;
                case "bin": return 102;
                case "bin-ng": return 1126;
                case "bn": return 69;
                case "bn-bd": return 2117;
                case "bn-in": return 1093;
                case "bo": return 81;
                case "bo-cn": return 1105;
                case "br": return 126;
                case "br-fr": return 1150;
                case "bs": return 30746;
                case "bs-cyrl": return 25626;
                case "bs-cyrl-ba": return 8218;
                case "bs-latn": return 26650;
                case "bs-latn-ba": return 5146;
                case "ca": return 3;
                case "ca-es": return 1027;
                case "ca-es-valencia": return 2051;
                case "chr": return 92;
                case "chr-cher": return 31836;
                case "chr-cher-us": return 1116;
                case "co": return 131;
                case "co-fr": return 1155;
                case "cs": return 5;
                case "cs-cz": return 1029;
                case "cy": return 82;
                case "cy-gb": return 1106;
                case "da": return 6;
                case "da-dk": return 1030;
                case "de": return 7;
                case "de-at": return 3079;
                case "de-ch": return 2055;
                case "de-de": return 1031;
                case "de-li": return 5127;
                case "de-lu": return 4103;
                case "dsb": return 31790;
                case "dsb-de": return 2094;
                case "dv": return 101;
                case "dv-mv": return 1125;
                case "dz-bt": return 3153;
                case "el": return 8;
                case "el-gr": return 1032;
                case "en": return 9;
                case "en-029": return 9225;
                case "en-au": return 3081;
                case "en-bz": return 10249;
                case "en-ca": return 4105;
                case "en-gb": return 2057;
                case "en-hk": return 15369;
                case "en-id": return 14345;
                case "en-ie": return 6153;
                case "en-in": return 16393;
                case "en-jm": return 8201;
                case "en-my": return 17417;
                case "en-nz": return 5129;
                case "en-ph": return 13321;
                case "en-sg": return 18441;
                case "en-tt": return 11273;
                case "en-us": return 1033;
                case "en-za": return 7177;
                case "en-zw": return 12297;
                case "es": return 10;
                case "es-419": return 22538;
                case "es-ar": return 11274;
                case "es-bo": return 16394;
                case "es-cl": return 13322;
                case "es-co": return 9226;
                case "es-cr": return 5130;
                case "es-cu": return 23562;
                case "es-do": return 7178;
                case "es-ec": return 12298;
                case "es-es": return 3082;
                case "es-gt": return 4106;
                case "es-hn": return 18442;
                case "es-mx": return 2058;
                case "es-ni": return 19466;
                case "es-pa": return 6154;
                case "es-pe": return 10250;
                case "es-pr": return 20490;
                case "es-py": return 15370;
                case "es-sv": return 17418;
                case "es-us": return 21514;
                case "es-uy": return 14346;
                case "es-ve": return 8202;
                case "et": return 37;
                case "et-ee": return 1061;
                case "eu": return 45;
                case "eu-es": return 1069;
                case "fa": return 41;
                case "fa-ir": return 1065;
                case "ff": return 103;
                case "ff-latn": return 31847;
                case "ff-latn-sn": return 2151;
                case "ff-ng": return 1127;
                case "fi": return 11;
                case "fi-fi": return 1035;
                case "fil": return 100;
                case "fil-ph": return 1124;
                case "fo": return 56;
                case "fo-fo": return 1080;
                case "fr": return 12;
                case "fr-029": return 7180;
                case "fr-be": return 2060;
                case "fr-ca": return 3084;
                case "fr-cd": return 9228;
                case "fr-ch": return 4108;
                case "fr-ci": return 12300;
                case "fr-cm": return 11276;
                case "fr-fr": return 1036;
                case "fr-ht": return 15372;
                case "fr-lu": return 5132;
                case "fr-ma": return 14348;
                case "fr-mc": return 6156;
                case "fr-ml": return 13324;
                case "fr-re": return 8204;
                case "fr-sn": return 10252;
                case "fy": return 98;
                case "fy-nl": return 1122;
                case "ga": return 60;
                case "ga-ie": return 2108;
                case "gd": return 145;
                case "gd-gb": return 1169;
                case "gl": return 86;
                case "gl-es": return 1110;
                case "gn": return 116;
                case "gn-py": return 1140;
                case "gsw": return 132;
                case "gsw-fr": return 1156;
                case "gu": return 71;
                case "gu-in": return 1095;
                case "ha": return 104;
                case "ha-latn": return 31848;
                case "ha-latn-ng": return 1128;
                case "haw": return 117;
                case "haw-us": return 1141;
                case "he": return 13;
                case "he-il": return 1037;
                case "hi": return 57;
                case "hi-in": return 1081;
                case "hr": return 26;
                case "hr-ba": return 4122;
                case "hr-hr": return 1050;
                case "hsb": return 46;
                case "hsb-de": return 1070;
                case "hu": return 14;
                case "hu-hu": return 1038;
                case "hy": return 43;
                case "hy-am": return 1067;
                case "ibb": return 105;
                case "ibb-ng": return 1129;
                case "id": return 33;
                case "id-id": return 1057;
                case "ig": return 112;
                case "ig-ng": return 1136;
                case "ii": return 120;
                case "ii-cn": return 1144;
                case "is": return 15;
                case "is-is": return 1039;
                case "it": return 16;
                case "it-ch": return 2064;
                case "it-it": return 1040;
                case "iu": return 93;
                case "iu-cans": return 30813;
                case "iu-cans-ca": return 1117;
                case "iu-latn": return 31837;
                case "iu-latn-ca": return 2141;
                case "ja": return 17;
                case "ja-jp": return 1041;
                case "ka": return 55;
                case "ka-ge": return 1079;
                case "kk": return 63;
                case "kk-kz": return 1087;
                case "kl": return 111;
                case "kl-gl": return 1135;
                case "km": return 83;
                case "km-kh": return 1107;
                case "kn": return 75;
                case "kn-in": return 1099;
                case "ko": return 18;
                case "ko-kr": return 1042;
                case "kok": return 87;
                case "kok-in": return 1111;
                case "kr": return 113;
                case "kr-ng": return 1137;
                case "ks": return 96;
                case "ks-arab": return 1120;
                case "ks-deva-in": return 2144;
                case "ku": return 146;
                case "ku-arab": return 31890;
                case "ku-arab-iq": return 1170;
                case "ky": return 64;
                case "ky-kg": return 1088;
                case "la": return 118;
                case "la-001": return 1142;
                case "lb": return 110;
                case "lb-lu": return 1134;
                case "lo": return 84;
                case "lo-la": return 1108;
                case "lt": return 39;
                case "lt-lt": return 1063;
                case "lv": return 38;
                case "lv-lv": return 1062;
                case "mi": return 129;
                case "mi-nz": return 1153;
                case "mk": return 47;
                case "mk-mk": return 1071;
                case "ml": return 76;
                case "ml-in": return 1100;
                case "mn": return 80;
                case "mn-cyrl": return 30800;
                case "mn-mn": return 1104;
                case "mn-mong": return 31824;
                case "mn-mong-cn": return 2128;
                case "mn-mong-mn": return 3152;
                case "mni": return 88;
                case "mni-in": return 1112;
                case "moh": return 124;
                case "moh-ca": return 1148;
                case "mr": return 78;
                case "mr-in": return 1102;
                case "ms": return 62;
                case "ms-bn": return 2110;
                case "ms-my": return 1086;
                case "mt": return 58;
                case "mt-mt": return 1082;
                case "my": return 85;
                case "my-mm": return 1109;
                case "nb": return 31764;
                case "nb-no": return 1044;
                case "ne": return 97;
                case "ne-in": return 2145;
                case "ne-np": return 1121;
                case "nl": return 19;
                case "nl-be": return 2067;
                case "nl-nl": return 1043;
                case "nn": return 30740;
                case "nn-no": return 2068;
                case "no": return 20;
                case "nso": return 108;
                case "nso-za": return 1132;
                case "oc": return 130;
                case "oc-fr": return 1154;
                case "om": return 114;
                case "om-et": return 1138;
                case "or": return 72;
                case "or-in": return 1096;
                case "pa": return 70;
                case "pa-arab": return 31814;
                case "pa-arab-pk": return 2118;
                case "pa-in": return 1094;
                case "pap": return 121;
                case "pap-029": return 1145;
                case "pl": return 21;
                case "pl-pl": return 1045;
                case "prs": return 140;
                case "prs-af": return 1164;
                case "ps": return 99;
                case "ps-af": return 1123;
                case "pt": return 22;
                case "pt-br": return 1046;
                case "pt-pt": return 2070;
                case "quc": return 134;
                case "quc-latn": return 31878;
                case "quc-latn-gt": return 1158;
                case "quz": return 107;
                case "quz-bo": return 1131;
                case "quz-ec": return 2155;
                case "quz-pe": return 3179;
                case "rm": return 23;
                case "rm-ch": return 1047;
                case "ro": return 24;
                case "ro-md": return 2072;
                case "ro-ro": return 1048;
                case "ru": return 25;
                case "ru-md": return 2073;
                case "ru-ru": return 1049;
                case "rw": return 135;
                case "rw-rw": return 1159;
                case "sa": return 79;
                case "sa-in": return 1103;
                case "sah": return 133;
                case "sah-ru": return 1157;
                case "sd": return 89;
                case "sd-arab": return 31833;
                case "sd-arab-pk": return 2137;
                case "sd-deva-in": return 1113;
                case "se": return 59;
                case "se-fi": return 3131;
                case "se-no": return 1083;
                case "se-se": return 2107;
                case "si": return 91;
                case "si-lk": return 1115;
                case "sk": return 27;
                case "sk-sk": return 1051;
                case "sl": return 36;
                case "sl-si": return 1060;
                case "sma": return 30779;
                case "sma-no": return 6203;
                case "sma-se": return 7227;
                case "smj": return 31803;
                case "smj-no": return 4155;
                case "smj-se": return 5179;
                case "smn": return 28731;
                case "smn-fi": return 9275;
                case "sms": return 29755;
                case "sms-fi": return 8251;
                case "so": return 119;
                case "so-so": return 1143;
                case "sq": return 28;
                case "sq-al": return 1052;
                case "sr": return 31770;
                case "sr-cyrl": return 27674;
                case "sr-cyrl-ba": return 7194;
                case "sr-cyrl-me": return 12314;
                case "sr-cyrl-rs": return 10266;
                case "sr-latn": return 28698;
                case "sr-latn-ba": return 6170;
                case "sr-latn-me": return 11290;
                case "sr-latn-rs": return 9242;
                case "st": return 48;
                case "st-za": return 1072;
                case "sv": return 29;
                case "sv-fi": return 2077;
                case "sv-se": return 1053;
                case "sw": return 65;
                case "sw-ke": return 1089;
                case "syr": return 90;
                case "syr-sy": return 1114;
                case "ta": return 73;
                case "ta-in": return 1097;
                case "ta-lk": return 2121;
                case "te": return 74;
                case "te-in": return 1098;
                case "tg": return 40;
                case "tg-cyrl": return 31784;
                case "tg-cyrl-tj": return 1064;
                case "th": return 30;
                case "th-th": return 1054;
                case "ti": return 115;
                case "ti-er": return 2163;
                case "ti-et": return 1139;
                case "tk": return 66;
                case "tk-tm": return 1090;
                case "tn": return 50;
                case "tn-bw": return 2098;
                case "tn-za": return 1074;
                case "tr": return 31;
                case "tr-tr": return 1055;
                case "ts": return 49;
                case "ts-za": return 1073;
                case "tt": return 68;
                case "tt-ru": return 1092;
                case "tzm": return 95;
                case "tzm-arab-ma": return 1119;
                case "tzm-latn": return 31839;
                case "tzm-latn-dz": return 2143;
                case "tzm-tfng": return 30815;
                case "tzm-tfng-ma": return 4191;
                case "ug": return 128;
                case "ug-cn": return 1152;
                case "uk": return 34;
                case "uk-ua": return 1058;
                case "ur": return 32;
                case "ur-in": return 2080;
                case "ur-pk": return 1056;
                case "uz": return 67;
                case "uz-cyrl": return 30787;
                case "uz-cyrl-uz": return 2115;
                case "uz-latn": return 31811;
                case "uz-latn-uz": return 1091;
                case "ve": return 51;
                case "ve-za": return 1075;
                case "vi": return 42;
                case "vi-vn": return 1066;
                case "wo": return 136;
                case "wo-sn": return 1160;
                case "xh": return 52;
                case "xh-za": return 1076;
                case "yi": return 61;
                case "yi-001": return 1085;
                case "yo": return 106;
                case "yo-ng": return 1130;
                case "zh": return 30724;
                case "zh-cn": return 2052;
                case "zh-hans": return 4;
                case "zh-hant": return 31748;
                case "zh-hk": return 3076;
                case "zh-mo": return 5124;
                case "zh-sg": return 4100;
                case "zh-tw": return 1028;
                case "zu": return 53;
                case "zu-za": return 1077;
                case "zh-chs": return 4;
                case "zh-cht": return 31748;
            }
            return 0;
        }
    }
    CalendarUtilities.$t = markType(CalendarUtilities, 'CalendarUtilities');
    return CalendarUtilities;
})();
