/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-angular-core";
/**
 * Exposes the information necessary for drawing an icon for a specific cell.
 * @see [[CellConditionalFormat]]
 */
export let CellIconInfo = /*@__PURE__*/ (() => {
    class CellIconInfo extends Base {
        constructor(a, b, c, d) {
            super();
            this._e = false;
            this._g = 0;
            this._a = 0;
            this._c = 0;
            this._c = a;
            this._a = b;
            this._g = c;
            this._e = d;
        }
        /**
         * The icon to be drawn (read-only).
         */
        get icon() {
            return this._a;
        }
        /**
         * The index of the icon in the icon set (read-only).
         */
        get iconIndex() {
            return this._g;
        }
        /**
         * The icon set (read-only).
         */
        get iconSet() {
            return this._c;
        }
        /**
         * Returns whether the cell value is to be shown along with the data bar (read-only).
         */
        get showValue() {
            return this._e;
        }
    }
    CellIconInfo.$t = markType(CellIconInfo, 'CellIconInfo');
    return CellIconInfo;
})();
