/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which define how blank cell values are plotted on the chart.
 */
export var DisplayBlanksAs = /*@__PURE__*/ (function (DisplayBlanksAs) {
    /**
     * Points representing blank cell values are not plotted on the chart.
     */
    DisplayBlanksAs[DisplayBlanksAs["NotPlotted"] = 1] = "NotPlotted";
    /**
     * Blank cell values are interpreted as having a value of zero.
     */
    DisplayBlanksAs[DisplayBlanksAs["Zero"] = 2] = "Zero";
    /**
     * The value is interpolated from adjacent values.
     */
    DisplayBlanksAs[DisplayBlanksAs["Interpolated"] = 3] = "Interpolated";
    return DisplayBlanksAs;
})({});
/**
 * @hidden
 */
export let DisplayBlanksAs_$type = markEnum('DisplayBlanksAs', 'NotPlotted,1|Zero,2|Interpolated,3');
