/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which define the manner in which colors are used
 * to depict series values in a geographic map chart.
 */
export var GeographicMapSeriesColor = /*@__PURE__*/ (function (GeographicMapSeriesColor) {
    /**
     * Two colors define the minimum and maximum series values.
     */
    GeographicMapSeriesColor[GeographicMapSeriesColor["Sequential"] = 0] = "Sequential";
    /**
     * Three colors define the minimum, midpoint, and maximum series values.
     */
    GeographicMapSeriesColor[GeographicMapSeriesColor["Diverging"] = 1] = "Diverging";
    return GeographicMapSeriesColor;
})({});
/**
 * @hidden
 */
export let GeographicMapSeriesColor_$type = markEnum('GeographicMapSeriesColor', 'Sequential,0|Diverging,1');
