/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { PackageRelationship } from "./PackageRelationship";
import { IInvalidPackageRelationshipTarget_$type } from "./IInvalidPackageRelationshipTarget";
import { Uri } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let InvalidTargetPackageRelationship = /*@__PURE__*/ (() => {
    class InvalidTargetPackageRelationship extends PackageRelationship {
        constructor(a, b, c, d, e) {
            super(1, a, null, c, d, e);
            this._targetString = null;
            this.targetString = b;
        }
        get_targetUri() {
            if (this.targetString != null && super.get_targetUri() == null) {
                this.targetUri = new Uri(1, this.targetString, 0);
            }
            return super.get_targetUri();
        }
        set_targetUri(a) {
            super.set_targetUri(a);
        }
        get targetString() {
            return this._targetString;
        }
        set targetString(a) {
            this._targetString = a;
        }
    }
    InvalidTargetPackageRelationship.$t = markType(InvalidTargetPackageRelationship, 'InvalidTargetPackageRelationship', PackageRelationship.$, [IInvalidPackageRelationshipTarget_$type]);
    return InvalidTargetPackageRelationship;
})();
