/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, markType } from "igniteui-angular-core";
import { WorksheetImage } from "./WorksheetImage";
import { WorksheetShapeGroup } from "./WorksheetShapeGroup";
import { ExcelUtils } from "./ExcelUtils";
import { stringFormat } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ObjectModelDrawingPartManager_ShapeIdentity = /*@__PURE__*/ (() => {
    class ObjectModelDrawingPartManager_ShapeIdentity extends Base {
        constructor(a, b) {
            super();
            this.c = 0;
            this.a = null;
            this.c = b;
            this.a = a._b8 != null ? a._b8 : ObjectModelDrawingPartManager_ShapeIdentity.b(a, b);
        }
        static b(a, b) {
            let c;
            if (typeCast(WorksheetImage.$, a) !== null) {
                c = "WorksheetShapeSerialization_ImageName";
            }
            else if (typeCast(WorksheetShapeGroup.$, a) !== null) {
                c = "WorksheetShapeSerialization_GroupName";
            }
            else {
                c = "WorksheetShapeSerialization_ShapeName";
            }
            return stringFormat("{0} {1}", ExcelUtils.ef(c), b);
        }
    }
    ObjectModelDrawingPartManager_ShapeIdentity.$t = markType(ObjectModelDrawingPartManager_ShapeIdentity, 'ObjectModelDrawingPartManager_ShapeIdentity');
    return ObjectModelDrawingPartManager_ShapeIdentity;
})();
