/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the page orientations available when a worksheet is printed.
 */
export var Orientation = /*@__PURE__*/ (function (Orientation) {
    /**
     * The page is printed with the larger dimension horizontal.
     */
    Orientation[Orientation["Landscape"] = 0] = "Landscape";
    /**
     * The page is printed with the larger dimension vertical.
     */
    Orientation[Orientation["Portrait"] = 1] = "Portrait";
    /**
     * The page is printed with the default setting.
     */
    Orientation[Orientation["Default"] = 2] = "Default";
    return Orientation;
})({});
/**
 * @hidden
 */
export let Orientation_$type = markEnum('Orientation', 'Landscape,0|Portrait,1|Default,2');
