/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which describe whether text is allowed to continue
 * horizontally outside the bounds of the containing element.
 */
export var TextHorizontalOverflow = /*@__PURE__*/ (function (TextHorizontalOverflow) {
    /**
     * The text is clipped by the containing element.
     */
    TextHorizontalOverflow[TextHorizontalOverflow["Clip"] = 0] = "Clip";
    /**
     * The text is allowed to continue outside the bounds
     * of the containing element.
     */
    TextHorizontalOverflow[TextHorizontalOverflow["Overflow"] = 1] = "Overflow";
    return TextHorizontalOverflow;
})({});
/**
 * @hidden
 */
export let TextHorizontalOverflow_$type = markEnum('TextHorizontalOverflow', 'Clip,0|Overflow,1');
