/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Comparer$1 } from "igniteui-angular-core";
import { Number_$type, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let Utilities_Int16Comparer = /*@__PURE__*/ (() => {
    class Utilities_Int16Comparer extends Comparer$1 {
        constructor() {
            super(Number_$type);
        }
        compare(a, b) {
            if (a < b) {
                return -1;
            }
            if (b < a) {
                return 1;
            }
            return 0;
        }
    }
    Utilities_Int16Comparer.$t = markType(Utilities_Int16Comparer, 'Utilities_Int16Comparer', Comparer$1.$.specialize(Number_$type));
    Utilities_Int16Comparer._c = new Utilities_Int16Comparer();
    return Utilities_Int16Comparer;
})();
