/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various types of the [[AverageFilter]].
 * @see [[AverageFilter.type]]
 */
export var AverageFilterType = /*@__PURE__*/ (function (AverageFilterType) {
    /**
     * Filter in values above the average of the entire range of data being filtered.
     */
    AverageFilterType[AverageFilterType["AboveAverage"] = 0] = "AboveAverage";
    /**
     * Filter in values below the average of the entire range of data being filtered.
     */
    AverageFilterType[AverageFilterType["BelowAverage"] = 1] = "BelowAverage";
    return AverageFilterType;
})({});
/**
 * @hidden
 */
export var AverageFilterType_$type = markEnum('AverageFilterType', 'AboveAverage,0|BelowAverage,1');
