/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Specifies the axis type.
 */
export var AxisType = /*@__PURE__*/ (function (AxisType) {
    /**
     * Axis displays categories.
     */
    AxisType[AxisType["Category"] = 1] = "Category";
    /**
     * Axis displays values.
     */
    AxisType[AxisType["Value"] = 2] = "Value";
    /**
     * Axis displays data series along the Z-axis (3D charts only).
     */
    AxisType[AxisType["SeriesAxis"] = 3] = "SeriesAxis";
    return AxisType;
})({});
/**
 * @hidden
 */
export var AxisType_$type = markEnum('AxisType', 'Category,1|Value,2|SeriesAxis,3');
