/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, typeCast, markType, getInstanceType } from "igniteui-angular-core";
import { ISupportSetProperty_$type } from "./ISupportSetProperty";
import { List$1 } from "igniteui-angular-core";
import { CT_Cfvo } from "./CT_Cfvo";
import { ColorInfo } from "./ColorInfo";
/**
 * @hidden
 */
var CT_ColorScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CT_ColorScale, _super);
    function CT_ColorScale() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.b = null;
        _this.a = new List$1(CT_Cfvo.$, 0);
        _this.b = new List$1(ColorInfo.$, 0);
        return _this;
    }
    CT_ColorScale.prototype.setProperty = function (a, b) {
        switch (a) {
            case 252:
                this.a.add(typeCast(CT_Cfvo.$, b));
                break;
            case 302:
                this.b.add(typeCast(ColorInfo.$, b));
                break;
            default: break;
        }
    };
    CT_ColorScale.prototype.toString = function () {
        var a = getInstanceType(this);
        return a != null ? a.typeName : _super.prototype.toString.call(this);
    };
    CT_ColorScale.$t = markType(CT_ColorScale, 'CT_ColorScale', Base.$, [ISupportSetProperty_$type]);
    return CT_ColorScale;
}(Base));
export { CT_ColorScale };
