/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DrawingNamespaceDefinitionBase } from "./DrawingNamespaceDefinitionBase";
import { fromEnum, markType } from "igniteui-angular-core";
import { ST_Coordinate } from "./ST_Coordinate";
import { ST_OnOff } from "./ST_OnOff";
import { XmlNamespaceDefinitionBase } from "./XmlNamespaceDefinitionBase";
import { DrawingMLMain } from "./DrawingMLMain";
import { ST_EditAs_$type } from "./ST_EditAs";
/**
 * @hidden
 */
var DrawingMLSpreadsheetDrawing = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DrawingMLSpreadsheetDrawing, _super);
    function DrawingMLSpreadsheetDrawing() {
        return _super.call(this, DrawingMLSpreadsheetDrawing.dq, DrawingMLSpreadsheetDrawing.dr) || this;
    }
    DrawingMLSpreadsheetDrawing.prototype.get_j = function () {
        return "xdr";
    };
    Object.defineProperty(DrawingMLSpreadsheetDrawing.prototype, "j", {
        get: function () {
            return this.get_j();
        },
        enumerable: false,
        configurable: true
    });
    DrawingMLSpreadsheetDrawing.eq = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                switch (c.a.e(a.d)) {
                    default: break;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    DrawingMLSpreadsheetDrawing.e5 = function (a, b) {
        a.ad.p(b, "xdr");
    };
    DrawingMLSpreadsheetDrawing.ex = function (a, b, c) {
        var e_2, _a;
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                switch (d.a.e(a.d)) {
                    default: break;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        c = ST_Coordinate.h(a.ab.ad);
        return {
            p2: c
        };
    };
    DrawingMLSpreadsheetDrawing.fc = function (a, b, c) {
        a.ad.p(b, "xdr");
        a.ad.u(c.toString());
    };
    DrawingMLSpreadsheetDrawing.em = function (a) {
        var e_3, _a;
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                switch (b.a.e(a.d)) {
                    default: break;
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
    };
    DrawingMLSpreadsheetDrawing.e1 = function (a) {
        a.ad.p(DrawingMLSpreadsheetDrawing.ds, "xdr");
    };
    DrawingMLSpreadsheetDrawing.en = function (a, b, c) {
        var e_4, _a;
        b = true;
        c = true;
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                switch (d.a.e(a.d)) {
                    case "fLocksWithSheet":
                        b = ST_OnOff.e(d.d);
                        break;
                    case "fPrintsWithSheet":
                        c = ST_OnOff.e(d.d);
                        break;
                    default: break;
                }
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        return {
            p1: b,
            p2: c
        };
    };
    DrawingMLSpreadsheetDrawing.e2 = function (a, b, c) {
        if (b === void 0) {
            b = true;
        }
        if (c === void 0) {
            c = true;
        }
        a.ad.p(DrawingMLSpreadsheetDrawing.dt, "xdr");
        var d;
        if (b != true) {
            d = ST_OnOff.g(b);
            a.ad.h("fLocksWithSheet", d);
        }
        if (c != true) {
            d = ST_OnOff.g(c);
            a.ad.h("fPrintsWithSheet", d);
        }
    };
    DrawingMLSpreadsheetDrawing.eo = function (a, b) {
        var c = XmlNamespaceDefinitionBase.r(a, DrawingMLSpreadsheetDrawing.dw, b);
        b = c.p2;
        return {
            p1: b
        };
    };
    DrawingMLSpreadsheetDrawing.e3 = function (a, b) {
        XmlNamespaceDefinitionBase.af(a, DrawingMLSpreadsheetDrawing.dw, "xdr", b);
    };
    DrawingMLSpreadsheetDrawing.ep = function (a, b) {
        var c = DrawingMLSpreadsheetDrawing.ex(a, DrawingMLSpreadsheetDrawing.dx, b);
        b = c.p2;
        return {
            p1: b
        };
    };
    DrawingMLSpreadsheetDrawing.e4 = function (a, b) {
        DrawingMLSpreadsheetDrawing.fc(a, DrawingMLSpreadsheetDrawing.dx, b);
    };
    DrawingMLSpreadsheetDrawing.er = function (a, b, c) {
        var d = DrawingMLMain.k5(a, DrawingMLSpreadsheetDrawing.d0, b, c);
        b = d.p2;
        c = d.p3;
        return {
            p1: b,
            p2: c
        };
    };
    DrawingMLSpreadsheetDrawing.e6 = function (a, b, c) {
        DrawingMLMain.n6(a, DrawingMLSpreadsheetDrawing.d0, b, c);
    };
    DrawingMLSpreadsheetDrawing.es = function (a) {
    };
    DrawingMLSpreadsheetDrawing.e7 = function (a) {
        DrawingMLSpreadsheetDrawing.e5(a, DrawingMLSpreadsheetDrawing.d3);
    };
    DrawingMLSpreadsheetDrawing.et = function (a) {
        var e_5, _a;
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                switch (b.a.e(a.d)) {
                    default: break;
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
    };
    DrawingMLSpreadsheetDrawing.e8 = function (a) {
        a.ad.p(DrawingMLSpreadsheetDrawing.ea, "xdr");
    };
    DrawingMLSpreadsheetDrawing.eu = function (a, b, c) {
        var d = DrawingMLMain.k1(a, DrawingMLSpreadsheetDrawing.ec, b, c);
        b = d.p2;
        c = d.p3;
        return {
            p1: b,
            p2: c
        };
    };
    DrawingMLSpreadsheetDrawing.e9 = function (a, b, c) {
        DrawingMLMain.n2(a, DrawingMLSpreadsheetDrawing.ec, b, c);
    };
    DrawingMLSpreadsheetDrawing.ev = function (a, b) {
        var c = XmlNamespaceDefinitionBase.r(a, DrawingMLSpreadsheetDrawing.ed, b);
        b = c.p2;
        return {
            p1: b
        };
    };
    DrawingMLSpreadsheetDrawing.fa = function (a, b) {
        XmlNamespaceDefinitionBase.af(a, DrawingMLSpreadsheetDrawing.ed, "xdr", b);
    };
    DrawingMLSpreadsheetDrawing.ew = function (a, b) {
        var c = DrawingMLSpreadsheetDrawing.ex(a, DrawingMLSpreadsheetDrawing.ee, b);
        b = c.p2;
        return {
            p1: b
        };
    };
    DrawingMLSpreadsheetDrawing.fb = function (a, b) {
        DrawingMLSpreadsheetDrawing.fc(a, DrawingMLSpreadsheetDrawing.ee, b);
    };
    DrawingMLSpreadsheetDrawing.ey = function (a) {
    };
    DrawingMLSpreadsheetDrawing.fd = function (a) {
        DrawingMLSpreadsheetDrawing.e5(a, DrawingMLSpreadsheetDrawing.ei);
    };
    DrawingMLSpreadsheetDrawing.ez = function (a, b) {
        var e_6, _a;
        b = 0;
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                switch (c.a.e(a.d)) {
                    case "editAs":
                        b = XmlNamespaceDefinitionBase.b(ST_EditAs_$type, c.d, b);
                        break;
                    default: break;
                }
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
        return {
            p1: b
        };
    };
    DrawingMLSpreadsheetDrawing.fe = function (a, b) {
        if (b === void 0) {
            b = 0;
        }
        a.ad.p(DrawingMLSpreadsheetDrawing.ej, "xdr");
        var c;
        if (b != 0) {
            c = XmlNamespaceDefinitionBase.f(ST_EditAs_$type, b);
            a.ad.h("editAs", c);
        }
    };
    DrawingMLSpreadsheetDrawing.e0 = function (a) {
        var e_7, _a;
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                switch (b.a.e(a.d)) {
                    default: break;
                }
            }
        }
        catch (e_7_1) {
            e_7 = { error: e_7_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_7)
                    throw e_7.error;
            }
        }
    };
    DrawingMLSpreadsheetDrawing.ff = function (a) {
        a.ad.p(DrawingMLSpreadsheetDrawing.el, "xdr");
        var b = a.d._z;
        a.ad.l(DrawingMLMain.an);
        a.ad.l(DrawingMLSpreadsheetDrawing.dn);
    };
    DrawingMLSpreadsheetDrawing.$t = markType(DrawingMLSpreadsheetDrawing, 'DrawingMLSpreadsheetDrawing', DrawingNamespaceDefinitionBase.$);
    DrawingMLSpreadsheetDrawing.dr = "http://schemas.openxmlformats.org/drawingml/2006/spreadsheetDrawing";
    DrawingMLSpreadsheetDrawing.dq = "http://purl.oclc.org/ooxml/drawingml/spreadsheetDrawing";
    DrawingMLSpreadsheetDrawing.ds = DrawingMLSpreadsheetDrawing.dq + "/absoluteAnchor";
    DrawingMLSpreadsheetDrawing.dt = DrawingMLSpreadsheetDrawing.dq + "/clientData";
    DrawingMLSpreadsheetDrawing.dw = DrawingMLSpreadsheetDrawing.dq + "/col";
    DrawingMLSpreadsheetDrawing.dx = DrawingMLSpreadsheetDrawing.dq + "/colOff";
    DrawingMLSpreadsheetDrawing.d0 = DrawingMLSpreadsheetDrawing.dq + "/ext";
    DrawingMLSpreadsheetDrawing.d3 = DrawingMLSpreadsheetDrawing.dq + "/from";
    DrawingMLSpreadsheetDrawing.ea = DrawingMLSpreadsheetDrawing.dq + "/oneCellAnchor";
    DrawingMLSpreadsheetDrawing.ec = DrawingMLSpreadsheetDrawing.dq + "/pos";
    DrawingMLSpreadsheetDrawing.ed = DrawingMLSpreadsheetDrawing.dq + "/row";
    DrawingMLSpreadsheetDrawing.ee = DrawingMLSpreadsheetDrawing.dq + "/rowOff";
    DrawingMLSpreadsheetDrawing.ei = DrawingMLSpreadsheetDrawing.dq + "/to";
    DrawingMLSpreadsheetDrawing.ej = DrawingMLSpreadsheetDrawing.dq + "/twoCellAnchor";
    DrawingMLSpreadsheetDrawing.el = DrawingMLSpreadsheetDrawing.dq + "/wsDr";
    DrawingMLSpreadsheetDrawing.dy = DrawingMLSpreadsheetDrawing.dq + "/cxnSp";
    DrawingMLSpreadsheetDrawing.d4 = DrawingMLSpreadsheetDrawing.dq + "/graphicFrame";
    DrawingMLSpreadsheetDrawing.d5 = DrawingMLSpreadsheetDrawing.dq + "/grpSp";
    DrawingMLSpreadsheetDrawing.eb = DrawingMLSpreadsheetDrawing.dq + "/pic";
    DrawingMLSpreadsheetDrawing.ef = DrawingMLSpreadsheetDrawing.dq + "/sp";
    DrawingMLSpreadsheetDrawing.d9 = DrawingMLSpreadsheetDrawing.dq + "/nvSpPr";
    DrawingMLSpreadsheetDrawing.du = DrawingMLSpreadsheetDrawing.dq + "/cNvPr";
    DrawingMLSpreadsheetDrawing.dv = DrawingMLSpreadsheetDrawing.dq + "/cNvSpPr";
    DrawingMLSpreadsheetDrawing.eg = DrawingMLSpreadsheetDrawing.dq + "/spPr";
    DrawingMLSpreadsheetDrawing.ek = DrawingMLSpreadsheetDrawing.dq + "/txBody";
    DrawingMLSpreadsheetDrawing.dn = new DrawingMLSpreadsheetDrawing();
    return DrawingMLSpreadsheetDrawing;
}(DrawingNamespaceDefinitionBase));
export { DrawingMLSpreadsheetDrawing };
