/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, typeCast, toNullable, String_$type, Number_$type, Boolean_$type, Array_$type, runOn, markType } from "igniteui-angular-core";
import { XmlPartManagerBase } from "./XmlPartManagerBase";
import { EG_ColorChoice } from "./EG_ColorChoice";
import { CT_Color } from "./CT_Color";
import { CT_SolidFillProperties } from "./CT_SolidFillProperties";
import { CT_StyleMatrixReference } from "./CT_StyleMatrixReference";
import { CT_FontReference } from "./CT_FontReference";
import { CT_LineProperties } from "./CT_LineProperties";
import { CT_ShapePropertiesBase } from "./CT_ShapePropertiesBase";
import { CT_TextCharacterProperties } from "./CT_TextCharacterProperties";
import { CT_PresetGeometry2D } from "./CT_PresetGeometry2D";
import { CT_GeomGuideList } from "./CT_GeomGuideList";
import { ST_PositiveFixedPercentage } from "./ST_PositiveFixedPercentage";
import { DrawingMLMain } from "./DrawingMLMain";
import { ColorTransform_Alpha } from "./ColorTransform_Alpha";
import { ST_PositivePercentage } from "./ST_PositivePercentage";
import { ColorTransform_AlphaMod } from "./ColorTransform_AlphaMod";
import { ST_FixedPercentage } from "./ST_FixedPercentage";
import { ColorTransform_AlphaOff } from "./ColorTransform_AlphaOff";
import { CT_BlipFillProperties } from "./CT_BlipFillProperties";
import { ST_BlipCompression_$type } from "./ST_BlipCompression";
import { CT_Blip } from "./CT_Blip";
import { CT_Picture } from "./CT_Picture";
import { ST_Percentage } from "./ST_Percentage";
import { ColorTransform_Blue } from "./ColorTransform_Blue";
import { ColorTransform_BlueMod } from "./ColorTransform_BlueMod";
import { ColorTransform_BlueOff } from "./ColorTransform_BlueOff";
import { CT_TextBody } from "./CT_TextBody";
import { CT_TextBodyProperties } from "./CT_TextBodyProperties";
import { CT_GraphicalObjectData } from "./CT_GraphicalObjectData";
import { DrawingMLChart } from "./DrawingMLChart";
import { CT_RelId } from "./CT_RelId";
import { Tuple } from "igniteui-angular-core";
import { Tuple$2 } from "igniteui-angular-core";
import { DrawingMLChart2014 } from "./DrawingMLChart2014";
import { CT_GroupTransform2D } from "./CT_GroupTransform2D";
import { ST_PositiveCoordinate } from "./ST_PositiveCoordinate";
import { CT_PositiveSize2D } from "./CT_PositiveSize2D";
import { ST_Coordinate } from "./ST_Coordinate";
import { CT_Point2D } from "./CT_Point2D";
import { CT_ConnectorNonVisual } from "./CT_ConnectorNonVisual";
import { CT_NonVisualConnectorProperties } from "./CT_NonVisualConnectorProperties";
import { CT_GraphicalObjectFrameNonVisual } from "./CT_GraphicalObjectFrameNonVisual";
import { CT_NonVisualGraphicFrameProperties } from "./CT_NonVisualGraphicFrameProperties";
import { CT_GroupShapeNonVisual } from "./CT_GroupShapeNonVisual";
import { CT_NonVisualGroupDrawingShapeProps } from "./CT_NonVisualGroupDrawingShapeProps";
import { CT_PictureNonVisual } from "./CT_PictureNonVisual";
import { CT_NonVisualPictureProperties } from "./CT_NonVisualPictureProperties";
import { CT_NonVisualBase } from "./CT_NonVisualBase";
import { ST_DrawingElementId } from "./ST_DrawingElementId";
import { CT_NonVisualDrawingProps } from "./CT_NonVisualDrawingProps";
import { CT_ShapeNonVisual } from "./CT_ShapeNonVisual";
import { CT_NonVisualDrawingShapeProps } from "./CT_NonVisualDrawingShapeProps";
import { IShapesOwner_$type } from "./IShapesOwner";
import { CT_Connector } from "./CT_Connector";
import { ColorTransform_Comp } from "./ColorTransform_Comp";
import { CT_TextFont } from "./CT_TextFont";
import { CT_ConnectorLocking } from "./CT_ConnectorLocking";
import { CT_ShapeStyle } from "./CT_ShapeStyle";
import { CT_Connection } from "./CT_Connection";
import { CT_Transform2D } from "./CT_Transform2D";
import { IgnoreChildrenMarker } from "./IgnoreChildrenMarker";
import { CT_StretchInfoProperties } from "./CT_StretchInfoProperties";
import { CT_RelativeRect } from "./CT_RelativeRect";
import { CT_TextParagraph } from "./CT_TextParagraph";
import { CT_RegularTextRun } from "./CT_RegularTextRun";
import { CT_GeomGuide } from "./CT_GeomGuide";
import { CT_GraphicalObjectFrame } from "./CT_GraphicalObjectFrame";
import { CT_GraphicalObject } from "./CT_GraphicalObject";
import { AttributeValue } from "./AttributeValue";
import { Enumerable } from "igniteui-angular-core";
import { ST_OnOff } from "./ST_OnOff";
import { ColorTransform_Gray } from "./ColorTransform_Gray";
import { ColorTransform_Green } from "./ColorTransform_Green";
import { ColorTransform_GreenMod } from "./ColorTransform_GreenMod";
import { ColorTransform_GreenOff } from "./ColorTransform_GreenOff";
import { CT_GroupFillProperties } from "./CT_GroupFillProperties";
import { CT_GroupShape } from "./CT_GroupShape";
import { CT_GroupLocking } from "./CT_GroupLocking";
import { CT_GroupShapeProperties } from "./CT_GroupShapeProperties";
import { CT_LineEndProperties } from "./CT_LineEndProperties";
import { ST_PositiveFixedAngle } from "./ST_PositiveFixedAngle";
import { ColorTransform_Hue } from "./ColorTransform_Hue";
import { ColorTransform_HueMod } from "./ColorTransform_HueMod";
import { ST_Angle } from "./ST_Angle";
import { ColorTransform_HueOff } from "./ColorTransform_HueOff";
import { ColorTransform_Inv } from "./ColorTransform_Inv";
import { CT_ShapeProperties } from "./CT_ShapeProperties";
import { CT_TextListStyle } from "./CT_TextListStyle";
import { CT_TextParagraphProperties } from "./CT_TextParagraphProperties";
import { ST_TextFontSize } from "./ST_TextFontSize";
import { ColorTransform_Lum } from "./ColorTransform_Lum";
import { ColorTransform_LumMod } from "./ColorTransform_LumMod";
import { ColorTransform_LumOff } from "./ColorTransform_LumOff";
import { CT_NoFillProperties } from "./CT_NoFillProperties";
import { CT_Shape } from "./CT_Shape";
import { CT_PictureLocking } from "./CT_PictureLocking";
import { CT_PresetColor_Core } from "./CT_PresetColor_Core";
import { ColorTransform_Red } from "./ColorTransform_Red";
import { ColorTransform_RedMod } from "./ColorTransform_RedMod";
import { ColorTransform_RedOff } from "./ColorTransform_RedOff";
import { ColorTransform_Sat } from "./ColorTransform_Sat";
import { ColorTransform_SatMod } from "./ColorTransform_SatMod";
import { ColorTransform_SatOff } from "./ColorTransform_SatOff";
import { CT_SchemeColor } from "./CT_SchemeColor";
import { ColorTransform_Shade } from "./ColorTransform_Shade";
import { Drawing2010Slicer } from "./Drawing2010Slicer";
import { CT_Slicer } from "./CT_Slicer";
import { CT_ShapeLocking } from "./CT_ShapeLocking";
import { ICT_ShapePropertiesOwner_$type } from "./ICT_ShapePropertiesOwner";
import { ST_HexColorRGB } from "./ST_HexColorRGB";
import { CT_SRgbColor } from "./CT_SRgbColor";
import { ICT_ShapeStyleOwner_$type } from "./ICT_ShapeStyleOwner";
import { CT_SysColor } from "./CT_SysColor";
import { ColorTransform_Tint } from "./ColorTransform_Tint";
import { IGraphicalObjectContent_$type } from "./IGraphicalObjectContent";
import { AlternateContentChoice } from "./AlternateContentChoice";
import { IGOfficeExtensions } from "./IGOfficeExtensions";
import { nullableEquals } from "igniteui-angular-core";
import { stringEmpty } from "igniteui-angular-core";
import { IEG_ColorChoiceVisitor$2_$type } from "./IEG_ColorChoiceVisitor$2";
import { IEG_ColorTransformVisitor$2_$type } from "./IEG_ColorTransformVisitor$2";
import { IEG_FillModePropertiesVisitor$2_$type } from "./IEG_FillModePropertiesVisitor$2";
import { IEG_FillPropertiesVisitor$2_$type } from "./IEG_FillPropertiesVisitor$2";
import { IEG_GeometryVisitor$2_$type } from "./IEG_GeometryVisitor$2";
import { IEG_LineDashPropertiesVisitor$2_$type } from "./IEG_LineDashPropertiesVisitor$2";
import { IEG_LineFillPropertiesVisitor$2_$type } from "./IEG_LineFillPropertiesVisitor$2";
import { IEG_LineJoinPropertiesVisitor$2_$type } from "./IEG_LineJoinPropertiesVisitor$2";
import { IEG_TextRunVisitor$2_$type } from "./IEG_TextRunVisitor$2";
import { IGraphicalObjectContentVisitor$2_$type } from "./IGraphicalObjectContentVisitor$2";
/**
 * @hidden
 */
var DrawingPartManagerHelpers = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DrawingPartManagerHelpers, _super);
    function DrawingPartManagerHelpers() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DrawingPartManagerHelpers.a = function (a, b) {
        var c = a.s.a(CT_Color.$);
        if (c != null) {
            c.a = b;
            return;
        }
        var d = a.s.a(CT_SolidFillProperties.$);
        if (d != null) {
            d.a = b;
            return;
        }
        var e = a.s.a(CT_StyleMatrixReference.$);
        if (e != null) {
            e.a = b;
            return;
        }
        var f = a.s.a(CT_FontReference.$);
        if (f != null) {
            f.a = b;
            return;
        }
    };
    DrawingPartManagerHelpers.b = function ($t, a, b) {
        var c = typeCast(CT_LineProperties.$, a.s.f);
        if (c != null) {
            c.i = b;
            return;
        }
        var d = typeCast(CT_ShapePropertiesBase.$, a.s.f);
        if (d != null) {
            d.a = b;
            return;
        }
        var e = typeCast(CT_TextCharacterProperties.$, a.s.f);
        if (e != null) {
            e.y = b;
            return;
        }
    };
    DrawingPartManagerHelpers.c = function ($t, a, b) {
        var c = typeCast(CT_ShapePropertiesBase.$, a.s.f);
        if (c != null) {
            c.a = b;
            return;
        }
    };
    DrawingPartManagerHelpers.g = function (a) {
        var b = a.s.a(CT_PresetGeometry2D.$);
        if (b == null) {
            return;
        }
        var c = new CT_GeomGuideList();
        b.a = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.d = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_PositiveFixedPercentage();
        var d = DrawingMLMain.kg(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_Alpha();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.e = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_PositivePercentage();
        var d = DrawingMLMain.kh(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_AlphaMod();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.f = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_FixedPercentage();
        var d = DrawingMLMain.ki(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_AlphaOff();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.h = function (a) {
        var b = a.s.a(CT_BlipFillProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f = DrawingMLMain.kk(a, c, d, e);
        c = f.p1;
        d = f.p2;
        e = f.p3;
        var g = ((function () {
            var $ret = new CT_Blip();
            $ret.d = c;
            $ret.e = d;
            $ret.c = toNullable(ST_BlipCompression_$type, e.value);
            return $ret;
        })());
        b.d = g;
        a.s.k(g);
    };
    DrawingPartManagerHelpers.i = function (a) {
        var b = a.s.a(CT_Picture.$);
        if (b != null) {
            var c_1;
            var d_1;
            var e = a.d._t.b4(a, c_1, d_1);
            c_1 = e.p1;
            d_1 = e.p2;
            var f = ((function () {
                var $ret = new CT_BlipFillProperties();
                $ret.b = c_1;
                $ret.c = d_1;
                return $ret;
            })());
            b.a = f;
            a.s.k(f);
            return;
        }
        else {
            var g_1;
            var h_1;
            var i = DrawingMLMain.kl(a, g_1, h_1);
            g_1 = i.p1;
            h_1 = i.p2;
            var j = ((function () {
                var $ret = new CT_BlipFillProperties();
                $ret.b = g_1;
                $ret.c = h_1;
                return $ret;
            })());
            DrawingPartManagerHelpers.c(CT_BlipFillProperties.$, a, j);
            a.s.k(j);
        }
    };
    DrawingPartManagerHelpers.r = function (a) {
    };
    DrawingPartManagerHelpers.s = function (a) {
        var b = a.s.a(CT_BlipFillProperties.$);
        if (b == null) {
            return;
        }
        var c = b.d;
        if (c == null) {
            return;
        }
        var d = new CT_Color();
        c.a = d;
        a.s.k(d);
    };
    DrawingPartManagerHelpers.t = function (a) {
        var b = a.s.a(CT_BlipFillProperties.$);
        if (b == null) {
            return;
        }
        var c = b.d;
        if (c == null) {
            return;
        }
        var d = new CT_Color();
        c.b = d;
        a.s.k(d);
    };
    DrawingPartManagerHelpers.j = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.km(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_Blue();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.k = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.kn(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_BlueMod();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.l = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.ko(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_BlueOff();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.m = function (a) {
        var b = a.s.a(CT_TextBody.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f;
        var g;
        var h;
        var i;
        var j;
        var k;
        var l;
        var m;
        var n;
        var o;
        var p;
        var q;
        var r;
        var s;
        var t;
        var u;
        var v = DrawingMLMain.kp(a, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u);
        c = v.p1;
        d = v.p2;
        e = v.p3;
        f = v.p4;
        g = v.p5;
        h = v.p6;
        i = v.p7;
        j = v.p8;
        k = v.p9;
        l = v.p10;
        m = v.p11;
        n = v.p12;
        o = v.p13;
        p = v.p14;
        q = v.p15;
        r = v.p16;
        s = v.p17;
        t = v.p18;
        u = v.p19;
        b.a = ((function () {
            var $ret = new CT_TextBodyProperties();
            $ret.n = c;
            $ret.l = d;
            $ret.q = e;
            $ret.p = f;
            $ret.t = g;
            $ret.r = h;
            $ret.j = i;
            $ret.s = j;
            $ret.m = k;
            $ret.f = l;
            $ret.k = m;
            $ret.o = n;
            $ret.a = o;
            $ret.i = p;
            $ret.d = q;
            $ret.e = r;
            $ret.h = s;
            $ret.c = t;
            $ret.g = u;
            return $ret;
        })());
        a.s.k(b.a);
    };
    DrawingPartManagerHelpers.n = function (a) {
        var b = a.s.a(CT_GraphicalObjectData.$);
        if (b == null) {
            return;
        }
        var c;
        var d = DrawingMLChart.gx(a, c);
        c = d.p1;
        var e = DrawingMLChart.be;
        if (b.c == DrawingMLChart2014.aq) {
            e = DrawingMLChart2014.ap;
        }
        b.b.add(Tuple.a(String_$type, Base.$, e, ((function () {
            var $ret = new CT_RelId();
            $ret.a = c;
            return $ret;
        })())));
    };
    DrawingPartManagerHelpers.o = function (a) {
        var b = a.s.a(CT_GraphicalObjectData.$);
        if (b == null) {
            return;
        }
        var c;
        var d = DrawingMLChart2014.at(a, c);
        c = d.p1;
        b.b.add(Tuple.a(String_$type, Base.$, DrawingMLChart2014.ap, ((function () {
            var $ret = new CT_RelId();
            $ret.a = c;
            return $ret;
        })())));
    };
    DrawingPartManagerHelpers.p = function (a) {
        var b = a.s.a(CT_GroupTransform2D.$);
        if (b == null) {
            return;
        }
        var c = new ST_PositiveCoordinate();
        var d = new ST_PositiveCoordinate();
        var e = DrawingMLMain.kq(a, c, d);
        c = e.p1;
        d = e.p2;
        var f = ((function () {
            var $ret = new CT_PositiveSize2D();
            $ret.a = c;
            $ret.b = d;
            return $ret;
        })());
        b.m = f;
        a.s.k(f);
    };
    DrawingPartManagerHelpers.q = function (a) {
        var b = a.s.a(CT_GroupTransform2D.$);
        if (b == null) {
            return;
        }
        var c = new ST_Coordinate();
        var d = new ST_Coordinate();
        var e = DrawingMLMain.kr(a, c, d);
        c = e.p1;
        d = e.p2;
        var f = ((function () {
            var $ret = new CT_Point2D();
            $ret.a = c;
            $ret.b = d;
            return $ret;
        })());
        b.l = f;
        a.s.k(f);
    };
    DrawingPartManagerHelpers.u = function (a) {
        var b = a.s.a(CT_ConnectorNonVisual.$);
        if (b == null) {
            return;
        }
        var c = new CT_NonVisualConnectorProperties();
        b.b = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.v = function (a) {
        var b = a.s.a(CT_GraphicalObjectFrameNonVisual.$);
        if (b == null) {
            return;
        }
        var c = new CT_NonVisualGraphicFrameProperties();
        b.b = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.w = function (a) {
        var b = a.s.a(CT_GroupShapeNonVisual.$);
        if (b == null) {
            return;
        }
        var c = new CT_NonVisualGroupDrawingShapeProps();
        b.b = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.x = function (a) {
        var b = a.s.a(CT_PictureNonVisual.$);
        if (b == null) {
            return;
        }
        var c;
        var d = a.d._t.b8(a, c);
        c = d.p1;
        var e = ((function () {
            var $ret = new CT_NonVisualPictureProperties();
            $ret.b = c;
            return $ret;
        })());
        b.b = e;
        a.s.k(e);
    };
    DrawingPartManagerHelpers.y = function (a) {
        var b = a.s.a(CT_NonVisualBase.$);
        if (b == null) {
            return;
        }
        var c = new ST_DrawingElementId();
        var d;
        var e;
        var f;
        var g;
        var h = a.d._t.b9(a, c, d, e, f, g);
        c = h.p1;
        d = h.p2;
        e = h.p3;
        f = h.p4;
        g = h.p5;
        var i = ((function () {
            var $ret = new CT_NonVisualDrawingProps();
            $ret.c = c;
            $ret.f = d;
            $ret.e = e;
            $ret.d = f;
            $ret.g = g;
            return $ret;
        })());
        b.a = i;
        a.s.k(i);
    };
    DrawingPartManagerHelpers.z = function (a) {
        var b = a.s.a(CT_ShapeNonVisual.$);
        if (b == null) {
            return;
        }
        var c;
        var d = a.d._t.ca(a, c);
        c = d.p1;
        var e = ((function () {
            var $ret = new CT_NonVisualDrawingShapeProps();
            $ret.b = c;
            return $ret;
        })());
        b.b = e;
        a.s.k(e);
    };
    DrawingPartManagerHelpers.ac = function (a) {
        var b = a.s.a(IShapesOwner_$type);
        var c;
        var d;
        var e = a.d._t.cc(a, c, d);
        c = e.p1;
        d = e.p2;
        var f = ((function () {
            var $ret = new CT_Connector();
            $ret.c = c;
            $ret.b = d;
            return $ret;
        })());
        if (b != null) {
            b.addShape(a.d, f);
        }
        a.s.k(f);
    };
    DrawingPartManagerHelpers.aa = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        b.b.add(new ColorTransform_Comp());
    };
    DrawingPartManagerHelpers.ab = function (a) {
        var b = a.s.a(CT_TextCharacterProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f;
        var g = DrawingMLMain.ku(a, c, d, e, f);
        c = g.p1;
        d = g.p2;
        e = g.p3;
        f = g.p4;
        var h = ((function () {
            var $ret = new CT_TextFont();
            $ret.d = c;
            $ret.a = d;
            $ret.c = e;
            $ret.b = f;
            return $ret;
        })());
        b.a = h;
        a.s.k(h);
    };
    DrawingPartManagerHelpers.ad = function (a) {
        var b = a.s.a(CT_NonVisualConnectorProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f;
        var g;
        var h;
        var i;
        var j;
        var k;
        var l;
        var m = a.d._t.cd(a, c, d, e, f, g, h, i, j, k, l);
        c = m.p1;
        d = m.p2;
        e = m.p3;
        f = m.p4;
        g = m.p5;
        h = m.p6;
        i = m.p7;
        j = m.p8;
        k = m.p9;
        l = m.p10;
        var n = ((function () {
            var $ret = new CT_ConnectorLocking();
            $ret.f = c;
            $ret.j = d;
            $ret.i = e;
            $ret.c = f;
            $ret.g = g;
            $ret.h = h;
            $ret.e = i;
            $ret.a = j;
            $ret.b = k;
            $ret.d = l;
            return $ret;
        })());
        b.c = n;
        a.s.k(n);
    };
    DrawingPartManagerHelpers.af = function (a) {
        var b = a.s.a(CT_TextCharacterProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f;
        var g = DrawingMLMain.ld(a, c, d, e, f);
        c = g.p1;
        d = g.p2;
        e = g.p3;
        f = g.p4;
        var h = ((function () {
            var $ret = new CT_TextFont();
            $ret.d = c;
            $ret.a = d;
            $ret.c = e;
            $ret.b = toNullable(Number_$type, f);
            return $ret;
        })());
        b.b = h;
        a.s.k(h);
    };
    DrawingPartManagerHelpers.ag = function (a) {
        var b = a.s.a(CT_ShapeStyle.$);
        if (b == null) {
            return;
        }
        var c;
        var d = DrawingMLMain.le(a, c);
        c = d.p1;
        var e = ((function () {
            var $ret = new CT_StyleMatrixReference();
            $ret.b = c;
            return $ret;
        })());
        b.b = e;
        a.s.k(e);
    };
    DrawingPartManagerHelpers.ah = function (a) {
        var b = a.s.a(CT_NonVisualConnectorProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e = a.d._t.ce(a, c, d);
        c = e.p1;
        d = e.p2;
        var f = ((function () {
            var $ret = new CT_Connection();
            $ret.a = c;
            $ret.b = d;
            return $ret;
        })());
        b.a = f;
        a.s.k(f);
    };
    DrawingPartManagerHelpers.ai = function (a) {
        var b = a.s.a(CT_Transform2D.$);
        if (b == null) {
            return;
        }
        var c = new ST_PositiveCoordinate();
        var d = new ST_PositiveCoordinate();
        var e = DrawingMLMain.lf(a, c, d);
        c = e.p1;
        d = e.p2;
        var f = ((function () {
            var $ret = new CT_PositiveSize2D();
            $ret.a = c;
            $ret.b = d;
            return $ret;
        })());
        b.b = f;
        a.s.k(f);
    };
    DrawingPartManagerHelpers.aj = function (a) {
        a.s.k(IgnoreChildrenMarker.a);
    };
    DrawingPartManagerHelpers.ak = function (a) {
        var b = a.s.a(CT_StretchInfoProperties.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = new ST_Percentage();
        var e = new ST_Percentage();
        var f = new ST_Percentage();
        var g = DrawingMLMain.lj(a, c, d, e, f);
        c = g.p1;
        d = g.p2;
        e = g.p3;
        f = g.p4;
        var h = ((function () {
            var $ret = new CT_RelativeRect();
            $ret.b = c;
            $ret.d = d;
            $ret.c = e;
            $ret.a = f;
            return $ret;
        })());
        b.a = h;
        a.s.k(h);
    };
    DrawingPartManagerHelpers.al = function (a) {
        var b = a.s.a(CT_ShapeStyle.$);
        if (b == null) {
            return;
        }
        var c;
        var d = DrawingMLMain.lk(a, c);
        c = d.p1;
        var e = ((function () {
            var $ret = new CT_StyleMatrixReference();
            $ret.b = c;
            return $ret;
        })());
        b.c = e;
        a.s.k(e);
    };
    DrawingPartManagerHelpers.am = function (a) {
        var b = a.s.a(CT_TextParagraph.$);
        if (b == null) {
            return;
        }
        var c = new CT_RegularTextRun();
        b.c.add(c);
        a.s.k(c);
    };
    DrawingPartManagerHelpers.an = function (a) {
        var b = a.s.a(CT_ShapeStyle.$);
        if (b == null) {
            return;
        }
        var c;
        var d = DrawingMLMain.ln(a, c);
        c = d.p1;
        var e = ((function () {
            var $ret = new CT_FontReference();
            $ret.b = c;
            return $ret;
        })());
        b.a = e;
        a.s.k(e);
    };
    DrawingPartManagerHelpers.ao = function (a) {
        var b = a.s.a(CT_GeomGuideList.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e = DrawingMLMain.lp(a, c, d);
        c = e.p1;
        d = e.p2;
        var f = ((function () {
            var $ret = new CT_GeomGuide();
            $ret.b = c;
            $ret.a = d;
            return $ret;
        })());
        b.b.add(f);
        a.s.k(f);
    };
    DrawingPartManagerHelpers.aq = function (a) {
        var b = a.s.a(CT_GraphicalObjectFrame.$);
        var c = new CT_GraphicalObject();
        if (b != null) {
            b.a = c;
        }
        a.s.k(c);
    };
    DrawingPartManagerHelpers.ap = function (a) {
        var b = a.s.a(CT_GraphicalObject.$);
        if (b == null) {
            return;
        }
        var c;
        var d = DrawingMLMain.lq(a, c);
        c = d.p1;
        var e = ((function () {
            var $ret = new CT_GraphicalObjectData();
            $ret.c = c;
            return $ret;
        })());
        b.a = e;
        a.s.k(e);
    };
    DrawingPartManagerHelpers.ar = function (a) {
        var b = a.s.a(IShapesOwner_$type);
        var c;
        var d;
        var e = a.d._t.cf(a, c, d);
        c = e.p1;
        d = e.p2;
        var f = ((function () {
            var $ret = new CT_GraphicalObjectFrame();
            $ret.e = c;
            $ret.d = d;
            return $ret;
        })());
        if (b != null) {
            b.addShape(a.d, f);
        }
        a.s.k(f);
    };
    DrawingPartManagerHelpers.as = function (a) {
        var b = Enumerable.ag(AttributeValue.$, a.ab.u, function (c) { return c.a.e(a.d) == IGOfficeExtensions.ap; });
        if (b.d == null || ST_OnOff.e(b.d) == false) {
            a.d._bj();
        }
    };
    DrawingPartManagerHelpers.at = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        b.b.add(new ColorTransform_Gray());
    };
    DrawingPartManagerHelpers.au = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.lu(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_Green();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.av = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.lv(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_GreenMod();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.aw = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.lw(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_GreenOff();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.ax = function (a) {
        var b = new CT_GroupFillProperties();
        DrawingPartManagerHelpers.c(CT_GroupFillProperties.$, a, b);
        a.s.k(b);
    };
    DrawingPartManagerHelpers.ay = function (a) {
        var b = a.s.a(IShapesOwner_$type);
        var c = new CT_GroupShape();
        if (b != null) {
            b.addShape(a.d, c);
        }
        a.s.k(c);
    };
    DrawingPartManagerHelpers.az = function (a) {
        var b = a.s.a(CT_NonVisualGroupDrawingShapeProps.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f;
        var g;
        var h;
        var i;
        var j = a.d._t.ch(a, c, d, e, f, g, h, i);
        c = j.p1;
        d = j.p2;
        e = j.p3;
        f = j.p4;
        g = j.p5;
        h = j.p6;
        i = j.p7;
        var k = ((function () {
            var $ret = new CT_GroupLocking();
            $ret.b = c;
            $ret.g = d;
            $ret.f = e;
            $ret.e = f;
            $ret.a = g;
            $ret.c = h;
            $ret.d = i;
            return $ret;
        })());
        b.a = k;
        a.s.k(k);
    };
    DrawingPartManagerHelpers.a0 = function (a) {
        var b = a.s.a(CT_GroupShape.$);
        if (b == null) {
            return;
        }
        var c;
        var d = a.d._t.ci(a, c);
        c = d.p1;
        var e = ((function () {
            var $ret = new CT_GroupShapeProperties();
            $ret.b = c;
            return $ret;
        })());
        b.b = e;
        a.s.k(e);
    };
    DrawingPartManagerHelpers.a1 = function (a) {
        var b = a.s.a(CT_LineProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f = DrawingMLMain.ly(a, c, d, e);
        c = f.p1;
        d = f.p2;
        e = f.p3;
        var g = ((function () {
            var $ret = new CT_LineEndProperties();
            $ret.b = c;
            $ret.c = d;
            $ret.a = e;
            return $ret;
        })());
        b.a = g;
        a.s.k(g);
    };
    DrawingPartManagerHelpers.a2 = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_PositiveFixedAngle();
        var d = DrawingMLMain.l1(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_Hue();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.a3 = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_PositivePercentage();
        var d = DrawingMLMain.l2(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_HueMod();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.a4 = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Angle();
        var d = DrawingMLMain.l3(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_HueOff();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.a5 = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        b.b.add(new ColorTransform_Inv());
    };
    DrawingPartManagerHelpers.a6 = function (a) {
        var b = a.s.a(CT_TextCharacterProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f;
        var g = DrawingMLMain.l5(a, c, d, e, f);
        c = g.p1;
        d = g.p2;
        e = g.p3;
        f = g.p4;
        var h = ((function () {
            var $ret = new CT_TextFont();
            $ret.d = c;
            $ret.a = d;
            $ret.c = e;
            $ret.b = toNullable(Number_$type, f);
            return $ret;
        })());
        b.c = h;
        a.s.k(h);
    };
    DrawingPartManagerHelpers.a7 = function (a) {
        var b = a.s.a(CT_ShapeProperties.$);
        var c = b == null ? a.s.a(CT_TextCharacterProperties.$) : null;
        if (b == null && c == null) {
            return;
        }
        var d;
        var e;
        var f;
        var g;
        var h = DrawingMLMain.l6(a, d, e, f, g);
        d = h.p1;
        e = h.p2;
        f = h.p3;
        g = h.p4;
        var i = ((function () {
            var $ret = new CT_LineProperties();
            $ret.h = d;
            $ret.f = e;
            $ret.g = f;
            $ret.e = g;
            return $ret;
        })());
        if (b != null) {
            b.c = i;
        }
        else {
            c.w = i;
        }
        a.s.k(i);
    };
    DrawingPartManagerHelpers.a8 = function (a) {
        var b = a.s.a(CT_ShapeStyle.$);
        if (b == null) {
            return;
        }
        var c;
        var d = DrawingMLMain.l7(a, c);
        c = d.p1;
        var e = ((function () {
            var $ret = new CT_StyleMatrixReference();
            $ret.b = c;
            return $ret;
        })());
        b.d = e;
        a.s.k(e);
    };
    DrawingPartManagerHelpers.a9 = function (a) {
        var b = a.s.a(CT_TextBody.$);
        if (b == null) {
            return;
        }
        var c = new CT_TextListStyle();
        b.b = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.bd = function (a) {
        var b = a.s.a(CT_TextListStyle.$);
        if (b == null) {
            return;
        }
        var c = CT_TextParagraphProperties.b(a);
        b.b = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.ae = function (a) {
        var b = a.s.a(CT_TextParagraphProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f;
        var g;
        var h;
        var i;
        var j;
        var k;
        var l;
        var m;
        var n;
        var o;
        var p;
        var q;
        var r;
        var s;
        var t;
        var u;
        var v = DrawingMLMain.ms(a, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, DrawingMLMain.c5);
        c = v.p1;
        d = v.p2;
        e = v.p3;
        f = v.p4;
        g = v.p5;
        h = v.p6;
        i = v.p7;
        j = v.p8;
        k = v.p9;
        l = v.p10;
        m = v.p11;
        n = v.p12;
        o = v.p13;
        p = v.p14;
        q = v.p15;
        r = v.p16;
        s = v.p17;
        t = v.p18;
        u = v.p19;
        var w = ((function () {
            var $ret = new CT_TextCharacterProperties();
            $ret.k = c;
            $ret.v = d;
            $ret.t = e;
            $ret.r = ST_TextFontSize.g(f);
            $ret.d = g;
            $ret.i = h;
            $ret.s = i;
            $ret.q = j;
            $ret.j = k;
            $ret.f = l;
            $ret.p = m;
            $ret.m = n;
            $ret.e = o;
            $ret.l = p;
            $ret.g = q;
            $ret.h = r;
            $ret.n = s;
            $ret.o = t;
            $ret.u = u;
            return $ret;
        })());
        b.a = w;
        a.s.k(w);
    };
    DrawingPartManagerHelpers.ba = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.mb(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_Lum();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.bb = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.mc(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_LumMod();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.bc = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.md(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_LumOff();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.be = function (a) {
        var b = new CT_NoFillProperties();
        DrawingPartManagerHelpers.b(CT_NoFillProperties.$, a, b);
        a.s.k(b);
    };
    DrawingPartManagerHelpers.bf = function (a) {
        var b = a.s.a(CT_Connector.$);
        if (b == null) {
            return;
        }
        var c = new CT_ConnectorNonVisual();
        b.a = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.bg = function (a) {
        var b = a.s.a(CT_GraphicalObjectFrame.$);
        if (b == null) {
            return;
        }
        var c = new CT_GraphicalObjectFrameNonVisual();
        b.b = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.bh = function (a) {
        var b = a.s.a(CT_GroupShape.$);
        if (b == null) {
            return;
        }
        var c = new CT_GroupShapeNonVisual();
        b.a = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.bi = function (a) {
        var b = a.s.a(CT_Picture.$);
        if (b == null) {
            return;
        }
        var c = new CT_PictureNonVisual();
        b.b = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.bj = function (a) {
        var b = a.s.a(CT_Shape.$);
        if (b == null) {
            return;
        }
        var c = new CT_ShapeNonVisual();
        b.a = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.bk = function (a) {
        var b = a.s.a(CT_Transform2D.$);
        if (b == null) {
            return;
        }
        var c = new ST_Coordinate();
        var d = new ST_Coordinate();
        var e = DrawingMLMain.mi(a, c, d);
        c = e.p1;
        d = e.p2;
        var f = ((function () {
            var $ret = new CT_Point2D();
            $ret.a = c;
            $ret.b = d;
            return $ret;
        })());
        b.a = f;
        a.s.k(f);
    };
    DrawingPartManagerHelpers.bl = function (a) {
        var b = a.s.a(CT_TextBody.$);
        if (b == null) {
            return;
        }
        var c = new CT_TextParagraph();
        b.d.add(c);
        a.s.k(c);
    };
    DrawingPartManagerHelpers.bm = function (a) {
        var b = a.s.a(IShapesOwner_$type);
        var c;
        var d;
        var e = a.d._t.co(a, c, d);
        c = e.p1;
        d = e.p2;
        var f = ((function () {
            var $ret = new CT_Picture();
            $ret.d = c;
            $ret.c = d;
            return $ret;
        })());
        if (b != null) {
            b.addShape(a.d, f);
        }
        a.s.k(f);
    };
    DrawingPartManagerHelpers.bn = function (a) {
        var b = a.s.a(CT_NonVisualPictureProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f;
        var g;
        var h;
        var i;
        var j;
        var k;
        var l;
        var m;
        var n = DrawingMLMain.mk(a, c, d, e, f, g, h, i, j, k, l, m);
        c = n.p1;
        d = n.p2;
        e = n.p3;
        f = n.p4;
        g = n.p5;
        h = n.p6;
        i = n.p7;
        j = n.p8;
        k = n.p9;
        l = n.p10;
        m = n.p11;
        var o = ((function () {
            var $ret = new CT_PictureLocking();
            $ret.g = c;
            $ret.k = d;
            $ret.j = e;
            $ret.c = f;
            $ret.h = g;
            $ret.i = h;
            $ret.f = i;
            $ret.a = j;
            $ret.b = k;
            $ret.d = l;
            $ret.e = m;
            return $ret;
        })());
        b.a = o;
        a.s.k(o);
    };
    DrawingPartManagerHelpers.bo = function (a) {
        var b = a.s.a(CT_TextParagraph.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f;
        var g;
        var h;
        var i;
        var j;
        var k;
        var l;
        var m;
        var n = DrawingMLMain.ml(a, c, d, e, f, g, h, i, j, k, l, m);
        c = n.p1;
        d = n.p2;
        e = n.p3;
        f = n.p4;
        g = n.p5;
        h = n.p6;
        i = n.p7;
        j = n.p8;
        k = n.p9;
        l = n.p10;
        m = n.p11;
        var o = ((function () {
            var $ret = new CT_TextParagraphProperties();
            $ret.k = c;
            $ret.l = d;
            $ret.j = e;
            $ret.h = f;
            $ret.c = g;
            $ret.d = h;
            $ret.m = i;
            $ret.e = j;
            $ret.f = k;
            $ret.i = l;
            $ret.g = m;
            return $ret;
        })());
        b.a = o;
        a.s.k(o);
    };
    DrawingPartManagerHelpers.bp = function (a) {
        var b;
        var c = DrawingMLMain.mm(a, b);
        b = c.p1;
        var d = ((function () {
            var $ret = new CT_PresetColor_Core();
            $ret.c = b;
            return $ret;
        })());
        a.s.k(d);
        DrawingPartManagerHelpers.a(a, d);
    };
    DrawingPartManagerHelpers.bq = function (a) {
        var b = a.s.a(CT_ShapeProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d = DrawingMLMain.mn(a, c);
        c = d.p1;
        var e = ((function () {
            var $ret = new CT_PresetGeometry2D();
            $ret.b = c;
            return $ret;
        })());
        b.e = e;
        a.s.k(e);
    };
    DrawingPartManagerHelpers.br = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.mo(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_Red();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.bs = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.mp(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_RedMod();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.bt = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.mq(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_RedOff();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.bu = function (a) {
        var b = a.s.a(CT_TextParagraph.$);
        if (b == null) {
            return;
        }
        var c = new CT_RegularTextRun();
        b.c.add(c);
        a.s.k(c);
    };
    DrawingPartManagerHelpers.bv = function (a) {
        var b = a.s.a(CT_RegularTextRun.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f;
        var g;
        var h;
        var i;
        var j;
        var k;
        var l;
        var m;
        var n;
        var o;
        var p;
        var q;
        var r;
        var s;
        var t;
        var u;
        var v = DrawingMLMain.ms(a, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u);
        c = v.p1;
        d = v.p2;
        e = v.p3;
        f = v.p4;
        g = v.p5;
        h = v.p6;
        i = v.p7;
        j = v.p8;
        k = v.p9;
        l = v.p10;
        m = v.p11;
        n = v.p12;
        o = v.p13;
        p = v.p14;
        q = v.p15;
        r = v.p16;
        s = v.p17;
        t = v.p18;
        u = v.p19;
        var w = ((function () {
            var $ret = new CT_TextCharacterProperties();
            $ret.k = c;
            $ret.v = d;
            $ret.t = e;
            $ret.r = ST_TextFontSize.g(f);
            $ret.d = g;
            $ret.i = h;
            $ret.s = i;
            $ret.q = j;
            $ret.j = k;
            $ret.f = l;
            $ret.p = m;
            $ret.m = n;
            $ret.e = o;
            $ret.l = p;
            $ret.g = q;
            $ret.h = r;
            $ret.n = s;
            $ret.o = t;
            $ret.u = u;
            return $ret;
        })());
        b.a = w;
        a.s.k(w);
    };
    DrawingPartManagerHelpers.bw = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.mt(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_Sat();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.bx = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.mu(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_SatMod();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.by = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = DrawingMLMain.mv(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_SatOff();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.bz = function (a) {
        var b;
        var c = DrawingMLMain.mw(a, b);
        b = c.p1;
        var d = ((function () {
            var $ret = new CT_SchemeColor();
            $ret.c = b;
            return $ret;
        })());
        a.s.k(d);
        DrawingPartManagerHelpers.a(a, d);
    };
    DrawingPartManagerHelpers.b0 = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_PositiveFixedPercentage();
        var d = DrawingMLMain.mx(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_Shade();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.b1 = function (a) {
        var b = a.s.a(CT_GraphicalObjectData.$);
        if (b == null) {
            return;
        }
        var c;
        var d = Drawing2010Slicer.at(a, c);
        c = d.p1;
        b.b.add(Tuple.a(String_$type, Base.$, Drawing2010Slicer.as, ((function () {
            var $ret = new CT_Slicer();
            $ret.a = c;
            return $ret;
        })())));
    };
    DrawingPartManagerHelpers.b2 = function (a) {
        var b = new CT_SolidFillProperties();
        DrawingPartManagerHelpers.b(CT_SolidFillProperties.$, a, b);
        a.s.k(b);
    };
    DrawingPartManagerHelpers.b3 = function (a) {
        var b = a.s.a(IShapesOwner_$type);
        var c;
        var d;
        var e;
        var f;
        var g = a.d._t.cp(a, c, d, e, f);
        c = g.p1;
        d = g.p2;
        e = g.p3;
        f = g.p4;
        var h = ((function () {
            var $ret = new CT_Shape();
            $ret.e = c;
            $ret.f = d;
            $ret.c = e;
            $ret.d = f;
            return $ret;
        })());
        if (b != null) {
            b.addShape(a.d, h);
        }
        a.s.k(h);
    };
    DrawingPartManagerHelpers.b4 = function (a) {
        var b = a.s.a(CT_NonVisualDrawingShapeProps.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f;
        var g;
        var h;
        var i;
        var j;
        var k;
        var l;
        var m;
        var n = DrawingMLMain.mz(a, c, d, e, f, g, h, i, j, k, l, m);
        c = n.p1;
        d = n.p2;
        e = n.p3;
        f = n.p4;
        g = n.p5;
        h = n.p6;
        i = n.p7;
        j = n.p8;
        k = n.p9;
        l = n.p10;
        m = n.p11;
        var o = ((function () {
            var $ret = new CT_ShapeLocking();
            $ret.f = c;
            $ret.j = d;
            $ret.i = e;
            $ret.c = f;
            $ret.g = g;
            $ret.h = h;
            $ret.e = i;
            $ret.a = j;
            $ret.b = k;
            $ret.d = l;
            $ret.k = m;
            return $ret;
        })());
        b.a = o;
        a.s.k(o);
    };
    DrawingPartManagerHelpers.b5 = function (a) {
        var b = a.s.a(ICT_ShapePropertiesOwner_$type);
        if (b == null) {
            return;
        }
        var c;
        var d = a.d._t.cq(a, c);
        c = d.p1;
        var e = ((function () {
            var $ret = new CT_ShapeProperties();
            $ret.b = c;
            return $ret;
        })());
        b.spPr = e;
        a.s.k(e);
    };
    DrawingPartManagerHelpers.b6 = function (a) {
        var b = a.s.a(CT_BlipFillProperties.$);
        if (b == null) {
            return;
        }
        var c = new ST_Percentage();
        var d = new ST_Percentage();
        var e = new ST_Percentage();
        var f = new ST_Percentage();
        var g = DrawingMLMain.m0(a, c, d, e, f);
        c = g.p1;
        d = g.p2;
        e = g.p3;
        f = g.p4;
        var h = ((function () {
            var $ret = new CT_RelativeRect();
            $ret.b = c;
            $ret.d = d;
            $ret.c = e;
            $ret.a = f;
            return $ret;
        })());
        b.a = h;
        a.s.k(h);
    };
    DrawingPartManagerHelpers.b7 = function (a) {
        var b = new ST_HexColorRGB();
        var c = DrawingMLMain.m1(a, b);
        b = c.p1;
        var d = ((function () {
            var $ret = new CT_SRgbColor();
            $ret.c = b;
            return $ret;
        })());
        a.s.k(d);
        DrawingPartManagerHelpers.a(a, d);
    };
    DrawingPartManagerHelpers.b8 = function (a) {
        var b = a.s.a(CT_NonVisualConnectorProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e = a.d._t.cr(a, c, d);
        c = e.p1;
        d = e.p2;
        var f = ((function () {
            var $ret = new CT_Connection();
            $ret.a = c;
            $ret.b = d;
            return $ret;
        })());
        b.b = f;
        a.s.k(f);
    };
    DrawingPartManagerHelpers.b9 = function (a) {
        var b = a.s.a(CT_BlipFillProperties.$);
        if (b == null) {
            return;
        }
        var c = new CT_StretchInfoProperties();
        b.e = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.ca = function (a) {
        var b = a.s.a(ICT_ShapeStyleOwner_$type);
        if (b == null) {
            return;
        }
        var c = new CT_ShapeStyle();
        b.style = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.cb = function (a) {
        var b;
        var c = new ST_HexColorRGB();
        var d = DrawingMLMain.m3(a, b, c);
        b = d.p1;
        c = d.p2;
        var e = ((function () {
            var $ret = new CT_SysColor();
            $ret.d = b;
            $ret.c = c;
            return $ret;
        })());
        a.s.k(e);
        DrawingPartManagerHelpers.a(a, e);
    };
    DrawingPartManagerHelpers.cc = function (a) {
        var b = a.s.a(CT_LineProperties.$);
        if (b == null) {
            return;
        }
        var c;
        var d;
        var e;
        var f = DrawingMLMain.m4(a, c, d, e);
        c = f.p1;
        d = f.p2;
        e = f.p3;
        var g = ((function () {
            var $ret = new CT_LineEndProperties();
            $ret.b = c;
            $ret.c = d;
            $ret.a = e;
            return $ret;
        })());
        b.b = g;
        a.s.k(g);
    };
    DrawingPartManagerHelpers.cd = function (a) {
        var b = a.s.a(CT_RegularTextRun.$);
        if (b == null) {
            return;
        }
        var c;
        var d = DrawingMLMain.m5(a, c);
        c = d.p1;
        b.b = c != null ? c : stringEmpty();
    };
    DrawingPartManagerHelpers.ce = function (a) {
        var b = a.s.a(EG_ColorChoice.$);
        if (b == null) {
            return;
        }
        var c = new ST_PositiveFixedPercentage();
        var d = DrawingMLMain.m9(a, c);
        c = d.p1;
        b.b.add(((function () {
            var $ret = new ColorTransform_Tint();
            $ret.a = c;
            return $ret;
        })()));
    };
    DrawingPartManagerHelpers.cf = function (a) {
        var b = a.s.a(CT_Shape.$);
        if (b == null) {
            return;
        }
        var c = new CT_TextBody();
        b.b = c;
        a.s.k(c);
    };
    DrawingPartManagerHelpers.cg = function (a) {
        var b = new ST_Angle();
        var c;
        var d;
        var e = a.s.a(CT_GraphicalObjectFrame.$);
        if (e != null) {
            var f = a.d._t.cu(a, b, c, d);
            b = f.p1;
            c = f.p2;
            d = f.p3;
            var g = ((function () {
                var $ret = new CT_Transform2D();
                $ret.j = toNullable(ST_Angle.$, b);
                $ret.i = toNullable(Boolean_$type, c);
                $ret.k = toNullable(Boolean_$type, d);
                return $ret;
            })());
            e.c = g;
            a.s.k(g);
            return;
        }
        var h = DrawingMLMain.na(a, b, c, d);
        b = h.p1;
        c = h.p2;
        d = h.p3;
        var i = a.s.a(CT_ShapeProperties.$);
        if (i != null) {
            var j = ((function () {
                var $ret = new CT_Transform2D();
                $ret.j = toNullable(ST_Angle.$, b);
                $ret.i = toNullable(Boolean_$type, c);
                $ret.k = toNullable(Boolean_$type, d);
                return $ret;
            })());
            i.d = j;
            a.s.k(j);
            return;
        }
        var k = a.s.a(CT_GroupShapeProperties.$);
        if (k != null) {
            var l = ((function () {
                var $ret = new CT_GroupTransform2D();
                $ret.j = toNullable(ST_Angle.$, b);
                $ret.i = toNullable(Boolean_$type, c);
                $ret.k = toNullable(Boolean_$type, d);
                return $ret;
            })());
            k.c = l;
            a.s.k(l);
            return;
        }
    };
    DrawingPartManagerHelpers.ch = function (a) {
        a.ay(DrawingMLMain.a1, DrawingPartManagerHelpers.d);
        a.ay(DrawingMLMain.a6, DrawingPartManagerHelpers.e);
        a.ay(DrawingMLMain.a8, DrawingPartManagerHelpers.f);
        a.ay(DrawingMLMain.bg, DrawingPartManagerHelpers.g);
        a.ay(DrawingMLMain.bs, DrawingPartManagerHelpers.h);
        a.ay(DrawingMLMain.cj, DrawingPartManagerHelpers.r);
        a.ay(DrawingMLMain.ck, DrawingPartManagerHelpers.s);
        a.ay(DrawingMLMain.cn, DrawingPartManagerHelpers.t);
        a.ay(DrawingMLMain.bt, DrawingPartManagerHelpers.i);
        a.ay(DrawingMLMain.bu, DrawingPartManagerHelpers.j);
        a.ay(DrawingMLMain.bv, DrawingPartManagerHelpers.k);
        a.ay(DrawingMLMain.bw, DrawingPartManagerHelpers.l);
        a.ay(DrawingMLMain.bz, DrawingPartManagerHelpers.m);
        a.ay(DrawingMLMain.cg, DrawingPartManagerHelpers.p);
        a.ay(DrawingMLMain.ch, DrawingPartManagerHelpers.q);
        a.ay(DrawingMLMain.cp, DrawingPartManagerHelpers.aa);
        a.ay(DrawingMLMain.ct, DrawingPartManagerHelpers.ab);
        a.ay(DrawingMLMain.c5, DrawingPartManagerHelpers.ae);
        a.ay(DrawingMLMain.de, DrawingPartManagerHelpers.af);
        a.ay(DrawingMLMain.dj, DrawingPartManagerHelpers.ag);
        a.ay(DrawingMLMain.dq, DrawingPartManagerHelpers.ai);
        a.ay(DrawingMLMain.dr, DrawingPartManagerHelpers.aj);
        a.ay(DrawingMLMain.dy, DrawingPartManagerHelpers.ak);
        a.ay(DrawingMLMain.dz, DrawingPartManagerHelpers.al);
        a.ay(DrawingMLMain.d3, DrawingPartManagerHelpers.am);
        a.ay(DrawingMLMain.eb, DrawingPartManagerHelpers.an);
        a.ay(DrawingMLMain.eg, DrawingPartManagerHelpers.ao);
        a.ay(DrawingMLMain.ek, DrawingPartManagerHelpers.aq);
        a.ay(DrawingMLMain.el, DrawingPartManagerHelpers.ap);
        a.ay(DrawingMLMain.em, DrawingPartManagerHelpers.as);
        a.ay(DrawingMLMain.en, DrawingPartManagerHelpers.at);
        a.ay(DrawingMLMain.ep, DrawingPartManagerHelpers.au);
        a.ay(DrawingMLMain.eq, DrawingPartManagerHelpers.av);
        a.ay(DrawingMLMain.er, DrawingPartManagerHelpers.aw);
        a.ay(DrawingMLMain.es, DrawingPartManagerHelpers.ax);
        a.ay(DrawingMLMain.ew, DrawingPartManagerHelpers.a1);
        a.ay(DrawingMLMain.e8, DrawingPartManagerHelpers.a2);
        a.ay(DrawingMLMain.e9, DrawingPartManagerHelpers.a3);
        a.ay(DrawingMLMain.fa, DrawingPartManagerHelpers.a4);
        a.ay(DrawingMLMain.fg, DrawingPartManagerHelpers.a5);
        a.ay(DrawingMLMain.fq, DrawingPartManagerHelpers.a6);
        a.ay(DrawingMLMain.fw, DrawingPartManagerHelpers.a7);
        a.ay(DrawingMLMain.fx, DrawingPartManagerHelpers.a8);
        a.ay(DrawingMLMain.f1, DrawingPartManagerHelpers.a9);
        a.ay(DrawingMLMain.f4, DrawingPartManagerHelpers.ba);
        a.ay(DrawingMLMain.f5, DrawingPartManagerHelpers.bb);
        a.ay(DrawingMLMain.f6, DrawingPartManagerHelpers.bc);
        a.ay(DrawingMLMain.f8, DrawingPartManagerHelpers.bd);
        a.ay(DrawingMLMain.gy, DrawingPartManagerHelpers.be);
        a.ay(DrawingMLMain.hb, DrawingPartManagerHelpers.bk);
        a.ay(DrawingMLMain.hd, DrawingPartManagerHelpers.bl);
        a.ay(DrawingMLMain.hi, DrawingPartManagerHelpers.bn);
        a.ay(DrawingMLMain.hl, DrawingPartManagerHelpers.bo);
        a.ay(DrawingMLMain.hn, DrawingPartManagerHelpers.bp);
        a.ay(DrawingMLMain.hp, DrawingPartManagerHelpers.bq);
        a.ay(DrawingMLMain.hu, DrawingPartManagerHelpers.bu);
        a.ay(DrawingMLMain.hx, DrawingPartManagerHelpers.br);
        a.ay(DrawingMLMain.hy, DrawingPartManagerHelpers.bs);
        a.ay(DrawingMLMain.hz, DrawingPartManagerHelpers.bt);
        a.ay(DrawingMLMain.h7, DrawingPartManagerHelpers.bv);
        a.ay(DrawingMLMain.ia, DrawingPartManagerHelpers.bw);
        a.ay(DrawingMLMain.ib, DrawingPartManagerHelpers.bx);
        a.ay(DrawingMLMain.ic, DrawingPartManagerHelpers.by);
        a.ay(DrawingMLMain.ie, DrawingPartManagerHelpers.bz);
        a.ay(DrawingMLMain.ii, DrawingPartManagerHelpers.b0);
        a.ay(DrawingMLMain.io, DrawingPartManagerHelpers.b2);
        a.ay(DrawingMLMain.iy, DrawingPartManagerHelpers.b4);
        a.ay(DrawingMLMain.iz, DrawingPartManagerHelpers.b6);
        a.ay(DrawingMLMain.i0, DrawingPartManagerHelpers.b7);
        a.ay(DrawingMLMain.i2, DrawingPartManagerHelpers.b9);
        a.ay(DrawingMLMain.i8, DrawingPartManagerHelpers.cb);
        a.ay(DrawingMLMain.ja, DrawingPartManagerHelpers.cd);
        a.ay(DrawingMLMain.je, DrawingPartManagerHelpers.cc);
        a.ay(DrawingMLMain.jm, DrawingPartManagerHelpers.ce);
        a.ay(DrawingMLMain.j8, DrawingPartManagerHelpers.cg);
        a.ay(DrawingMLChart.be, DrawingPartManagerHelpers.n);
        a.ay(DrawingMLChart2014.ap, DrawingPartManagerHelpers.o);
        a.ay(Drawing2010Slicer.as, DrawingPartManagerHelpers.b1);
        var b = a.d._t;
        if (b != null) {
            a.ay(b.an, DrawingPartManagerHelpers.i);
            a.ay(b.ap, DrawingPartManagerHelpers.u);
            a.ay(b.aq, DrawingPartManagerHelpers.v);
            a.ay(b.ar, DrawingPartManagerHelpers.w);
            a.ay(b.as, DrawingPartManagerHelpers.x);
            a.ay(b.at, DrawingPartManagerHelpers.y);
            a.ay(b.au, DrawingPartManagerHelpers.z);
            a.ay(b.av, DrawingPartManagerHelpers.ac);
            a.ay(b.aw, DrawingPartManagerHelpers.ad);
            a.ay(b.ay, DrawingPartManagerHelpers.ah);
            a.ay(b.a3, DrawingPartManagerHelpers.ar);
            a.ay(b.a4, DrawingPartManagerHelpers.ay);
            a.ay(b.a5, DrawingPartManagerHelpers.az);
            a.ay(b.a6, DrawingPartManagerHelpers.a0);
            a.ay(b.bn, DrawingPartManagerHelpers.bf);
            a.ay(b.bo, DrawingPartManagerHelpers.bg);
            a.ay(b.bp, DrawingPartManagerHelpers.bh);
            a.ay(b.bq, DrawingPartManagerHelpers.bi);
            a.ay(b.br, DrawingPartManagerHelpers.bj);
            a.ay(b.bs, DrawingPartManagerHelpers.bm);
            a.ay(b.bw, DrawingPartManagerHelpers.b3);
            a.ay(b.bx, DrawingPartManagerHelpers.b5);
            a.ay(b.by, DrawingPartManagerHelpers.b8);
            a.ay(b.bz, DrawingPartManagerHelpers.ca);
            a.ay(b.b1, DrawingPartManagerHelpers.cf);
            a.ay(b.b3, DrawingPartManagerHelpers.cg);
        }
    };
    DrawingPartManagerHelpers.ci = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.nh(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.cj = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.ni(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ck = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.nj(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.cl = function (a, b) {
        if (b == null) {
            return;
        }
        a.ad.g(Enumerable.o(Tuple$2.$.specialize(Array_$type, IGraphicalObjectContent_$type), AlternateContentChoice.$, b.b, function (c) { return new AlternateContentChoice(1, c.c, function () { return c.d._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a); }); }), b.a == null ? null : function () { return b.a._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a); });
    };
    DrawingPartManagerHelpers.cm = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.nk(a);
        b.b.q(function (c) { return DrawingPartManagerHelpers.df(a, c); });
        a.ad.k();
    };
    DrawingPartManagerHelpers.cn = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.nl(a, b.d, b.e, b.c);
        if (b.a != null || b.b != null) {
            a.ad.o(DrawingMLMain.cj);
            if (b.a != null && b.a.a != null) {
                a.ad.o(DrawingMLMain.ck);
                b.a.a._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
                a.ad.k();
            }
            if (b.b != null && b.b.a != null) {
                a.ad.o(DrawingMLMain.cn);
                b.b.a._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
                a.ad.k();
            }
            a.ad.k();
        }
        a.ad.k();
    };
    DrawingPartManagerHelpers.co = function (a, b, c) {
        if (c === void 0) {
            c = false;
        }
        if (b == null) {
            return;
        }
        if (c) {
            a.d._t.cv(a, nullableEquals(b.b, 0) ? toNullable(Number_$type, null) : b.b, nullableEquals(b.c, false) ? toNullable(Boolean_$type, null) : b.c);
        }
        else {
            DrawingMLMain.nm(a, nullableEquals(b.b, 0) ? toNullable(Number_$type, null) : b.b, nullableEquals(b.c, false) ? toNullable(Boolean_$type, null) : b.c);
        }
        DrawingPartManagerHelpers.cn(a, b.d);
        DrawingPartManagerHelpers.ew(a, b.a);
        if (b.e != null) {
            b.e._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        a.ad.k();
    };
    DrawingPartManagerHelpers.cp = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.nn(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.cq = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.no(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.cr = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.np(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.cs = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.nq(a, b.n, b.l, b.q, b.p, b.t, b.r, b.j, b.s, b.m, b.f, b.k, b.o, b.a, b.i, b.d, b.e, b.h, b.c, b.g);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ct = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.nr(a, b.a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.cu = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.ns(a, b.a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.cv = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.cw(a);
        DrawingPartManagerHelpers.c7(a, b.c);
        DrawingPartManagerHelpers.ey(a, b.b);
        DrawingPartManagerHelpers.da(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.cw = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.cx(a);
        DrawingPartManagerHelpers.dl(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.cx = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.cy(a);
        DrawingPartManagerHelpers.ds(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.cy = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.cz(a, b.b);
        DrawingPartManagerHelpers.ee(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.cz = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.c0(a, b.c, b.f, b.e, b.d, b.g);
        a.ad.k();
    };
    DrawingPartManagerHelpers.c0 = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.c1(a, b.b);
        DrawingPartManagerHelpers.eu(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.c1 = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.nu(a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.c2 = function (a, b) {
        if (b == null) {
            return;
        }
        var c = b.b.hasValue ? b.b.value : 1;
        DrawingMLMain.nv(a, b.d, b.a, b.c, c);
        a.ad.k();
    };
    DrawingPartManagerHelpers.c3 = function (a, b, c) {
        if (b == null) {
            return;
        }
        c(a, b.b, b.c, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.c4 = function (a, b, c) {
        if (b == null) {
            return;
        }
        c(a, b.b, b.d, b.c, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.c5 = function (a, b) {
        if (b == null) {
            return;
        }
        a.ad.n(b.g);
    };
    DrawingPartManagerHelpers.c6 = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.c3(a);
        DrawingPartManagerHelpers.d6(a, b.a);
        DrawingPartManagerHelpers.ev(a, b.spPr);
        DrawingPartManagerHelpers.e0(a, b.style);
        a.ad.k();
    };
    DrawingPartManagerHelpers.c7 = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.c4(a, b.f, b.j, b.i, b.c, b.g, b.h, b.e, b.a, b.b, b.d);
        a.ad.k();
    };
    DrawingPartManagerHelpers.c8 = function (a, b) {
        if (b == null) {
            return;
        }
        var c = b.b.hasValue ? b.b.value : 1;
        DrawingMLMain.oe(a, b.d, b.a, b.c, c);
        a.ad.k();
    };
    DrawingPartManagerHelpers.c9 = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.of(a, b.b);
        if (b.a != null) {
            b.a._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        a.ad.k();
    };
    DrawingPartManagerHelpers.da = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.c5(a, b.a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.db = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.og(a, b.a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dc = function (a, b) {
        DrawingPartManagerHelpers.c4(a, b, DrawingMLMain.ok);
    };
    DrawingPartManagerHelpers.dd = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.ol(a, b.b);
        if (b.a != null) {
            b.a._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        a.ad.k();
    };
    DrawingPartManagerHelpers.de = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.oo(a, b.b);
        if (b.a != null) {
            b.a._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        a.ad.k();
    };
    DrawingPartManagerHelpers.df = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.oq(a, b.b, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dh = function (a, b) {
        var c = typeCast(IGraphicalObjectContent_$type, b.d);
        if (c != null) {
            c._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
            return;
        }
        var d = typeCast(CT_RelId.$, b.d);
        if (d != null) {
            switch (b.c) {
                case DrawingMLChart.be:
                    DrawingMLChart.gy(a, d.a);
                    a.ad.k();
                    break;
                case DrawingMLChart2014.ap:
                    DrawingMLChart2014.au(a, d.a);
                    a.ad.k();
                    break;
                default: break;
            }
            return;
        }
        var e = typeCast(CT_Slicer.$, b.d);
        if (e != null) {
            switch (b.c) {
                case Drawing2010Slicer.as:
                    Drawing2010Slicer.au(a, e.a);
                    a.ad.k();
                    break;
                default: break;
            }
            return;
        }
    };
    DrawingPartManagerHelpers.di = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.or(a, b.c);
        b.b.q(function (c) { return DrawingPartManagerHelpers.dh(a, c); });
        a.ad.k();
    };
    DrawingPartManagerHelpers.dj = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.os(a);
        DrawingPartManagerHelpers.di(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dk = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.c6(a, b.e, b.d);
        DrawingPartManagerHelpers.d7(a, b.b);
        DrawingPartManagerHelpers.e6(a, b.c, runOn(a.d._t, a.d._t.dm));
        DrawingPartManagerHelpers.dj(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dl = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.ot(a, b.c, b.b, b.f, b.a, b.d, b.e);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dm = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.ou(a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dn = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.ov(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dp = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.ow(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dq = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.ox(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dr = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.c7(a);
        DrawingPartManagerHelpers.d8(a, b.a);
        DrawingPartManagerHelpers.dt(a, b.b);
        b.d.q(function (c) { return c._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a); });
        a.ad.k();
    };
    DrawingPartManagerHelpers.ds = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.c8(a, b.b, b.g, b.f, b.e, b.a, b.c, b.d);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dt = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.c9(a, b.b);
        DrawingPartManagerHelpers.e5(a, b.c);
        if (b.a != null) {
            b.a._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        a.ad.k();
    };
    DrawingPartManagerHelpers.du = function (a, b) {
        DrawingPartManagerHelpers.c3(a, b, DrawingMLMain.oz);
    };
    DrawingPartManagerHelpers.dv = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.o2(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dw = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.o3(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dx = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.o4(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dy = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.o5(a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.dz = function (a, b) {
        if (b == null) {
            return;
        }
        var c = b.b.hasValue ? b.b.value : 1;
        DrawingMLMain.o6(a, b.d, b.a, b.c, c);
        a.ad.k();
    };
    DrawingPartManagerHelpers.d0 = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.o7(a, b.h, b.f, b.g, b.e);
        if (b.i != null) {
            b.i._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        if (b.c != null) {
            b.c._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        if (b.d != null) {
            b.d._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        DrawingPartManagerHelpers.du(a, b.a);
        DrawingPartManagerHelpers.e2(a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.d1 = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.o8(a, b.b);
        if (b.a != null) {
            b.a._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        a.ad.k();
    };
    DrawingPartManagerHelpers.d2 = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pc(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.d3 = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pd(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.d4 = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pe(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.d5 = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.ph(a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.d6 = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.db(a);
        DrawingPartManagerHelpers.cz(a, b.a);
        DrawingPartManagerHelpers.cv(a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.d7 = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.dc(a);
        DrawingPartManagerHelpers.cz(a, b.a);
        DrawingPartManagerHelpers.cw(a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.d8 = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.dd(a);
        DrawingPartManagerHelpers.cz(a, b.a);
        DrawingPartManagerHelpers.cx(a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.d9 = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.de(a);
        DrawingPartManagerHelpers.cz(a, b.a);
        DrawingPartManagerHelpers.cy(a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ea = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.df(a);
        DrawingPartManagerHelpers.cz(a, b.a);
        DrawingPartManagerHelpers.c0(a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.eb = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pj(a, b.a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ec = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pk(a);
        DrawingPartManagerHelpers.ef(a, b.a);
        b.c.q(function (c) { return c._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a); });
        a.ad.k();
    };
    DrawingPartManagerHelpers.ed = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.dg(a);
        DrawingPartManagerHelpers.d9(a, b.b);
        DrawingPartManagerHelpers.co(a, b.a, true);
        DrawingPartManagerHelpers.ev(a, b.spPr);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ee = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pl(a, b.g, b.k, b.j, b.c, b.h, b.i, b.f, b.a, b.b, b.d, b.e);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ef = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pm(a, b.k, b.l, b.j, b.h, b.c, b.d, b.m, b.e, b.f, b.i, b.g);
        a.ad.k();
    };
    DrawingPartManagerHelpers.eg = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pn(a, b.c);
        b.b.q(function (c) { return c._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a); });
        a.ad.k();
    };
    DrawingPartManagerHelpers.eh = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.po(a, b.b);
        DrawingPartManagerHelpers.cm(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ei = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pp(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ej = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pq(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ek = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pr(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.el = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.ps(a);
        DrawingPartManagerHelpers.em(a, b.a);
        DrawingMLMain.p6(a, b.b);
        a.ad.k();
        a.ad.k();
    };
    DrawingPartManagerHelpers.em = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pt(a, b.k, b.v, b.t, ST_TextFontSize.h(b.r), b.d, b.i, b.s, b.q, b.j, b.f, b.p, b.m, b.e, b.l, b.g, b.h, b.n, b.o, b.u);
        DrawingPartManagerHelpers.d0(a, b.w);
        if (b.y != null) {
            b.y._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        DrawingPartManagerHelpers.dz(a, b.c);
        DrawingPartManagerHelpers.c8(a, b.b);
        DrawingPartManagerHelpers.c2(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.en = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pu(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.eo = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pv(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ep = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pw(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.eq = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.px(a, b.c);
        b.b.q(function (c) { return c._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a); });
        a.ad.k();
    };
    DrawingPartManagerHelpers.dg = function (a, b) {
        if (b == null) {
            return;
        }
        b._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
    };
    DrawingPartManagerHelpers.es = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.pz(a);
        if (b.a != null) {
            b.a._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        a.ad.k();
    };
    DrawingPartManagerHelpers.et = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.dh(a);
        DrawingPartManagerHelpers.ea(a, b.a);
        DrawingPartManagerHelpers.ev(a, b.spPr);
        DrawingPartManagerHelpers.e0(a, b.style);
        DrawingPartManagerHelpers.e4(a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.eu = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.p0(a, b.f, b.j, b.i, b.c, b.g, b.h, b.e, b.a, b.b, b.d, b.k);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ev = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.di(a, b.b);
        DrawingPartManagerHelpers.e6(a, b.d, DrawingMLMain.qb);
        if (b.e != null) {
            b.e._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        if (b.a != null) {
            b.a._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a);
        }
        DrawingPartManagerHelpers.d0(a, b.c);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ew = function (a, b) {
        DrawingPartManagerHelpers.c4(a, b, DrawingMLMain.p1);
    };
    DrawingPartManagerHelpers.er = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.py(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ex = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.p2(a, b.c);
        b.b.q(function (c) { return c._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a); });
        a.ad.k();
    };
    DrawingPartManagerHelpers.ey = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.dj(a, b.a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.ez = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.p3(a);
        DrawingPartManagerHelpers.dc(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.e0 = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.dk(a);
        DrawingPartManagerHelpers.d1(a, b.d);
        DrawingPartManagerHelpers.dd(a, b.c);
        DrawingPartManagerHelpers.c9(a, b.b);
        DrawingPartManagerHelpers.de(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.e1 = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.p4(a, b.d, b.c);
        b.b.q(function (c) { return c._accept$2$i(XmlPartManagerBase.$, Boolean_$type, DrawingPartManagerHelpers_DrawingSerializationHelper.a, a); });
        a.ad.k();
    };
    DrawingPartManagerHelpers.e2 = function (a, b) {
        DrawingPartManagerHelpers.c3(a, b, DrawingMLMain.p5);
    };
    DrawingPartManagerHelpers.e3 = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.qa(a, b.a);
        a.ad.k();
    };
    DrawingPartManagerHelpers.e4 = function (a, b) {
        if (b == null) {
            return;
        }
        a.d._t.dl(a);
        DrawingPartManagerHelpers.cs(a, b.a);
        b.d.q(function (c) { return DrawingPartManagerHelpers.ec(a, c); });
        a.ad.k();
    };
    DrawingPartManagerHelpers.e6 = function (a, b, c) {
        if (b == null) {
            return;
        }
        c(a, b.d(), b.g(), b.h());
        DrawingPartManagerHelpers.eb(a, b.a);
        DrawingPartManagerHelpers.db(a, b.b);
        a.ad.k();
    };
    DrawingPartManagerHelpers.e5 = function (a, b) {
        if (b == null) {
            return;
        }
        DrawingMLMain.qb(a, b.d(), b.g(), b.h());
        DrawingPartManagerHelpers.eb(a, b.a);
        DrawingPartManagerHelpers.db(a, b.b);
        DrawingPartManagerHelpers.cu(a, b.l);
        DrawingPartManagerHelpers.ct(a, b.m);
        a.ad.k();
    };
    DrawingPartManagerHelpers.$t = markType(DrawingPartManagerHelpers, 'DrawingPartManagerHelpers');
    return DrawingPartManagerHelpers;
}(Base));
export { DrawingPartManagerHelpers };
/**
 * @hidden
 */
var DrawingPartManagerHelpers_DrawingSerializationHelper = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DrawingPartManagerHelpers_DrawingSerializationHelper, _super);
    function DrawingPartManagerHelpers_DrawingSerializationHelper() {
        return _super.call(this) || this;
    }
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_SchemeColor$i = function (a, b) {
        DrawingPartManagerHelpers.eq(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_SRgbColor$i = function (a, b) {
        DrawingPartManagerHelpers.ex(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_SysColor$i = function (a, b) {
        DrawingPartManagerHelpers.e1(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_PresetColor$i = function (a, b) {
        DrawingPartManagerHelpers.eg(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Alpha$i = function (a, b) {
        DrawingPartManagerHelpers.ci(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_AlphaMod$i = function (a, b) {
        DrawingPartManagerHelpers.cj(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_AlphaOff$i = function (a, b) {
        DrawingPartManagerHelpers.ck(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Blue$i = function (a, b) {
        DrawingPartManagerHelpers.cp(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_BlueMod$i = function (a, b) {
        DrawingPartManagerHelpers.cq(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_BlueOff$i = function (a, b) {
        DrawingPartManagerHelpers.cr(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Comp$i = function (a, b) {
        DrawingPartManagerHelpers.c1(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Gray$i = function (a, b) {
        DrawingPartManagerHelpers.dm(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Green$i = function (a, b) {
        DrawingPartManagerHelpers.dn(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_GreenMod$i = function (a, b) {
        DrawingPartManagerHelpers.dp(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_GreenOff$i = function (a, b) {
        DrawingPartManagerHelpers.dq(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Hue$i = function (a, b) {
        DrawingPartManagerHelpers.dv(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_HueMod$i = function (a, b) {
        DrawingPartManagerHelpers.dw(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_HueOff$i = function (a, b) {
        DrawingPartManagerHelpers.dx(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Inv$i = function (a, b) {
        DrawingPartManagerHelpers.dy(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Lum$i = function (a, b) {
        DrawingPartManagerHelpers.d2(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_LumMod$i = function (a, b) {
        DrawingPartManagerHelpers.d3(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_LumOff$i = function (a, b) {
        DrawingPartManagerHelpers.d4(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Red$i = function (a, b) {
        DrawingPartManagerHelpers.ei(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_RedMod$i = function (a, b) {
        DrawingPartManagerHelpers.ej(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_RedOff$i = function (a, b) {
        DrawingPartManagerHelpers.ek(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Sat$i = function (a, b) {
        DrawingPartManagerHelpers.en(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_SatMod$i = function (a, b) {
        DrawingPartManagerHelpers.eo(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_SatOff$i = function (a, b) {
        DrawingPartManagerHelpers.ep(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Shade$i = function (a, b) {
        DrawingPartManagerHelpers.er(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitColorTransform_Tint$i = function (a, b) {
        DrawingPartManagerHelpers.e3(b, a);
        return false;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_StretchInfoProperties$i = function (a, b) {
        DrawingPartManagerHelpers.ez(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_TileInfoProperties$i = function (a, b) {
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_BlipFillProperties$i = function (a, b) {
        DrawingPartManagerHelpers.co(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_GroupFillProperties$i = function (a, b) {
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_NoFillProperties$i = function (a, b) {
        DrawingPartManagerHelpers.d5(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_SolidFillProperties$i = function (a, b) {
        DrawingPartManagerHelpers.es(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_PresetGeometry2D$i = function (a, b) {
        DrawingPartManagerHelpers.eh(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_CustomGeometry2D$i = function (a, b) {
        DrawingPartManagerHelpers.c5(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_DashStopList$i = function (a, b) {
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_PresetLineDashProperties$i = function (a, b) {
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_NoFillProperties1$i = function (a, b) {
        DrawingPartManagerHelpers.d5(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_SolidFillProperties1$i = function (a, b) {
        DrawingPartManagerHelpers.es(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_LineJoinBevel$i = function (a, b) {
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_LineJoinMiterProperties$i = function (a, b) {
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_LineJoinRound$i = function (a, b) {
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_RegularTextRun$i = function (a, b) {
        DrawingPartManagerHelpers.el(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitAlternateGraphicalObjectContent$i = function (a, b) {
        DrawingPartManagerHelpers.cl(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_Connector$i = function (a, b) {
        DrawingPartManagerHelpers.c6(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_GraphicalObjectFrame$i = function (a, b) {
        DrawingPartManagerHelpers.dk(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_GroupShape$i = function (a, b) {
        DrawingPartManagerHelpers.dr(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_Picture$i = function (a, b) {
        DrawingPartManagerHelpers.ed(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.prototype._visitCT_Shape$i = function (a, b) {
        DrawingPartManagerHelpers.et(b, a);
        return true;
    };
    DrawingPartManagerHelpers_DrawingSerializationHelper.$t = markType(DrawingPartManagerHelpers_DrawingSerializationHelper, 'DrawingPartManagerHelpers_DrawingSerializationHelper', Base.$, [IEG_ColorChoiceVisitor$2_$type.specialize(XmlPartManagerBase.$, Boolean_$type), IEG_ColorTransformVisitor$2_$type.specialize(XmlPartManagerBase.$, Boolean_$type), IEG_FillModePropertiesVisitor$2_$type.specialize(XmlPartManagerBase.$, Boolean_$type), IEG_FillPropertiesVisitor$2_$type.specialize(XmlPartManagerBase.$, Boolean_$type), IEG_GeometryVisitor$2_$type.specialize(XmlPartManagerBase.$, Boolean_$type), IEG_LineDashPropertiesVisitor$2_$type.specialize(XmlPartManagerBase.$, Boolean_$type), IEG_LineFillPropertiesVisitor$2_$type.specialize(XmlPartManagerBase.$, Boolean_$type), IEG_LineJoinPropertiesVisitor$2_$type.specialize(XmlPartManagerBase.$, Boolean_$type), IEG_TextRunVisitor$2_$type.specialize(XmlPartManagerBase.$, Boolean_$type), IGraphicalObjectContentVisitor$2_$type.specialize(XmlPartManagerBase.$, Boolean_$type)]);
    DrawingPartManagerHelpers_DrawingSerializationHelper.a = new DrawingPartManagerHelpers_DrawingSerializationHelper();
    return DrawingPartManagerHelpers_DrawingSerializationHelper;
}(Base));
export { DrawingPartManagerHelpers_DrawingSerializationHelper };
