/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { OfficeDocumentManager } from "./OfficeDocumentManager";
import { DrawingMLSpreadsheetDrawing } from "./DrawingMLSpreadsheetDrawing";
import { fromEnum, markType } from "igniteui-angular-core";
import { ExcelNamespace } from "./ExcelNamespace";
import { Excel2006Main } from "./Excel2006Main";
import { SpreadsheetMLMain } from "./SpreadsheetMLMain";
import { SpreadsheetML2009Main } from "./SpreadsheetML2009Main";
import { BmpPartManager } from "./BmpPartManager";
import { EmfPartManager } from "./EmfPartManager";
import { GifPartManager } from "./GifPartManager";
import { JpegPartManager } from "./JpegPartManager";
import { PngPartManager } from "./PngPartManager";
import { TiffPartManager } from "./TiffPartManager";
import { WmfPartManager } from "./WmfPartManager";
import { WorkbookPartManagerBase } from "./WorkbookPartManagerBase";
/**
 * @hidden
 */
var ExcelDocumentManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ExcelDocumentManager, _super);
    function ExcelDocumentManager(a, b, c, d) {
        return _super.call(this, a, b, c, d) || this;
    }
    ExcelDocumentManager.prototype.get__v = function () {
        return 0;
    };
    Object.defineProperty(ExcelDocumentManager.prototype, "_v", {
        get: function () {
            return this.get__v();
        },
        enumerable: false,
        configurable: true
    });
    ExcelDocumentManager.prototype._aa = function () {
        var e_1, _a;
        if (this._ac == false) {
            return 0;
        }
        try {
            for (var _c = __values(fromEnum(this._b.getRelationships())), _d = _c.next(); !_d.done; _d = _c.next()) {
                var a = _d.value;
                switch (a.relationshipType) {
                    case WorkbookPartManagerBase.a6: return 0;
                    case WorkbookPartManagerBase.a5: return 1;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return 0;
    };
    ExcelDocumentManager.prototype._bh = function () {
        _super.prototype._bh.call(this);
        this._bk(DrawingMLSpreadsheetDrawing.dn);
        this._bk(ExcelNamespace.an);
        this._bk(Excel2006Main.an);
        this._bk(SpreadsheetMLMain.ao);
        this._bk(SpreadsheetML2009Main.an);
        this._bl(BmpPartManager.y);
        this._bl(EmfPartManager.y);
        this._bl(GifPartManager.y);
        this._bl(JpegPartManager.y);
        this._bl(PngPartManager.y);
        this._bl(TiffPartManager.y);
        this._bl(WmfPartManager.y);
    };
    ExcelDocumentManager.prototype.get__t = function () {
        return DrawingMLSpreadsheetDrawing.dn;
    };
    Object.defineProperty(ExcelDocumentManager.prototype, "_t", {
        get: function () {
            return this.get__t();
        },
        enumerable: false,
        configurable: true
    });
    ExcelDocumentManager.prototype._bq = function () {
        switch (this._z) {
            case 0: return ExcelDocumentManager._bp;
            case 1: return ExcelDocumentManager._bo;
            default: return ExcelDocumentManager._bp;
        }
    };
    ExcelDocumentManager.prototype._br = function () {
        switch (this._z) {
            case 0: return ExcelDocumentManager._bt;
            case 1: return ExcelDocumentManager._bs;
            default: return ExcelDocumentManager._bt;
        }
    };
    ExcelDocumentManager.$t = markType(ExcelDocumentManager, 'ExcelDocumentManager', OfficeDocumentManager.$);
    ExcelDocumentManager._bp = "http://schemas.openxmlformats.org/officeDocument/2006/relationships/externalLinkPath";
    ExcelDocumentManager._bo = "http://purl.oclc.org/ooxml/officeDocument/relationships/externalLinkPath";
    ExcelDocumentManager._bt = "http://schemas.openxmlformats.org/officeDocument/2006/relationships/oleObject";
    ExcelDocumentManager._bs = "http://purl.oclc.org/ooxml/officeDocument/relationships/oleObject";
    return ExcelDocumentManager;
}(OfficeDocumentManager));
export { ExcelDocumentManager };
