/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which define the manner in which map labels are displayed.
 */
export var GeographicMapLabels = /*@__PURE__*/ (function (GeographicMapLabels) {
    /**
     * Map labels are not displayed.
     */
    GeographicMapLabels[GeographicMapLabels["None"] = 0] = "None";
    /**
     * Map labels are displayed only for regions inside which the label can fit.
     */
    GeographicMapLabels[GeographicMapLabels["BestFit"] = 1] = "BestFit";
    /**
     * Map labels are displayed for all regions.
     */
    GeographicMapLabels[GeographicMapLabels["ShowAll"] = 2] = "ShowAll";
    return GeographicMapLabels;
})({});
/**
 * @hidden
 */
export var GeographicMapLabels_$type = markEnum('GeographicMapLabels', 'None,0|BestFit,1|ShowAll,2');
