/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the way pages are numbered when printed.
 */
export var PageNumbering = /*@__PURE__*/ (function (PageNumbering) {
    /**
     * Pages are automatically numbered based on the style of the worksheet.
     */
    PageNumbering[PageNumbering["Automatic"] = 0] = "Automatic";
    /**
     * The starting page number specified is used for the first page, additional
     * pages receive a page number that it one greater than the previous page.
     */
    PageNumbering[PageNumbering["UseStartPageNumber"] = 1] = "UseStartPageNumber";
    return PageNumbering;
})({});
/**
 * @hidden
 */
export var PageNumbering_$type = markEnum('PageNumbering', 'Automatic,0|UseStartPageNumber,1');
