/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the options available for getting or setting the bounds of a shape, cell, or region.
 */
export var PositioningOptions = /*@__PURE__*/ (function (PositioningOptions) {
    /**
     * No special options should be used. Get and set actual bounds on the worksheet in its current state.
     */
    PositioningOptions[PositioningOptions["None"] = 0] = "None";
    /**
     * Ignore the [[RowColumnBase.hidden]] value on all rows and columns.
     * Get and set bounds as if all rows and columns were currently visible.
     */
    PositioningOptions[PositioningOptions["TreatAllRowsAndColumnsAsVisible"] = 1] = "TreatAllRowsAndColumnsAsVisible";
    return PositioningOptions;
})({});
/**
 * @hidden
 */
export var PositioningOptions_$type = markEnum('PositioningOptions', 'None,0|TreatAllRowsAndColumnsAsVisible,1');
