/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which determine the reading order.
 */
export var ReadingOrder = /*@__PURE__*/ (function (ReadingOrder) {
    /**
     * The direction is based on context.
     */
    ReadingOrder[ReadingOrder["Context"] = -5002] = "Context";
    /**
     * The order is left-to-right.
     */
    ReadingOrder[ReadingOrder["LeftToRight"] = -5003] = "LeftToRight";
    /**
     * The order is right-to-left.
     */
    ReadingOrder[ReadingOrder["RightToLeft"] = -5004] = "RightToLeft";
    return ReadingOrder;
})({});
/**
 * @hidden
 */
export var ReadingOrder_$type = markEnum('ReadingOrder', 'Context,-5002|LeftToRight,-5003|RightToLeft,-5004');
