/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various sort directions which can be used with a [[SortCondition]].
 * @see [[SortCondition.sortDirection]]
 */
export var SortDirection = /*@__PURE__*/ (function (SortDirection) {
    /**
     * Sort values in an ascending manner.
     */
    SortDirection[SortDirection["Ascending"] = 0] = "Ascending";
    /**
     * Sort values in an descending manner.
     */
    SortDirection[SortDirection["Descending"] = 1] = "Descending";
    return SortDirection;
})({});
/**
 * @hidden
 */
export var SortDirection_$type = markEnum('SortDirection', 'Ascending,0|Descending,1');
