/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which determine the unit of measure for [[Axis]] date/time values.
 */
export var TimeUnit = /*@__PURE__*/ (function (TimeUnit) {
    /**
     * The Axis interval is expressed in days.
     */
    TimeUnit[TimeUnit["Days"] = 0] = "Days";
    /**
     * The Axis interval is expressed in months.
     */
    TimeUnit[TimeUnit["Months"] = 1] = "Months";
    /**
     * The Axis interval is expressed in years.
     */
    TimeUnit[TimeUnit["Years"] = 2] = "Years";
    return TimeUnit;
})({});
/**
 * @hidden
 */
export var TimeUnit_$type = markEnum('TimeUnit', 'Days,0|Months,1|Years,2');
