/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { Convert } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionChar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionChar, _super);
    function UltraCalcFunctionChar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionChar.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var d = c._toInt321();
        return new ExcelCalcValue(Convert.toChar1(d));
    };
    UltraCalcFunctionChar.prototype.get_name = function () {
        return "char";
    };
    Object.defineProperty(UltraCalcFunctionChar.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionChar.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionChar.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionChar.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionChar.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionChar.$t = markType(UltraCalcFunctionChar, 'UltraCalcFunctionChar', BuiltInFunctionBase.$);
    return UltraCalcFunctionChar;
}(BuiltInFunctionBase));
export { UltraCalcFunctionChar };
