/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionCode = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionCode, _super);
    function UltraCalcFunctionCode() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionCode.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var d = c.toString();
        if (d == null || d.length == 0) {
            return new ExcelCalcValue(0);
        }
        return new ExcelCalcValue(d.charAt(0).charCodeAt(0));
    };
    UltraCalcFunctionCode.prototype.get_name = function () {
        return "code";
    };
    Object.defineProperty(UltraCalcFunctionCode.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionCode.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionCode.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionCode.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionCode.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionCode.$t = markType(UltraCalcFunctionCode, 'UltraCalcFunctionCode', BuiltInFunctionBase.$);
    return UltraCalcFunctionCode;
}(BuiltInFunctionBase));
export { UltraCalcFunctionCode };
