/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { CalcManagerUtilities } from "./CalcManagerUtilities";
import { markType } from "igniteui-angular-core";
import { dateGetDate, dateFromValues, dateGetMonth, daysInMonth } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionEOMonth = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionEOMonth, _super);
    function UltraCalcFunctionEOMonth() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionEOMonth.prototype.evaluate = function (a, b) {
        var c = a.pop()._toDouble3();
        var d = dateGetDate(a.pop()._toDateTime1());
        d = CalcManagerUtilities.b(2, c, d);
        d = dateFromValues(d.getFullYear(), dateGetMonth(d), daysInMonth(d.getFullYear(), dateGetMonth(d)), 0, 0, 0, 0);
        return new ExcelCalcValue(d);
    };
    UltraCalcFunctionEOMonth.prototype.get_name = function () {
        return "eomonth";
    };
    Object.defineProperty(UltraCalcFunctionEOMonth.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionEOMonth.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionEOMonth.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionEOMonth.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionEOMonth.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionEOMonth.$t = markType(UltraCalcFunctionEOMonth, 'UltraCalcFunctionEOMonth', BuiltInFunctionBase.$);
    return UltraCalcFunctionEOMonth;
}(BuiltInFunctionBase));
export { UltraCalcFunctionEOMonth };
