/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { CalcFunctionUtilities } from "./CalcFunctionUtilities";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { truncate } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionEffect = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionEffect, _super);
    function UltraCalcFunctionEffect() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionEffect.prototype.evaluate = function (a, b) {
        return CalcFunctionUtilities.j(a, false, function (c, d) {
            var e = truncate(d);
            var f = e;
            if (c <= 0 || f < 1) {
                return new ExcelCalcValue(new ExcelCalcErrorValue(4));
            }
            var g = Math.pow(1 + c / f, f) - 1;
            return new ExcelCalcValue(g);
        });
    };
    UltraCalcFunctionEffect.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionEffect.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionEffect.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionEffect.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionEffect.prototype.get_name = function () {
        return "effect";
    };
    Object.defineProperty(UltraCalcFunctionEffect.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionEffect.$t = markType(UltraCalcFunctionEffect, 'UltraCalcFunctionEffect', BuiltInFunctionBase.$);
    return UltraCalcFunctionEffect;
}(BuiltInFunctionBase));
export { UltraCalcFunctionEffect };
