/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { UltraCalcFunctionLookupBase } from "./UltraCalcFunctionLookupBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { markType } from "igniteui-angular-core";
import { truncate } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionHLookup = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionHLookup, _super);
    function UltraCalcFunctionHLookup() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionHLookup.prototype.evaluate = function (a, b) {
        var c = null;
        if (b == 4) {
            c = a.pop();
        }
        var d = a.pop();
        var e = a.pop();
        var f = a.pop();
        if (f.isError) {
            return f;
        }
        if (e.isError) {
            return e;
        }
        if (d.isError) {
            return d;
        }
        if (c != null && c.isError) {
            return c;
        }
        if (f.isArray || f.isArrayGroup) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(3));
        }
        if (f.isNull) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(3));
        }
        var g = e._d(false);
        var h;
        if (((function () { var i = d._toDouble1(h); h = i.p0; return i.ret; })()) == false || h < 1) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(1));
        }
        var i = truncate(Math.floor(h)) - 1;
        var j;
        if (((function () { var k = UltraCalcFunctionLookupBase._ak(c, j); j = k.p1; return k.ret; })()) == false) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(1));
        }
        var k = g.getLength(0);
        var l = UltraCalcFunctionLookupBase._al(g._i(1, 0), f, j ? 1 : 0);
        if (l < 0 || k <= l) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(3));
        }
        var m = g.getLength(1);
        if (m <= i) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(0));
        }
        var n = g.item(l, i);
        n._y = true;
        return new ExcelCalcValue(n._getResolvedValue());
    };
    UltraCalcFunctionHLookup.prototype.get_name = function () {
        return "hlookup";
    };
    Object.defineProperty(UltraCalcFunctionHLookup.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionHLookup.$t = markType(UltraCalcFunctionHLookup, 'UltraCalcFunctionHLookup', UltraCalcFunctionLookupBase.$);
    return UltraCalcFunctionHLookup;
}(UltraCalcFunctionLookupBase));
export { UltraCalcFunctionHLookup };
