/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
/**
 * @hidden
 */
var UltraCalcFunctionInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionInfo, _super);
    function UltraCalcFunctionInfo() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionInfo.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var d = c.toString();
        switch (d) {
            case "system": return new ExcelCalcValue("pcdos");
            case "numfile":
            case "origin":
            case "recalc":
            case "release": break;
            case "memavail":
            case "memused":
            case "totmem": break;
        }
        return new ExcelCalcValue(new ExcelCalcErrorValue(3));
    };
    UltraCalcFunctionInfo.prototype.get_name = function () {
        return "info";
    };
    Object.defineProperty(UltraCalcFunctionInfo.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionInfo.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionInfo.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionInfo.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionInfo.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionInfo.$t = markType(UltraCalcFunctionInfo, 'UltraCalcFunctionInfo', BuiltInFunctionBase.$);
    return UltraCalcFunctionInfo;
}(BuiltInFunctionBase));
export { UltraCalcFunctionInfo };
