/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionIsNull = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionIsNull, _super);
    function UltraCalcFunctionIsNull() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionIsNull.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isReference) {
            c = c.toReference().value;
        }
        return new ExcelCalcValue(c.value == null);
    };
    UltraCalcFunctionIsNull.prototype.get_name = function () {
        return "isnull";
    };
    Object.defineProperty(UltraCalcFunctionIsNull.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsNull.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionIsNull.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsNull.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionIsNull.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsNull.$t = markType(UltraCalcFunctionIsNull, 'UltraCalcFunctionIsNull', BuiltInFunctionBase.$);
    return UltraCalcFunctionIsNull;
}(BuiltInFunctionBase));
export { UltraCalcFunctionIsNull };
