/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionPermutationA = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionPermutationA, _super);
    function UltraCalcFunctionPermutationA() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionPermutationA.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var d = c._toDouble3();
        c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var e = c._toDouble3();
        if (e < 0 || d < 0) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var f = Math.pow(e, d);
        return new ExcelCalcValue(f);
    };
    UltraCalcFunctionPermutationA.prototype.get_name = function () {
        return "permutationa";
    };
    Object.defineProperty(UltraCalcFunctionPermutationA.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionPermutationA.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionPermutationA.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionPermutationA.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionPermutationA.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionPermutationA.$t = markType(UltraCalcFunctionPermutationA, 'UltraCalcFunctionPermutationA', BuiltInFunctionBase.$);
    return UltraCalcFunctionPermutationA;
}(BuiltInFunctionBase));
export { UltraCalcFunctionPermutationA };
