/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionRows = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionRows, _super);
    function UltraCalcFunctionRows() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionRows.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isReference == false && c.isError) {
            return c;
        }
        var d = c._b(false);
        if (d.length != 1) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(0));
        }
        return new ExcelCalcValue(d[0].getLength(1));
    };
    UltraCalcFunctionRows.prototype.get_name = function () {
        return "rows";
    };
    Object.defineProperty(UltraCalcFunctionRows.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRows.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionRows.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRows.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionRows.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRows.prototype._v = function (a) {
        return false;
    };
    UltraCalcFunctionRows.$t = markType(UltraCalcFunctionRows, 'UltraCalcFunctionRows', BuiltInFunctionBase.$);
    return UltraCalcFunctionRows;
}(BuiltInFunctionBase));
export { UltraCalcFunctionRows };
