/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { dateToday } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionToday = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionToday, _super);
    function UltraCalcFunctionToday() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionToday.prototype.evaluate = function (a, b) {
        return new ExcelCalcValue(dateToday());
    };
    UltraCalcFunctionToday.prototype.get_name = function () {
        return "today";
    };
    Object.defineProperty(UltraCalcFunctionToday.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionToday.prototype.get_minArgs = function () {
        return 0;
    };
    Object.defineProperty(UltraCalcFunctionToday.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionToday.prototype.get_maxArgs = function () {
        return 0;
    };
    Object.defineProperty(UltraCalcFunctionToday.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionToday.$t = markType(UltraCalcFunctionToday, 'UltraCalcFunctionToday', BuiltInFunctionBase.$);
    return UltraCalcFunctionToday;
}(BuiltInFunctionBase));
export { UltraCalcFunctionToday };
