/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { PartManagerBase } from "./PartManagerBase";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var VbaProjectPartManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VbaProjectPartManager, _super);
    function VbaProjectPartManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VbaProjectPartManager.prototype.get_m = function () {
        return "application/vnd.ms-office.vbaProject";
    };
    Object.defineProperty(VbaProjectPartManager.prototype, "m", {
        get: function () {
            return this.get_m();
        },
        enumerable: false,
        configurable: true
    });
    VbaProjectPartManager.prototype.n = function (a) {
        switch (a) {
            case 0: return "/xl/vbaProject.bin";
            case 1: return "/word/vbaProject.bin";
            default: return null;
        }
    };
    VbaProjectPartManager.prototype.o = function (a) {
        switch (a) {
            case 0: return VbaProjectPartManager.u;
            case 1: return VbaProjectPartManager.u;
            default: return VbaProjectPartManager.u;
        }
    };
    VbaProjectPartManager.prototype.get_g = function () {
        return false;
    };
    Object.defineProperty(VbaProjectPartManager.prototype, "g", {
        get: function () {
            return this.get_g();
        },
        enumerable: false,
        configurable: true
    });
    VbaProjectPartManager.$t = markType(VbaProjectPartManager, 'VbaProjectPartManager', PartManagerBase.$);
    VbaProjectPartManager.u = "http://schemas.microsoft.com/office/2006/relationships/vbaProject";
    return VbaProjectPartManager;
}(PartManagerBase));
export { VbaProjectPartManager };
