/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, Boolean_$type, markType } from "igniteui-angular-core";
import { IEG_AnchorVisitor$2_$type } from "./IEG_AnchorVisitor$2";
import { Tuple$2 } from "igniteui-angular-core";
import { Sheet } from "./Sheet";
import { WorksheetShape } from "./WorksheetShape";
import { ExcelUtils } from "./ExcelUtils";
import { MathUtilities } from "./MathUtilities";
import { XlsxUtilities } from "./XlsxUtilities";
import { truncate } from "igniteui-angular-core";
/**
 * @hidden
 */
var WorkbookLoadManagerExcel2007_ShapeAnchorApplicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(WorkbookLoadManagerExcel2007_ShapeAnchorApplicator, _super);
    function WorkbookLoadManagerExcel2007_ShapeAnchorApplicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WorkbookLoadManagerExcel2007_ShapeAnchorApplicator.prototype._visitCT_AbsoluteAnchor$i = function (a, b) {
        var c = b.c;
        var d = b.d;
        d.positioningMode = 3;
        if (a.c == null || a.d == null) {
            d._setBoundsInTwips(c, ExcelUtils.hb(0, 0, 1, 1));
            return false;
        }
        var e = ExcelUtils.hb(truncate(MathUtilities.f(a.c.a.k())), truncate(MathUtilities.f(a.c.b.k())), truncate(MathUtilities.f(a.d.a.j())), truncate(MathUtilities.f(a.d.b.j())));
        d._setBoundsInTwips(c, e);
        return true;
    };
    WorkbookLoadManagerExcel2007_ShapeAnchorApplicator.prototype._visitCT_OneCellAnchor$i = function (a, b) {
        var c = b.c;
        var d = b.d;
        d.positioningMode = 2;
        if (a.d == null || a.c == null) {
            d._setBoundsInTwips(c, ExcelUtils.hb(0, 0, 1, 1));
            return false;
        }
        else if (c.type != 0) {
            d._setBoundsInTwips(c, ExcelUtils.hb(0, 0, 1, 1));
            return false;
        }
        var e = c;
        var f = XlsxUtilities.bf(a.d, e);
        var g = WorksheetShape._ds(e, f.c, f.d, f.c, f.d);
        var h = ExcelUtils.hb(truncate(MathUtilities.f(g.left)), truncate(MathUtilities.f(g.top)), truncate(MathUtilities.f(a.c.a.j())), truncate(MathUtilities.f(a.c.b.j())));
        d._setBoundsInTwips(e, h);
        return true;
    };
    WorkbookLoadManagerExcel2007_ShapeAnchorApplicator.prototype._visitCT_TwoCellAnchor$i = function (a, b) {
        var c = b.c;
        var d = b.d;
        d.positioningMode = XlsxUtilities.x(a.e);
        if (a.c == null || a.d == null) {
            d._setBoundsInTwips(c, ExcelUtils.hb(0, 0, 1, 1));
            return false;
        }
        else if (c.type != 0) {
            d._setBoundsInTwips(c, ExcelUtils.hb(0, 0, 1, 1));
            return false;
        }
        var e = c;
        var f = XlsxUtilities.bf(a.c, e);
        var g = XlsxUtilities.bf(a.d, e);
        d._c5(e, f.c, f.d, g.c, g.d);
        return true;
    };
    WorkbookLoadManagerExcel2007_ShapeAnchorApplicator.$t = markType(WorkbookLoadManagerExcel2007_ShapeAnchorApplicator, 'WorkbookLoadManagerExcel2007_ShapeAnchorApplicator', Base.$, [IEG_AnchorVisitor$2_$type.specialize(Tuple$2.$.specialize(Sheet.$, WorksheetShape.$), Boolean_$type)]);
    WorkbookLoadManagerExcel2007_ShapeAnchorApplicator.a = new WorkbookLoadManagerExcel2007_ShapeAnchorApplicator();
    return WorkbookLoadManagerExcel2007_ShapeAnchorApplicator;
}(Base));
export { WorkbookLoadManagerExcel2007_ShapeAnchorApplicator };
