import { FormulaTokenEvaluator$1 } from "./FormulaTokenEvaluator$1";
import { FormulaToken } from "./FormulaToken";
import { BinaryOperatorToken } from "./BinaryOperatorToken";
import { IFunctionToken } from "./IFunctionToken";
import { FormulaContext } from "./FormulaContext";
import { OperandToken } from "./OperandToken";
import { ParenToken } from "./ParenToken";
import { UnaryOperatorToken } from "./UnaryOperatorToken";
import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class AddInFunctionResolver extends FormulaTokenEvaluator$1<FormulaToken> {
    static $t: Type;
    private static bh;
    constructor();
    protected a5(a: BinaryOperatorToken, b: FormulaToken, c: FormulaToken): FormulaToken;
    protected a6(a: IFunctionToken, b: FormulaToken, c: FormulaToken[]): FormulaToken;
    protected a7(a: OperandToken): FormulaToken;
    protected a8(a: ParenToken, b: FormulaToken): FormulaToken;
    protected a9(a: UnaryOperatorToken, b: FormulaToken): FormulaToken;
    static bi(a: FormulaContext): AddInFunctionResolver;
}
