import { Base, Nullable$1, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { CT_Bevel } from "./CT_Bevel";
import { CT_LightRig } from "./CT_LightRig";
import { CT_OfficeArtExtensionList } from "./CT_OfficeArtExtensionList";
import { ST_PresetMaterialType } from "./ST_PresetMaterialType";
import { XmlPartManagerBase } from "./XmlPartManagerBase";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_Cell3D extends Base implements ISupportSetProperty {
    static $t: Type;
    private b;
    private d;
    private f;
    private i;
    constructor();
    get a(): CT_Bevel;
    set a(a: CT_Bevel);
    get c(): CT_LightRig;
    set c(a: CT_LightRig);
    get e(): CT_OfficeArtExtensionList;
    set e(a: CT_OfficeArtExtensionList);
    get h(): Nullable$1<ST_PresetMaterialType>;
    set h(a: Nullable$1<ST_PresetMaterialType>);
    static k(a: XmlPartManagerBase, b: Nullable$1<ST_PresetMaterialType>): {
        p1: Nullable$1<ST_PresetMaterialType>;
    };
    static l(a: XmlPartManagerBase, b: string, c?: Nullable$1<ST_PresetMaterialType>): void;
    setProperty(a: ElementPropertyIds, b: any): void;
    toString(): string;
}
