import { Base, Nullable$1, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { CT_GeoCache } from "./CT_GeoCache";
import { ST_GeoProjectionType } from "./ST_GeoProjectionType";
import { ST_GeoMappingLevel } from "./ST_GeoMappingLevel";
import { XmlPartManagerBase } from "./XmlPartManagerBase";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_Geography extends Base implements ISupportSetProperty {
    static $t: Type;
    private b;
    private e;
    private g;
    private k;
    private m;
    private i;
    constructor();
    get a(): CT_GeoCache;
    set a(a: CT_GeoCache);
    get d(): Nullable$1<ST_GeoProjectionType>;
    set d(a: Nullable$1<ST_GeoProjectionType>);
    get f(): Nullable$1<ST_GeoMappingLevel>;
    set f(a: Nullable$1<ST_GeoMappingLevel>);
    get j(): string;
    set j(a: string);
    get l(): string;
    set l(a: string);
    get h(): string;
    set h(a: string);
    static c(a: XmlPartManagerBase): CT_Geography;
    static o(a: XmlPartManagerBase, b: Nullable$1<ST_GeoProjectionType>, c: Nullable$1<ST_GeoMappingLevel>, d: string, e: string, f: string): {
        p1: Nullable$1<ST_GeoProjectionType>;
        p2: Nullable$1<ST_GeoMappingLevel>;
        p3: string;
        p4: string;
        p5: string;
    };
    static p(a: XmlPartManagerBase, b: string, c: Nullable$1<ST_GeoProjectionType>, d: Nullable$1<ST_GeoMappingLevel>, e: string, f: string, g: string): void;
    setProperty(a: ElementPropertyIds, b: any): void;
    toString(): string;
}
