import { Base, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { CT_BaseStyles } from "./CT_BaseStyles";
import { CT_ObjectStyleDefaults } from "./CT_ObjectStyleDefaults";
import { List$1 } from "igniteui-angular-core";
import { CT_ColorSchemeAndMapping } from "./CT_ColorSchemeAndMapping";
import { CT_CustomColor } from "./CT_CustomColor";
import { CT_OfficeArtExtensionList } from "./CT_OfficeArtExtensionList";
import { XmlPartManagerBase } from "./XmlPartManagerBase";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_OfficeStyleSheet extends Base implements ISupportSetProperty {
    static $t: Type;
    private b;
    private d;
    private j;
    private h;
    private f;
    private l;
    constructor();
    get a(): CT_BaseStyles;
    set a(a: CT_BaseStyles);
    get c(): CT_ObjectStyleDefaults;
    set c(a: CT_ObjectStyleDefaults);
    get i(): List$1<CT_ColorSchemeAndMapping>;
    set i(a: List$1<CT_ColorSchemeAndMapping>);
    get g(): List$1<CT_CustomColor>;
    set g(a: List$1<CT_CustomColor>);
    get e(): CT_OfficeArtExtensionList;
    set e(a: CT_OfficeArtExtensionList);
    get k(): string;
    set k(a: string);
    static n(a: XmlPartManagerBase, b: string): {
        p1: string;
    };
    static o(a: XmlPartManagerBase, b: string, c?: string): void;
    toString(): string;
    setProperty(a: ElementPropertyIds, b: any): void;
}
