import { Type } from "igniteui-angular-core";
/**
 * Constants which identify the threshold of a [[ColorScaleCriterion]].
 */
export declare enum ColorScaleCriterionThreshold {
    /**
     * Identifies the minimum threshold.
     */
    Minimum = 0,
    /**
     * Identifies the midpoint threshold.
     */
    Midpoint = 1,
    /**
     * Identifies the maximum threshold.
     */
    Maximum = 2
}
/**
 * @hidden
 */
export declare let ColorScaleCriterionThreshold_$type: Type;
