import { Base, Nullable$1, Type } from "igniteui-angular-core";
import { FormatConditionType } from "./FormatConditionType";
import { CfType } from "./CfType";
import { CfTemplate } from "./CfTemplate";
import { ConditionBase } from "./ConditionBase";
import { CondFmtWrapper } from "./CondFmtWrapper";
import { CfWrapper } from "./CfWrapper";
import { Worksheet } from "./Worksheet";
import { SingleTargetFormula } from "./SingleTargetFormula";
import { Formula } from "./Formula";
import { DataBarConditionalFormat } from "./DataBarConditionalFormat";
import { ColorScaleConditionalFormat } from "./ColorScaleConditionalFormat";
import { IconSetConditionalFormat } from "./IconSetConditionalFormat";
import { CfIconSet } from "./CfIconSet";
import { FormatConditionAboveBelow } from "./FormatConditionAboveBelow";
import { FormatConditionOperator } from "./FormatConditionOperator";
import { CfOperator } from "./CfOperator";
import { FormatConditionTextOperator } from "./FormatConditionTextOperator";
import { CfTextOperator } from "./CfTextOperator";
import { FormatConditionTimePeriod } from "./FormatConditionTimePeriod";
import { CfDateOperator } from "./CfDateOperator";
import { FormatConditionValueType } from "./FormatConditionValueType";
import { CfValueType } from "./CfValueType";
import { FormatConditionIconSet } from "./FormatConditionIconSet";
import { ConditionValue } from "./ConditionValue";
import { CfVo } from "./CfVo";
import { ColorScaleCriterion } from "./ColorScaleCriterion";
import { WorkbookColorInfo } from "./WorkbookColorInfo";
import { IconSetCriterionCollection } from "./IconSetCriterionCollection";
import { CfIconCriterion } from "./CfIconCriterion";
import { IconCriterion } from "./IconCriterion";
import { IconSet } from "./IconSet";
/**
 * @hidden
 */
export declare class ConditionFactory_BIFF8 extends Base {
    static $t: Type;
    static i(a: CfType, b: Nullable$1<CfTemplate>): FormatConditionType;
    static d(a: FormatConditionType, b: CondFmtWrapper, c: CfWrapper, d: Worksheet): ConditionBase;
    private static a;
    private static o;
    private static n;
    private static j;
    private static p;
    private static f;
    private static e;
    private static c;
    private static k;
    private static b;
    private static l;
    private static h;
    private static m;
    private static q;
    private static g;
    private static s;
    private static t;
    static r(a: Formula, b: SingleTargetFormula, c?: boolean): {
        p1: SingleTargetFormula;
    };
}
/**
 * @hidden
 */
export declare class Extensions_BIFF8 extends Base {
    static $t: Type;
    static e(a: CfType): FormatConditionType;
    static a(a: CfTemplate, b: boolean): FormatConditionAboveBelow;
    static b(a: CfOperator): FormatConditionOperator;
    static i(a: FormatConditionOperator): CfOperator;
    static c(a: CfTextOperator): FormatConditionTextOperator;
    static d(a: CfWrapper): FormatConditionTimePeriod;
    static f(a: CfValueType): FormatConditionValueType;
    static g(a: CfIconSet): FormatConditionIconSet;
    static r(a: ConditionValue, b: CfVo): void;
    static n(a: ConditionValue): CfVo;
    static q(a: ColorScaleCriterion, b: CfVo, c: WorkbookColorInfo): void;
    static u(a: ColorScaleConditionalFormat, b: CfWrapper): void;
    static v(a: DataBarConditionalFormat, b: CfWrapper): void;
    static w(a: IconSetConditionalFormat, b: CfWrapper): void;
    private static x;
    static t(a: IconSetCriterionCollection, b: CfIconCriterion[]): void;
    static s(a: IconCriterion, b: CfIconCriterion): void;
    static l(a: ConditionBase): CfType;
    static j(a: ConditionBase): CfTemplate;
    static m(a: FormatConditionValueType): CfValueType;
    static p(a: FormatConditionAboveBelow): boolean;
    static k(a: FormatConditionTextOperator): CfTextOperator;
    static h(a: FormatConditionTimePeriod): CfDateOperator;
    static o(a: FormatConditionIconSet): IconSet;
}
