import { Base, Type } from "igniteui-angular-core";
import { XmlPartManagerBase } from "./XmlPartManagerBase";
import { CT_SolidFillProperties } from "./CT_SolidFillProperties";
import { CT_PresetGeometry2D } from "./CT_PresetGeometry2D";
import { ColorTransform_Alpha } from "./ColorTransform_Alpha";
import { ColorTransform_AlphaMod } from "./ColorTransform_AlphaMod";
import { ColorTransform_AlphaOff } from "./ColorTransform_AlphaOff";
import { CT_BlipFillProperties } from "./CT_BlipFillProperties";
import { CT_Picture } from "./CT_Picture";
import { ColorTransform_Blue } from "./ColorTransform_Blue";
import { ColorTransform_BlueMod } from "./ColorTransform_BlueMod";
import { ColorTransform_BlueOff } from "./ColorTransform_BlueOff";
import { Tuple$2 } from "igniteui-angular-core";
import { CT_Connector } from "./CT_Connector";
import { ColorTransform_Comp } from "./ColorTransform_Comp";
import { CT_StretchInfoProperties } from "./CT_StretchInfoProperties";
import { CT_RegularTextRun } from "./CT_RegularTextRun";
import { CT_GraphicalObjectFrame } from "./CT_GraphicalObjectFrame";
import { CT_GraphicalObject } from "./CT_GraphicalObject";
import { ColorTransform_Gray } from "./ColorTransform_Gray";
import { ColorTransform_Green } from "./ColorTransform_Green";
import { ColorTransform_GreenMod } from "./ColorTransform_GreenMod";
import { ColorTransform_GreenOff } from "./ColorTransform_GreenOff";
import { CT_GroupFillProperties } from "./CT_GroupFillProperties";
import { CT_GroupShape } from "./CT_GroupShape";
import { ColorTransform_Hue } from "./ColorTransform_Hue";
import { ColorTransform_HueMod } from "./ColorTransform_HueMod";
import { ColorTransform_HueOff } from "./ColorTransform_HueOff";
import { ColorTransform_Inv } from "./ColorTransform_Inv";
import { ColorTransform_Lum } from "./ColorTransform_Lum";
import { ColorTransform_LumMod } from "./ColorTransform_LumMod";
import { ColorTransform_LumOff } from "./ColorTransform_LumOff";
import { CT_NoFillProperties } from "./CT_NoFillProperties";
import { CT_Shape } from "./CT_Shape";
import { CT_PresetColor_Core } from "./CT_PresetColor_Core";
import { ColorTransform_Red } from "./ColorTransform_Red";
import { ColorTransform_RedMod } from "./ColorTransform_RedMod";
import { ColorTransform_RedOff } from "./ColorTransform_RedOff";
import { ColorTransform_Sat } from "./ColorTransform_Sat";
import { ColorTransform_SatMod } from "./ColorTransform_SatMod";
import { ColorTransform_SatOff } from "./ColorTransform_SatOff";
import { CT_SchemeColor } from "./CT_SchemeColor";
import { ColorTransform_Shade } from "./ColorTransform_Shade";
import { CT_SRgbColor } from "./CT_SRgbColor";
import { CT_SysColor } from "./CT_SysColor";
import { ColorTransform_Tint } from "./ColorTransform_Tint";
import { AlternateGraphicalObjectContent } from "./AlternateGraphicalObjectContent";
import { IGraphicalObjectContent } from "./IGraphicalObjectContent";
import { CT_CustomGeometry2D } from "./CT_CustomGeometry2D";
import { IEG_ColorChoiceVisitor$2 } from "./IEG_ColorChoiceVisitor$2";
import { IEG_ColorTransformVisitor$2 } from "./IEG_ColorTransformVisitor$2";
import { IEG_FillModePropertiesVisitor$2 } from "./IEG_FillModePropertiesVisitor$2";
import { IEG_FillPropertiesVisitor$2 } from "./IEG_FillPropertiesVisitor$2";
import { IEG_GeometryVisitor$2 } from "./IEG_GeometryVisitor$2";
import { IEG_LineDashPropertiesVisitor$2 } from "./IEG_LineDashPropertiesVisitor$2";
import { IEG_LineFillPropertiesVisitor$2 } from "./IEG_LineFillPropertiesVisitor$2";
import { IEG_LineJoinPropertiesVisitor$2 } from "./IEG_LineJoinPropertiesVisitor$2";
import { IEG_TextRunVisitor$2 } from "./IEG_TextRunVisitor$2";
import { IGraphicalObjectContentVisitor$2 } from "./IGraphicalObjectContentVisitor$2";
import { CT_TileInfoProperties } from "./CT_TileInfoProperties";
import { CT_DashStopList } from "./CT_DashStopList";
import { CT_PresetLineDashProperties } from "./CT_PresetLineDashProperties";
import { CT_LineJoinBevel } from "./CT_LineJoinBevel";
import { CT_LineJoinMiterProperties } from "./CT_LineJoinMiterProperties";
import { CT_LineJoinRound } from "./CT_LineJoinRound";
/**
 * @hidden
 */
export declare class DrawingPartManagerHelpers extends Base {
    static $t: Type;
    private static a;
    private static b;
    private static c;
    private static g;
    private static d;
    private static e;
    private static f;
    private static h;
    private static i;
    private static r;
    private static s;
    private static t;
    private static j;
    private static k;
    private static l;
    private static m;
    private static n;
    private static o;
    private static p;
    private static q;
    private static u;
    private static v;
    private static w;
    private static x;
    private static y;
    private static z;
    private static ac;
    private static aa;
    private static ab;
    private static ad;
    private static af;
    private static ag;
    private static ah;
    private static ai;
    private static aj;
    private static ak;
    private static al;
    private static am;
    private static an;
    private static ao;
    private static aq;
    private static ap;
    private static ar;
    private static as;
    private static at;
    private static au;
    private static av;
    private static aw;
    private static ax;
    private static ay;
    private static az;
    private static a0;
    private static a1;
    private static a2;
    private static a3;
    private static a4;
    private static a5;
    private static a6;
    private static a7;
    private static a8;
    private static a9;
    private static bd;
    private static ae;
    private static ba;
    private static bb;
    private static bc;
    private static be;
    private static bf;
    private static bg;
    private static bh;
    private static bi;
    private static bj;
    private static bk;
    private static bl;
    private static bm;
    private static bn;
    private static bo;
    private static bp;
    private static bq;
    private static br;
    private static bs;
    private static bt;
    private static bu;
    private static bv;
    private static bw;
    private static bx;
    private static by;
    private static bz;
    private static b0;
    private static b1;
    private static b2;
    private static b3;
    private static b4;
    private static b5;
    private static b6;
    private static b7;
    private static b8;
    private static b9;
    private static ca;
    private static cb;
    private static cc;
    private static cd;
    private static ce;
    private static cf;
    private static cg;
    static ch(a: XmlPartManagerBase): void;
    static ci(a: XmlPartManagerBase, b: ColorTransform_Alpha): void;
    static cj(a: XmlPartManagerBase, b: ColorTransform_AlphaMod): void;
    static ck(a: XmlPartManagerBase, b: ColorTransform_AlphaOff): void;
    static cl(a: XmlPartManagerBase, b: AlternateGraphicalObjectContent): void;
    private static cm;
    private static cn;
    static co(a: XmlPartManagerBase, b: CT_BlipFillProperties, c?: boolean): void;
    static cp(a: XmlPartManagerBase, b: ColorTransform_Blue): void;
    static cq(a: XmlPartManagerBase, b: ColorTransform_BlueMod): void;
    static cr(a: XmlPartManagerBase, b: ColorTransform_BlueOff): void;
    private static cs;
    private static ct;
    private static cu;
    private static cv;
    private static cw;
    private static cx;
    private static cy;
    private static cz;
    private static c0;
    static c1(a: XmlPartManagerBase, b: ColorTransform_Comp): void;
    private static c2;
    private static c3;
    private static c4;
    static c5(a: XmlPartManagerBase, b: CT_CustomGeometry2D): void;
    static c6(a: XmlPartManagerBase, b: CT_Connector): void;
    private static c7;
    private static c8;
    private static c9;
    private static da;
    private static db;
    private static dc;
    private static dd;
    private static de;
    private static df;
    static dh(a: XmlPartManagerBase, b: Tuple$2<string, any>): void;
    private static di;
    static dj(a: XmlPartManagerBase, b: CT_GraphicalObject): void;
    static dk(a: XmlPartManagerBase, b: CT_GraphicalObjectFrame): void;
    private static dl;
    static dm(a: XmlPartManagerBase, b: ColorTransform_Gray): void;
    static dn(a: XmlPartManagerBase, b: ColorTransform_Green): void;
    static dp(a: XmlPartManagerBase, b: ColorTransform_GreenMod): void;
    static dq(a: XmlPartManagerBase, b: ColorTransform_GreenOff): void;
    static dr(a: XmlPartManagerBase, b: CT_GroupShape): void;
    private static ds;
    private static dt;
    private static du;
    static dv(a: XmlPartManagerBase, b: ColorTransform_Hue): void;
    static dw(a: XmlPartManagerBase, b: ColorTransform_HueMod): void;
    static dx(a: XmlPartManagerBase, b: ColorTransform_HueOff): void;
    static dy(a: XmlPartManagerBase, b: ColorTransform_Inv): void;
    private static dz;
    private static d0;
    private static d1;
    static d2(a: XmlPartManagerBase, b: ColorTransform_Lum): void;
    static d3(a: XmlPartManagerBase, b: ColorTransform_LumMod): void;
    static d4(a: XmlPartManagerBase, b: ColorTransform_LumOff): void;
    static d5(a: XmlPartManagerBase, b: CT_NoFillProperties): void;
    private static d6;
    private static d7;
    private static d8;
    private static d9;
    private static ea;
    private static eb;
    private static ec;
    static ed(a: XmlPartManagerBase, b: CT_Picture): void;
    private static ee;
    private static ef;
    static eg(a: XmlPartManagerBase, b: CT_PresetColor_Core): void;
    static eh(a: XmlPartManagerBase, b: CT_PresetGeometry2D): void;
    static ei(a: XmlPartManagerBase, b: ColorTransform_Red): void;
    static ej(a: XmlPartManagerBase, b: ColorTransform_RedMod): void;
    static ek(a: XmlPartManagerBase, b: ColorTransform_RedOff): void;
    static el(a: XmlPartManagerBase, b: CT_RegularTextRun): void;
    private static em;
    static en(a: XmlPartManagerBase, b: ColorTransform_Sat): void;
    static eo(a: XmlPartManagerBase, b: ColorTransform_SatMod): void;
    static ep(a: XmlPartManagerBase, b: ColorTransform_SatOff): void;
    static eq(a: XmlPartManagerBase, b: CT_SchemeColor): void;
    static dg(a: XmlPartManagerBase, b: IGraphicalObjectContent): void;
    static es(a: XmlPartManagerBase, b: CT_SolidFillProperties): void;
    static et(a: XmlPartManagerBase, b: CT_Shape): void;
    private static eu;
    private static ev;
    private static ew;
    static er(a: XmlPartManagerBase, b: ColorTransform_Shade): void;
    static ex(a: XmlPartManagerBase, b: CT_SRgbColor): void;
    private static ey;
    static ez(a: XmlPartManagerBase, b: CT_StretchInfoProperties): void;
    private static e0;
    static e1(a: XmlPartManagerBase, b: CT_SysColor): void;
    private static e2;
    static e3(a: XmlPartManagerBase, b: ColorTransform_Tint): void;
    private static e4;
    private static e6;
    private static e5;
}
/**
 * @hidden
 */
export declare class DrawingPartManagerHelpers_DrawingSerializationHelper extends Base implements IEG_ColorChoiceVisitor$2<XmlPartManagerBase, boolean>, IEG_ColorTransformVisitor$2<XmlPartManagerBase, boolean>, IEG_FillModePropertiesVisitor$2<XmlPartManagerBase, boolean>, IEG_FillPropertiesVisitor$2<XmlPartManagerBase, boolean>, IEG_GeometryVisitor$2<XmlPartManagerBase, boolean>, IEG_LineDashPropertiesVisitor$2<XmlPartManagerBase, boolean>, IEG_LineFillPropertiesVisitor$2<XmlPartManagerBase, boolean>, IEG_LineJoinPropertiesVisitor$2<XmlPartManagerBase, boolean>, IEG_TextRunVisitor$2<XmlPartManagerBase, boolean>, IGraphicalObjectContentVisitor$2<XmlPartManagerBase, boolean> {
    static $t: Type;
    static readonly a: DrawingPartManagerHelpers_DrawingSerializationHelper;
    constructor();
    _visitCT_SchemeColor$i(a: CT_SchemeColor, b: XmlPartManagerBase): boolean;
    _visitCT_SRgbColor$i(a: CT_SRgbColor, b: XmlPartManagerBase): boolean;
    _visitCT_SysColor$i(a: CT_SysColor, b: XmlPartManagerBase): boolean;
    _visitCT_PresetColor$i(a: CT_PresetColor_Core, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Alpha$i(a: ColorTransform_Alpha, b: XmlPartManagerBase): boolean;
    _visitColorTransform_AlphaMod$i(a: ColorTransform_AlphaMod, b: XmlPartManagerBase): boolean;
    _visitColorTransform_AlphaOff$i(a: ColorTransform_AlphaOff, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Blue$i(a: ColorTransform_Blue, b: XmlPartManagerBase): boolean;
    _visitColorTransform_BlueMod$i(a: ColorTransform_BlueMod, b: XmlPartManagerBase): boolean;
    _visitColorTransform_BlueOff$i(a: ColorTransform_BlueOff, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Comp$i(a: ColorTransform_Comp, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Gray$i(a: ColorTransform_Gray, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Green$i(a: ColorTransform_Green, b: XmlPartManagerBase): boolean;
    _visitColorTransform_GreenMod$i(a: ColorTransform_GreenMod, b: XmlPartManagerBase): boolean;
    _visitColorTransform_GreenOff$i(a: ColorTransform_GreenOff, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Hue$i(a: ColorTransform_Hue, b: XmlPartManagerBase): boolean;
    _visitColorTransform_HueMod$i(a: ColorTransform_HueMod, b: XmlPartManagerBase): boolean;
    _visitColorTransform_HueOff$i(a: ColorTransform_HueOff, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Inv$i(a: ColorTransform_Inv, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Lum$i(a: ColorTransform_Lum, b: XmlPartManagerBase): boolean;
    _visitColorTransform_LumMod$i(a: ColorTransform_LumMod, b: XmlPartManagerBase): boolean;
    _visitColorTransform_LumOff$i(a: ColorTransform_LumOff, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Red$i(a: ColorTransform_Red, b: XmlPartManagerBase): boolean;
    _visitColorTransform_RedMod$i(a: ColorTransform_RedMod, b: XmlPartManagerBase): boolean;
    _visitColorTransform_RedOff$i(a: ColorTransform_RedOff, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Sat$i(a: ColorTransform_Sat, b: XmlPartManagerBase): boolean;
    _visitColorTransform_SatMod$i(a: ColorTransform_SatMod, b: XmlPartManagerBase): boolean;
    _visitColorTransform_SatOff$i(a: ColorTransform_SatOff, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Shade$i(a: ColorTransform_Shade, b: XmlPartManagerBase): boolean;
    _visitColorTransform_Tint$i(a: ColorTransform_Tint, b: XmlPartManagerBase): boolean;
    _visitCT_StretchInfoProperties$i(a: CT_StretchInfoProperties, b: XmlPartManagerBase): boolean;
    _visitCT_TileInfoProperties$i(a: CT_TileInfoProperties, b: XmlPartManagerBase): boolean;
    _visitCT_BlipFillProperties$i(a: CT_BlipFillProperties, b: XmlPartManagerBase): boolean;
    _visitCT_GroupFillProperties$i(a: CT_GroupFillProperties, b: XmlPartManagerBase): boolean;
    _visitCT_NoFillProperties$i(a: CT_NoFillProperties, b: XmlPartManagerBase): boolean;
    _visitCT_SolidFillProperties$i(a: CT_SolidFillProperties, b: XmlPartManagerBase): boolean;
    _visitCT_PresetGeometry2D$i(a: CT_PresetGeometry2D, b: XmlPartManagerBase): boolean;
    _visitCT_CustomGeometry2D$i(a: CT_CustomGeometry2D, b: XmlPartManagerBase): boolean;
    _visitCT_DashStopList$i(a: CT_DashStopList, b: XmlPartManagerBase): boolean;
    _visitCT_PresetLineDashProperties$i(a: CT_PresetLineDashProperties, b: XmlPartManagerBase): boolean;
    _visitCT_NoFillProperties1$i(a: CT_NoFillProperties, b: XmlPartManagerBase): boolean;
    _visitCT_SolidFillProperties1$i(a: CT_SolidFillProperties, b: XmlPartManagerBase): boolean;
    _visitCT_LineJoinBevel$i(a: CT_LineJoinBevel, b: XmlPartManagerBase): boolean;
    _visitCT_LineJoinMiterProperties$i(a: CT_LineJoinMiterProperties, b: XmlPartManagerBase): boolean;
    _visitCT_LineJoinRound$i(a: CT_LineJoinRound, b: XmlPartManagerBase): boolean;
    _visitCT_RegularTextRun$i(a: CT_RegularTextRun, b: XmlPartManagerBase): boolean;
    _visitAlternateGraphicalObjectContent$i(a: AlternateGraphicalObjectContent, b: XmlPartManagerBase): boolean;
    _visitCT_Connector$i(a: CT_Connector, b: XmlPartManagerBase): boolean;
    _visitCT_GraphicalObjectFrame$i(a: CT_GraphicalObjectFrame, b: XmlPartManagerBase): boolean;
    _visitCT_GroupShape$i(a: CT_GroupShape, b: XmlPartManagerBase): boolean;
    _visitCT_Picture$i(a: CT_Picture, b: XmlPartManagerBase): boolean;
    _visitCT_Shape$i(a: CT_Shape, b: XmlPartManagerBase): boolean;
}
