import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum EscherSysIndex {
    SystemColorButtonFace = 0,
    SystemColorWindowText = 1,
    SystemColorMenu = 2,
    SystemColorHighlight = 3,
    SystemColorHighlightText = 4,
    SystemColorCaptionText = 5,
    SystemColorActiveCaption = 6,
    SystemColorButtonHighlight = 7,
    SystemColorButtonShadow = 8,
    SystemColorButtonText = 9,
    SystemColorGrayText = 10,
    SystemColorInactiveCaption = 11,
    SystemColorInactiveCaptionText = 12,
    SystemColorInfoBackground = 13,
    SystemColorInfoText = 14,
    SystemColorMenuText = 15,
    SystemColorScrollbar = 16,
    SystemColorWindow = 17,
    SystemColorWindowFrame = 18,
    SystemColor3DLight = 19,
    SystemColorMax = 20,
    FillColor = 240,
    LineOrFillColor = 241,
    LineColor = 242,
    ShadowColor = 243,
    This = 244,
    FillBackColor = 245,
    LineBackColor = 246,
    FillThenLine = 247,
    IndexMask = 255,
    ProcessMask = 16776960,
    ModificationMask = 3840,
    ModFlagMask = 61440,
    Darken = 256,
    Lighten = 512,
    Add = 768,
    Subtract = 1024,
    ReverseSubtract = 1280,
    BlackWhite = 1536,
    Invert = 8192,
    Invert128 = 16384,
    Gray = 32768,
    BParamMask = 16711680,
    BParamShift = 16
}
/**
 * @hidden
 */
export declare let EscherSysIndex_$type: Type;
