import { Type } from "igniteui-angular-core";
/**
 * Constants which identify a set of icons for an [[IconSetConditionalFormat]].
 */
export declare enum FormatConditionIconSet {
    /**
     * No icon is shown.
     */
    IconSetNoIcon = -1,
    /**
     * Microsoft.Office.Interop.Excel.xl3Arrows = 1
     */
    IconSet3Arrows = 1,
    /**
     * Microsoft.Office.Interop.Excel.xl3ArrowsGray = 2
     */
    IconSet3ArrowsGray = 2,
    /**
     * Microsoft.Office.Interop.Excel.xl3Flags = 3
     */
    IconSet3Flags = 3,
    /**
     * Microsoft.Office.Interop.Excel.xl3TrafficLights1 = 4
     */
    IconSet3TrafficLights1 = 4,
    /**
     * Microsoft.Office.Interop.Excel.xl3TrafficLights2 = 5
     */
    IconSet3TrafficLights2 = 5,
    /**
     * Microsoft.Office.Interop.Excel.xl3Signs = 6
     */
    IconSet3Signs = 6,
    /**
     * Microsoft.Office.Interop.Excel.xl3Symbols = 7
     */
    IconSet3Symbols = 7,
    /**
     * Microsoft.Office.Interop.Excel.xl3Symbols2 = 8
     */
    IconSet3Symbols2 = 8,
    /**
     * Microsoft.Office.Interop.Excel.xl4Arrows = 9
     */
    IconSet4Arrows = 9,
    /**
     * Microsoft.Office.Interop.Excel.xl4ArrowsGray = 10
     */
    IconSet4ArrowsGray = 10,
    /**
     * Microsoft.Office.Interop.Excel.xl4RedToBlack = 11
     */
    IconSet4RedToBlack = 11,
    /**
     * Microsoft.Office.Interop.Excel.xl4CRV = 12
     */
    IconSet4Rating = 12,
    /**
     * Microsoft.Office.Interop.Excel.xl4TrafficLights = 13
     */
    IconSet4TrafficLights = 13,
    /**
     * Microsoft.Office.Interop.Excel.xl5Arrows = 14
     */
    IconSet5Arrows = 14,
    /**
     * Microsoft.Office.Interop.Excel.xl5ArrowsGray = 15
     */
    IconSet5ArrowsGray = 15,
    /**
     * Microsoft.Office.Interop.Excel.xl5CRV = 16
     */
    IconSet5Rating = 16,
    /**
     * Microsoft.Office.Interop.Excel.xl5Quarters = 17
     */
    IconSet5Quarters = 17,
    /**
     * Microsoft.Office.Interop.Excel.xl3Stars = 18
     */
    IconSet3Stars = 18,
    /**
     * Microsoft.Office.Interop.Excel.xl3Triangles = 19
     */
    IconSet3Triangles = 19,
    /**
     * Microsoft.Office.Interop.Excel.xl5Boxes = 20
     */
    IconSet5Boxes = 20
}
/**
 * @hidden
 */
export declare let FormatConditionIconSet_$type: Type;
