import { Type, Base, Nullable$1 } from "igniteui-angular-core";
import { CT_RelativeRect } from "./CT_RelativeRect";
import { ST_RectAlignment } from "./ST_RectAlignment";
import { ST_TileFlipMode } from "./ST_TileFlipMode";
import { ST_Percentage } from "./ST_Percentage";
import { ST_Coordinate } from "./ST_Coordinate";
/**
 * @hidden
 */
export interface IEG_FillModeProperties {
    _accept$2$i<TArg, TResult>($tArg: Type, $tResult: Type, a: IEG_FillModePropertiesVisitor$2<TArg, TResult>, b: TArg): TResult;
}
/**
 * @hidden
 */
export declare let IEG_FillModeProperties_$type: Type;
/**
 * @hidden
 */
export declare class CT_StretchInfoProperties extends Base implements IEG_FillModeProperties {
    static $t: Type;
    a: CT_RelativeRect;
    _accept$2$i<TArg, TResult>($tArg: Type, $tResult: Type, a: IEG_FillModePropertiesVisitor$2<TArg, TResult>, b: TArg): TResult;
}
/**
 * @hidden
 */
export declare class CT_TileInfoProperties extends Base implements IEG_FillModeProperties {
    static $t: Type;
    a: Nullable$1<ST_RectAlignment>;
    b: Nullable$1<ST_TileFlipMode>;
    c: Nullable$1<ST_Percentage>;
    d: Nullable$1<ST_Percentage>;
    e: Nullable$1<ST_Coordinate>;
    f: Nullable$1<ST_Coordinate>;
    _accept$2$i<TArg, TResult>($tArg: Type, $tResult: Type, a: IEG_FillModePropertiesVisitor$2<TArg, TResult>, b: TArg): TResult;
}
/**
 * @hidden
 */
export interface IEG_FillModePropertiesVisitor$2<TArg, TResult> {
    _visitCT_StretchInfoProperties$i(a: CT_StretchInfoProperties, b: TArg): TResult;
    _visitCT_TileInfoProperties$i(a: CT_TileInfoProperties, b: TArg): TResult;
}
/**
 * @hidden
 */
export declare let IEG_FillModePropertiesVisitor$2_$type: Type;
