import { Type, Base, Nullable$1 } from "igniteui-angular-core";
import { ST_PositivePercentage } from "./ST_PositivePercentage";
/**
 * @hidden
 */
export interface IEG_LineJoinProperties {
    _accept$2$i<TArg, TResult>($tArg: Type, $tResult: Type, a: IEG_LineJoinPropertiesVisitor$2<TArg, TResult>, b: TArg): TResult;
}
/**
 * @hidden
 */
export declare let IEG_LineJoinProperties_$type: Type;
/**
 * @hidden
 */
export declare class CT_LineJoinBevel extends Base implements IEG_LineJoinProperties {
    static $t: Type;
    _accept$2$i<TArg, TResult>($tArg: Type, $tResult: Type, a: IEG_LineJoinPropertiesVisitor$2<TArg, TResult>, b: TArg): TResult;
}
/**
 * @hidden
 */
export declare class CT_LineJoinMiterProperties extends Base implements IEG_LineJoinProperties {
    static $t: Type;
    a: Nullable$1<ST_PositivePercentage>;
    _accept$2$i<TArg, TResult>($tArg: Type, $tResult: Type, a: IEG_LineJoinPropertiesVisitor$2<TArg, TResult>, b: TArg): TResult;
}
/**
 * @hidden
 */
export declare class CT_LineJoinRound extends Base implements IEG_LineJoinProperties {
    static $t: Type;
    _accept$2$i<TArg, TResult>($tArg: Type, $tResult: Type, a: IEG_LineJoinPropertiesVisitor$2<TArg, TResult>, b: TArg): TResult;
}
/**
 * @hidden
 */
export interface IEG_LineJoinPropertiesVisitor$2<TArg, TResult> {
    _visitCT_LineJoinBevel$i(a: CT_LineJoinBevel, b: TArg): TResult;
    _visitCT_LineJoinMiterProperties$i(a: CT_LineJoinMiterProperties, b: TArg): TResult;
    _visitCT_LineJoinRound$i(a: CT_LineJoinRound, b: TArg): TResult;
}
/**
 * @hidden
 */
export declare let IEG_LineJoinPropertiesVisitor$2_$type: Type;
