import { SystemException, BaseError, Type } from "igniteui-angular-core";
/**
 * Represents an error in which a keyed collection was accessed with a key which does not exist in the collection.
 */
export declare class KeyNotFoundException extends SystemException {
    static $t: Type;
    constructor(message: string, innerException: BaseError);
}
