import { Type } from "igniteui-angular-core";
/**
 * Represents the various way objects and shapes are displayed in the workbook.
 */
export declare enum ObjectDisplayStyle {
    /**
     * All object are be shown.
     */
    ShowAll = 0,
    /**
     * Placeholders are shown in place of objects.
     */
    ShowPlaceholders = 1,
    /**
     * No objects or shapes are shown.
     */
    HideAll = 2
}
/**
 * @hidden
 */
export declare let ObjectDisplayStyle_$type: Type;
