import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum SummaryPropertyType {
    Title = 2,
    Subject = 3,
    Author = 4,
    Keywords = 5,
    Comments = 6,
    Template = 7,
    LastSavedBy = 8,
    RevisionNumber = 9,
    TotalEditingTime = 10,
    LastPrinted = 11,
    CreatedDateTime = 12,
    LastSavedDateTime = 13,
    NumberOfPages = 14,
    NumberOfWords = 15,
    NumberOfCharacters = 16,
    Thumbnail = 17,
    NameOfCreatingApplication = 18,
    Security = 19
}
/**
 * @hidden
 */
export declare let SummaryPropertyType_$type: Type;
