import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcNumberStack } from "./ExcelCalcNumberStack";
import { Type } from "igniteui-angular-core";
import { FirstWeekOfYear } from "./FirstWeekOfYear";
import { CalendarWeekRule, CultureInfo } from "igniteui-angular-core";
import { DateInterval } from "./DateInterval";
/**
 * @hidden
 */
export declare class UltraCalcFunctionDateDiff extends BuiltInFunctionBase {
    static $t: Type;
    protected evaluate(a: ExcelCalcNumberStack, b: number): ExcelCalcValue;
    private static _al;
    protected get_name(): string;
    get name(): string;
    protected get_minArgs(): number;
    get minArgs(): number;
    protected get_maxArgs(): number;
    get maxArgs(): number;
    static _ak(a: CalendarWeekRule): FirstWeekOfYear;
    static _an(a: CultureInfo, b: string, c: Date, d: Date): number;
    static _am(a: CultureInfo, b: DateInterval, c: Date, d: Date): number;
}
