import { Type } from "igniteui-angular-core";
/**
 * Represents the various encryption modes that can be used to encrypt documents saved in the 2007 file formats and later.
 */
export declare enum WorkbookEncryptionMode {
    /**
     * Standard encryption used in Excel 2007 and later
     */
    Standard = 0,
    /**
     * Agile encryption used in Excel 2010 and later
     */
    Agile = 1
}
/**
 * @hidden
 */
export declare let WorkbookEncryptionMode_$type: Type;
