import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum WorksheetTable_TableFlags {
    DisplayBandedColumns = 1,
    DisplayBandedRows = 2,
    DisplayFirstColumnFormatting = 4,
    DisplayLastColumnFormatting = 8,
    HasTotalsRowEverBeenVisible = 16,
    IsFilterUIVisible = 32,
    IsHeaderRowVisible = 64,
    IsInsertRowVisible = 128,
    IsResizing = 256,
    IsTotalsRowVisible = 512,
    PreventAssigningUniqueColumnNames = 1024,
    Published = 2048,
    RefilterRequired = 4096,
    SuspendAreaFormatSynchronization = 8192,
    WereCellsShiftedToShowInsertRow = 16384,
    IsChangingHeaderOrTotalRowVisibility = 32768,
    IsProcessingUndo = 65536
}
/**
 * @hidden
 */
export declare let WorksheetTable_TableFlags_$type: Type;
